module CBopControlPanel
    use CBopControlPanelVariables
    implicit none    
    public    
    contains
    
    ! Input routines
    subroutine SetAnnularRegulatorSetControl(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetAnnularRegulatorSetControl
    !DEC$ ATTRIBUTES ALIAS: 'SetAnnularRegulatorSetControl' :: SetAnnularRegulatorSetControl
	    implicit none
	    real*8, intent(in) :: v
	    AnnularRegulatorSetControl = v
#ifdef deb
        print*, 'AnnularRegulatorSetControl=', AnnularRegulatorSetControl
#endif
    end subroutine

    subroutine SetAirMasterValve(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetAirMasterValve
    !DEC$ ATTRIBUTES ALIAS: 'SetAirMasterValve' :: SetAirMasterValve
	    implicit none
	    real*8, intent(in) :: v
	    AirMasterValve = v
#ifdef deb
        print*, 'AirMasterValve=', AirMasterValve
#endif
    end subroutine

    subroutine SetByePassValve(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetByePassValve
    !DEC$ ATTRIBUTES ALIAS: 'SetByePassValve' :: SetByePassValve
	    implicit none
	    real*8, intent(in) :: v
	    ByePassValve = v
#ifdef deb
        print*, 'ByePassValve=', ByePassValve
#endif
    end subroutine

    subroutine SetAnnularValve(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetAnnularValve
    !DEC$ ATTRIBUTES ALIAS: 'SetAnnularValve' :: SetAnnularValve
	    implicit none
	    real*8, intent(in) :: v
	    AnnularValve = v
#ifdef deb
        print*, 'AnnularValve=', AnnularValve
#endif
    end subroutine

    subroutine SetUpperRamsValve(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetUpperRamsValve
    !DEC$ ATTRIBUTES ALIAS: 'SetUpperRamsValve' :: SetUpperRamsValve
	    implicit none
	    real*8, intent(in) :: v
	    UpperRamsValve = v
#ifdef deb
        print*, 'UpperRamsValve=', UpperRamsValve
#endif
    end subroutine

    subroutine SetMiddleRamsValve(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetMiddleRamsValve
    !DEC$ ATTRIBUTES ALIAS: 'SetMiddleRamsValve' :: SetMiddleRamsValve
	    implicit none
	    real*8, intent(in) :: v
	    MiddleRamsValve = v
#ifdef deb
        print*, 'MiddleRamsValve=', MiddleRamsValve
#endif
    end subroutine

    subroutine SetKillLineValve(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetKillLineValve
    !DEC$ ATTRIBUTES ALIAS: 'SetKillLineValve' :: SetKillLineValve
	    implicit none
	    real*8, intent(in) :: v
	    KillLineValve = v
#ifdef deb
        print*, 'KillLineValve=', KillLineValve
#endif
    end subroutine

    subroutine SetChokeLineValve(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetChokeLineValve
    !DEC$ ATTRIBUTES ALIAS: 'SetChokeLineValve' :: SetChokeLineValve
	    implicit none
	    real*8, intent(in) :: v
	    ChokeLineValve = v
#ifdef deb
        print*, 'ChokeLineValve=', ChokeLineValve
#endif
    end subroutine

    subroutine SetLowerRamsValve(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetLowerRamsValve
    !DEC$ ATTRIBUTES ALIAS: 'SetLowerRamsValve' :: SetLowerRamsValve
	    implicit none
	    real*8, intent(in) :: v
	    LowerRamsValve = v
#ifdef deb
        print*, 'LowerRamsValve=', LowerRamsValve
#endif
    end subroutine


    ! Output routines
    real(8) function GetManifoldPressureGauge()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetManifoldPressureGauge
    !DEC$ ATTRIBUTES ALIAS: 'GetManifoldPressureGauge' :: GetManifoldPressureGauge
	    implicit none
	    GetManifoldPressureGauge = ManifoldPressureGauge
    end function

    real(8) function GetAirSupplyPressureGauge()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetAirSupplyPressureGauge
    !DEC$ ATTRIBUTES ALIAS: 'GetAirSupplyPressureGauge' :: GetAirSupplyPressureGauge
	    implicit none
	    GetAirSupplyPressureGauge = AirSupplyPressureGauge
    end function

    real(8) function GetAccumulatorPressureGauge()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetAccumulatorPressureGauge
    !DEC$ ATTRIBUTES ALIAS: 'GetAccumulatorPressureGauge' :: GetAccumulatorPressureGauge
	    implicit none
	    GetAccumulatorPressureGauge = AccumulatorPressureGauge
	    !GetAccumulatorPressureGauge = 2000.0d0
    end function

    real(8) function GetAnnularPressureGauge()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetAnnularPressureGauge
    !DEC$ ATTRIBUTES ALIAS: 'GetAnnularPressureGauge' :: GetAnnularPressureGauge
	    implicit none
	    GetAnnularPressureGauge = AnnularPressureGauge
    end function

    integer function GetAnnularOpenLED()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetAnnularOpenLED
    !DEC$ ATTRIBUTES ALIAS: 'GetAnnularOpenLED' :: GetAnnularOpenLED
	    implicit none
	    GetAnnularOpenLED = AnnularOpenLED
    end function

    integer function GetAnnularCloseLED()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetAnnularCloseLED
    !DEC$ ATTRIBUTES ALIAS: 'GetAnnularCloseLED' :: GetAnnularCloseLED
	    implicit none
	    GetAnnularCloseLED = AnnularCloseLED
    end function

    integer function GetUpperRamsOpenLED()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetUpperRamsOpenLED
    !DEC$ ATTRIBUTES ALIAS: 'GetUpperRamsOpenLED' :: GetUpperRamsOpenLED
	    implicit none
	    GetUpperRamsOpenLED = UpperRamsOpenLED
    end function

    integer function GetUpperRamsCloseLED()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetUpperRamsCloseLED
    !DEC$ ATTRIBUTES ALIAS: 'GetUpperRamsCloseLED' :: GetUpperRamsCloseLED
	    implicit none
	    GetUpperRamsCloseLED = UpperRamsCloseLED
    end function

    integer function GetMiddleRamsOpenLED()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetMiddleRamsOpenLED
    !DEC$ ATTRIBUTES ALIAS: 'GetMiddleRamsOpenLED' :: GetMiddleRamsOpenLED
	    implicit none
	    GetMiddleRamsOpenLED = MiddleRamsOpenLED
    end function

    integer function GetMiddleRamsCloseLED()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetMiddleRamsCloseLED
    !DEC$ ATTRIBUTES ALIAS: 'GetMiddleRamsCloseLED' :: GetMiddleRamsCloseLED
	    implicit none
	    GetMiddleRamsCloseLED = MiddleRamsCloseLED
    end function

    integer function GetKillLineOpenLED()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetKillLineOpenLED
    !DEC$ ATTRIBUTES ALIAS: 'GetKillLineOpenLED' :: GetKillLineOpenLED
	    implicit none
	    GetKillLineOpenLED = KillLineOpenLED
    end function

    integer function GetKillLineCloseLED()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetKillLineCloseLED
    !DEC$ ATTRIBUTES ALIAS: 'GetKillLineCloseLED' :: GetKillLineCloseLED
	    implicit none
	    GetKillLineCloseLED = KillLineCloseLED
    end function

    integer function GetChokeLineOpenLED()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetChokeLineOpenLED
    !DEC$ ATTRIBUTES ALIAS: 'GetChokeLineOpenLED' :: GetChokeLineOpenLED
	    implicit none
	    GetChokeLineOpenLED = ChokeLineOpenLED
    end function

    integer function GetChokeLineCloseLED()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetChokeLineCloseLED
    !DEC$ ATTRIBUTES ALIAS: 'GetChokeLineCloseLED' :: GetChokeLineCloseLED
	    implicit none
	    GetChokeLineCloseLED = ChokeLineCloseLED
    end function

    integer function GetLowerRamsOpenLED()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetLowerRamsOpenLED
    !DEC$ ATTRIBUTES ALIAS: 'GetLowerRamsOpenLED' :: GetLowerRamsOpenLED
	    implicit none
	    GetLowerRamsOpenLED = LowerRamsOpenLED
    end function

    integer function GetLowerRamsCloseLED()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetLowerRamsCloseLED
    !DEC$ ATTRIBUTES ALIAS: 'GetLowerRamsCloseLED' :: GetLowerRamsCloseLED
	    implicit none
	    GetLowerRamsCloseLED = LowerRamsCloseLED
    end function

    real(8) function GetAnnularStatus()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetAnnularStatus
    !DEC$ ATTRIBUTES ALIAS: 'GetAnnularStatus' :: GetAnnularStatus
	    implicit none
	    GetAnnularStatus = AnnularStatus
    end function

    real(8) function GetUpperRamsStatus()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetUpperRamsStatus
    !DEC$ ATTRIBUTES ALIAS: 'GetUpperRamsStatus' :: GetUpperRamsStatus
	    implicit none
	    GetUpperRamsStatus = UpperRamsStatus
    end function

    real(8) function GetMiddleRamsStatus()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetMiddleRamsStatus
    !DEC$ ATTRIBUTES ALIAS: 'GetMiddleRamsStatus' :: GetMiddleRamsStatus
	    implicit none
	    GetMiddleRamsStatus = MiddleRamsStatus
    end function

    real(8) function GetLowerRamsStatus()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetLowerRamsStatus
    !DEC$ ATTRIBUTES ALIAS: 'GetLowerRamsStatus' :: GetLowerRamsStatus
	    implicit none
	    GetLowerRamsStatus = LowerRamsStatus
    end function

 end module CBopControlPanel
