module CBopControlPanelVariables
    implicit none    
    public
    
    ! Input vars
    real(8) :: AnnularRegulatorSetControl
    real(8) :: AirMasterValve
    real(8) :: ByePassValve
    real(8) :: AnnularValve
    real(8) :: UpperRamsValve
    real(8) :: MiddleRamsValve
    real(8) :: KillLineValve
    real(8) :: ChokeLineValve
    real(8) :: LowerRamsValve

    ! Output vars
    real(8) :: ManifoldPressureGauge
    real(8) :: AirSupplyPressureGauge
    real(8) :: AccumulatorPressureGauge
    real(8) :: AnnularPressureGauge
    integer :: AnnularOpenLED
    integer :: AnnularCloseLED
    integer :: UpperRamsOpenLED
    integer :: UpperRamsCloseLED
    integer :: MiddleRamsOpenLED
    integer :: MiddleRamsCloseLED
    integer :: KillLineOpenLED
    integer :: KillLineCloseLED
    integer :: ChokeLineOpenLED
    integer :: ChokeLineCloseLED
    integer :: LowerRamsOpenLED
    integer :: LowerRamsCloseLED
    real(8) :: AnnularStatus
    real(8) :: UpperRamsStatus
    real(8) :: MiddleRamsStatus
    real(8) :: LowerRamsStatus

    contains    
    
    subroutine OpenAnnular()
        use CManifolds
        implicit none
        call ChangeValve(52, .true.)
    end subroutine
    
    subroutine CloseAnnular()
        use CManifolds
        implicit none
        call ChangeValve(52, .false.)
    end subroutine
    
    subroutine OpenUpperRams()
        use CManifolds
        implicit none
        call ChangeValve(51, .true.)
    end subroutine
    
    subroutine CloseUpperRams()
        use CManifolds
        implicit none
        call ChangeValve(51, .false.)
    end subroutine
    
    subroutine OpenMiddleRams()
        use CManifolds
        implicit none
        call ToggleMiddleRams(.true.)
    end subroutine
    
    subroutine CloseMiddleRams()
        use CManifolds
        implicit none
        call ToggleMiddleRams(.false.)
    end subroutine
    
    subroutine OpenKillLine()
        use CManifolds
        implicit none
        call ChangeValve(46, .true.)        
    end subroutine
    
    subroutine CloseKillLine()
        use CManifolds
        implicit none
        call ChangeValve(46, .false.)        
    end subroutine
    
    subroutine OpenChokeLine()
        use CManifolds
        implicit none
        call ChangeValve(47, .true.)
         !WRITE (*,*) ' valve 47 true '
    end subroutine
    
    subroutine CloseChokeLine()
        use CManifolds
        implicit none
        call ChangeValve(47, .false.)
         !WRITE (*,*) ' valve 47 false '
    end subroutine
    
    subroutine OpenLowerRams()
        use CManifolds
        implicit none
        call ChangeValve(49, .true.)
        !WRITE (*,*) ' valve 49 true '
    end subroutine
    
    subroutine CloseLowerRams()
        use CManifolds
        implicit none
        call ChangeValve(49, .false.)
        !WRITE (*,*) ' valve 49 false '
    end subroutine
    
end module CBopControlPanelVariables
