module CDataDisplayConsole
	use CDataDisplayConsoleVariables
	implicit none    
	public    
    contains  
    
    
    
    !Portable
    subroutine SetTripAlarmLow(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetTripAlarmLow
    !DEC$ ATTRIBUTES ALIAS: 'SetTripAlarmLow' :: SetTripAlarmLow
        !use MudSystemVARIABLES, only: TripTank_MinVol_Allowded
	    implicit none
	    real*8, intent(in) :: v
	    TripAlarmLow = v
        !TripTank_MinVol_Allowded = v
#ifdef deb
		print*, 'TripAlarmLow=', TripAlarmLow
#endif
    end subroutine

    subroutine SetTripAlarmHigh(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetTripAlarmHigh
    !DEC$ ATTRIBUTES ALIAS: 'SetTripAlarmHigh' :: SetTripAlarmHigh
        !use MudSystemVARIABLES, only: TripTank_MaxVol_Allowded
	    implicit none
	    real*8, intent(in) :: v
	    TripAlarmHigh = v
        !TripTank_MaxVol_Allowded = v
#ifdef deb
		print*, 'TripAlarmHigh=', TripAlarmHigh
#endif
    end subroutine

    
    subroutine SetRetFlowAlarmLow(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetRetFlowAlarmLow
    !DEC$ ATTRIBUTES ALIAS: 'SetRetFlowAlarmLow' :: SetRetFlowAlarmLow
        !use MudSystemVARIABLES, only: MFFI_MinPercent_Allowded
	    implicit none
	    real*8, intent(in) :: v
	    RetFlowAlarmLow = v
        !MFFI_MinPercent_Allowded = v
#ifdef deb
		print*, 'RetFlowAlarmLow=', RetFlowAlarmLow
#endif
    end subroutine

    subroutine SetRetFlowAlarmHigh(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetRetFlowAlarmHigh
    !DEC$ ATTRIBUTES ALIAS: 'SetRetFlowAlarmHigh' :: SetRetFlowAlarmHigh
        !use MudSystemVARIABLES, only: MFFI_MaxPercent_Allowded
	    implicit none
	    real*8, intent(in) :: v
	    RetFlowAlarmHigh = v
        !MFFI_MaxPercent_Allowded = v
#ifdef deb
		print*, 'RetFlowAlarmHigh=', RetFlowAlarmHigh
#endif
    end subroutine

    
    subroutine SetPitAlarmLow(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetPitAlarmLow
    !DEC$ ATTRIBUTES ALIAS: 'SetPitAlarmLow' :: SetPitAlarmLow
	    implicit none
	    real*8, intent(in) :: v
	    PitAlarmLow = v
        !call Log_4('PitAlarmLow=', PitAlarmLow)
#ifdef deb
		print*, 'PitAlarmLow=', PitAlarmLow
#endif
    end subroutine

    subroutine SetPitAlarmHigh(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetPitAlarmHigh
    !DEC$ ATTRIBUTES ALIAS: 'SetPitAlarmHigh' :: SetPitAlarmHigh
	    implicit none
	    real*8, intent(in) :: v
	    PitAlarmHigh = v
        !call Log_4('PitAlarmHigh=', PitAlarmHigh)
#ifdef deb
		print*, 'PitAlarmHigh=', PitAlarmHigh
#endif
    end subroutine
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
	
	! Input routines
	subroutine SetTripTankSetAlarmLow(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetTripTankSetAlarmLow
	!DEC$ ATTRIBUTES ALIAS: 'SetTripTankSetAlarmLow' :: SetTripTankSetAlarmLow
		implicit none
		real*8, intent(in) :: v
		TripTankSetAlarmLow = v
#ifdef deb
		print*, 'TripTankSetAlarmLow=', TripTankSetAlarmLow
#endif
	end subroutine

	subroutine SetTripTankSetAlarmHigh(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetTripTankSetAlarmHigh
	!DEC$ ATTRIBUTES ALIAS: 'SetTripTankSetAlarmHigh' :: SetTripTankSetAlarmHigh
		implicit none
		real*8, intent(in) :: v
		TripTankSetAlarmHigh = v
#ifdef deb
		print*, 'TripTankSetAlarmHigh=', TripTankSetAlarmHigh
#endif
	end subroutine

	subroutine SetTripTankSetAlarmSwitch(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetTripTankSetAlarmSwitch
	!DEC$ ATTRIBUTES ALIAS: 'SetTripTankSetAlarmSwitch' :: SetTripTankSetAlarmSwitch
		implicit none
		integer, intent(in) :: v
		TripTankSetAlarmSwitch = v
#ifdef deb
		print*, 'TripTankSetAlarmSwitch=', TripTankSetAlarmSwitch
#endif
	end subroutine

	subroutine SetTripTankPowerSwitch(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetTripTankPowerSwitch
	!DEC$ ATTRIBUTES ALIAS: 'SetTripTankPowerSwitch' :: SetTripTankPowerSwitch
        use CTanksVariables, only: Set_ManualPumpPower
		implicit none
		logical, intent(in) :: v
		TripTankPowerSwitch = v
        if(TripTankPowerSwitch) call Set_ManualPumpPower(TripTankPumpSwitch)
#ifdef deb
		print*, 'TripTankPowerSwitch=', TripTankPowerSwitch
#endif
	end subroutine

	subroutine SetTripTankPumpSwitch(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetTripTankPumpSwitch
	!DEC$ ATTRIBUTES ALIAS: 'SetTripTankPumpSwitch' :: SetTripTankPumpSwitch
        use CTanksVariables, only: Set_ManualPumpPower
		implicit none
		logical, intent(in) :: v
		TripTankPumpSwitch = v
        if(TripTankPowerSwitch) call Set_ManualPumpPower(TripTankPumpSwitch)
#ifdef deb
		print*, 'TripTankPumpSwitch=', TripTankPumpSwitch
#endif
	end subroutine

	subroutine SetTripTankHornSwitch(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetTripTankHornSwitch
	!DEC$ ATTRIBUTES ALIAS: 'SetTripTankHornSwitch' :: SetTripTankHornSwitch
		implicit none
		logical, intent(in) :: v
		TripTankHornSwitch = v
#ifdef deb
		print*, 'TripTankHornSwitch=', TripTankHornSwitch
#endif
	end subroutine

	subroutine SetAcidGasDetectionHornSwitch(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetAcidGasDetectionHornSwitch
	!DEC$ ATTRIBUTES ALIAS: 'SetAcidGasDetectionHornSwitch' :: SetAcidGasDetectionHornSwitch
		implicit none
		logical, intent(in) :: v
		AcidGasDetectionHornSwitch = v
#ifdef deb
		print*, 'AcidGasDetectionHornSwitch=', AcidGasDetectionHornSwitch
#endif
	end subroutine

	subroutine SetTotalStrokeCounterResetSwitch(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetTotalStrokeCounterResetSwitch
	!DEC$ ATTRIBUTES ALIAS: 'SetTotalStrokeCounterResetSwitch' :: SetTotalStrokeCounterResetSwitch
		implicit none
		logical, intent(in) :: v
		TotalStrokeCounterResetSwitch = v
#ifdef deb
		print*, 'TotalStrokeCounterResetSwitch=', TotalStrokeCounterResetSwitch
#endif
	end subroutine

	subroutine SetDrillingTrippingSelectorSwitch(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetDrillingTrippingSelectorSwitch
	!DEC$ ATTRIBUTES ALIAS: 'SetDrillingTrippingSelectorSwitch' :: SetDrillingTrippingSelectorSwitch
		use CCommonVariables   
		implicit none
		logical, intent(in) :: v
		DrillingTrippingSelectorSwitch = v
		DrillWatchOperationMode = v
#ifdef deb
		print*, 'DrillingTrippingSelectorSwitch=', DrillingTrippingSelectorSwitch
#endif
	end subroutine

	subroutine SetMVTSetAlarmLowKnob(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetMVTSetAlarmLowKnob
	!DEC$ ATTRIBUTES ALIAS: 'SetMVTSetAlarmLowKnob' :: SetMVTSetAlarmLowKnob
		implicit none
		real*8, intent(in) :: v
		MVTSetAlarmLowKnob = v
#ifdef deb
		print*, 'MVTSetAlarmLowKnob=', MVTSetAlarmLowKnob
#endif
	end subroutine

	subroutine SetMVTSetAlarmHighKnob(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetMVTSetAlarmHighKnob
	!DEC$ ATTRIBUTES ALIAS: 'SetMVTSetAlarmHighKnob' :: SetMVTSetAlarmHighKnob
		implicit none
		real*8, intent(in) :: v
		MVTSetAlarmHighKnob = v
#ifdef deb
		print*, 'MVTSetAlarmHighKnob=', MVTSetAlarmHighKnob
#endif
	end subroutine

	subroutine SetMVTSetAlarmSwitch(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetMVTSetAlarmSwitch
	!DEC$ ATTRIBUTES ALIAS: 'SetMVTSetAlarmSwitch' :: SetMVTSetAlarmSwitch
		implicit none
		integer, intent(in) :: v
		MVTSetAlarmSwitch = v
#ifdef deb
		print*, 'MVTSetAlarmSwitch=', MVTSetAlarmSwitch
#endif
	end subroutine

	subroutine SetMudTank1Switch(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetMudTank1Switch
	!DEC$ ATTRIBUTES ALIAS: 'SetMudTank1Switch' :: SetMudTank1Switch
		implicit none
		logical, intent(in) :: v
		MudTank1Switch = v
#ifdef deb
		print*, 'MudTank1Switch=', MudTank1Switch
#endif
	end subroutine

	subroutine SetMudTank2Switch(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetMudTank2Switch
	!DEC$ ATTRIBUTES ALIAS: 'SetMudTank2Switch' :: SetMudTank2Switch
		implicit none
		logical, intent(in) :: v
		MudTank2Switch = v
#ifdef deb
		print*, 'MudTank2Switch=', MudTank2Switch
#endif
	end subroutine

	subroutine SetMudTank3Switch(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetMudTank3Switch
	!DEC$ ATTRIBUTES ALIAS: 'SetMudTank3Switch' :: SetMudTank3Switch
		implicit none
		logical, intent(in) :: v
		MudTank3Switch = v
#ifdef deb
		print*, 'MudTank3Switch=', MudTank3Switch
#endif
	end subroutine

	subroutine SetMudTank4Switch(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetMudTank4Switch
	!DEC$ ATTRIBUTES ALIAS: 'SetMudTank4Switch' :: SetMudTank4Switch
		implicit none
		logical, intent(in) :: v
		MudTank4Switch = v
#ifdef deb
		print*, 'MudTank4Switch=', MudTank4Switch
#endif
	end subroutine

	subroutine SetMVTFineKnob(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetMVTFineKnob
	!DEC$ ATTRIBUTES ALIAS: 'SetMVTFineKnob' :: SetMVTFineKnob
		implicit none
		real*8, intent(in) :: v
		MVTFineKnob = v
#ifdef deb
		print*, 'MVTFineKnob=', MVTFineKnob
#endif
	end subroutine

	subroutine SetMVTCoarseKnob(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetMVTCoarseKnob
	!DEC$ ATTRIBUTES ALIAS: 'SetMVTCoarseKnob' :: SetMVTCoarseKnob
		implicit none
		real*8, intent(in) :: v
		MVTCoarseKnob = v
#ifdef deb
		print*, 'MVTCoarseKnob=', MVTCoarseKnob
#endif
	end subroutine

	subroutine SetMVTHornSwitch(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetMVTHornSwitch
	!DEC$ ATTRIBUTES ALIAS: 'SetMVTHornSwitch' :: SetMVTHornSwitch
		implicit none
		logical, intent(in) :: v
		MVTHornSwitch = v
#ifdef deb
		print*, 'MVTHornSwitch=', MVTHornSwitch
#endif
	end subroutine

	subroutine SetMVTDeviationTripSelectionSwitch(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetMVTDeviationTripSelectionSwitch
	!DEC$ ATTRIBUTES ALIAS: 'SetMVTDeviationTripSelectionSwitch' :: SetMVTDeviationTripSelectionSwitch
		implicit none
		logical, intent(in) :: v
		MVTDeviationTripSelectionSwitch = v
#ifdef deb
		print*, 'MVTDeviationTripSelectionSwitch=', MVTDeviationTripSelectionSwitch
#endif
	end subroutine

	subroutine SetMVTPowerSwitch(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetMVTPowerSwitch
	!DEC$ ATTRIBUTES ALIAS: 'SetMVTPowerSwitch' :: SetMVTPowerSwitch
		implicit none
		logical, intent(in) :: v
		MVTPowerSwitch = v
#ifdef deb
		print*, 'MVTPowerSwitch=', MVTPowerSwitch
#endif
	end subroutine

	subroutine SetMFFIResetTotalStrokes(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetMFFIResetTotalStrokes
	!DEC$ ATTRIBUTES ALIAS: 'SetMFFIResetTotalStrokes' :: SetMFFIResetTotalStrokes
		implicit none
		logical, intent(in) :: v
		MFFIResetTotalStrokes = v
#ifdef deb
		print*, 'MFFIResetTotalStrokes=', MFFIResetTotalStrokes
#endif
	end subroutine

	subroutine SetMFFIResetFillCounter(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetMFFIResetFillCounter
	!DEC$ ATTRIBUTES ALIAS: 'SetMFFIResetFillCounter' :: SetMFFIResetFillCounter
		implicit none
		logical, intent(in) :: v
		MFFIResetFillCounter = v
#ifdef deb
		print*, 'MFFIResetFillCounter=', MFFIResetFillCounter
#endif
	end subroutine

	subroutine SetMFFIPumpSelectorSwitch(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetMFFIPumpSelectorSwitch
	!DEC$ ATTRIBUTES ALIAS: 'SetMFFIPumpSelectorSwitch' :: SetMFFIPumpSelectorSwitch
		implicit none
		integer, intent(in) :: v
		MFFIPumpSelectorSwitch = v
#ifdef deb
		print*, 'MFFIPumpSelectorSwitch=', MFFIPumpSelectorSwitch
#endif
	end subroutine

	subroutine SetMFFIFillSPMSelectorSwitch(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetMFFIFillSPMSelectorSwitch
	!DEC$ ATTRIBUTES ALIAS: 'SetMFFIFillSPMSelectorSwitch' :: SetMFFIFillSPMSelectorSwitch
		implicit none
		logical, intent(in) :: v
		MFFIFillSPMSelectorSwitch = v
#ifdef deb
		print*, 'MFFIFillSPMSelectorSwitch=', MFFIFillSPMSelectorSwitch
#endif
	end subroutine

	subroutine SetMFFISetAlarmLowKnob(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetMFFISetAlarmLowKnob
	!DEC$ ATTRIBUTES ALIAS: 'SetMFFISetAlarmLowKnob' :: SetMFFISetAlarmLowKnob
		implicit none
		real*8, intent(in) :: v
		MFFISetAlarmLowKnob = v
#ifdef deb
		print*, 'MFFISetAlarmLowKnob=', MFFISetAlarmLowKnob
#endif
	end subroutine

	subroutine SetMFFISetAlarmHighKnob(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetMFFISetAlarmHighKnob
	!DEC$ ATTRIBUTES ALIAS: 'SetMFFISetAlarmHighKnob' :: SetMFFISetAlarmHighKnob
		implicit none
		real*8, intent(in) :: v
		MFFISetAlarmHighKnob = v
#ifdef deb
		print*, 'MFFISetAlarmHighKnob=', MFFISetAlarmHighKnob
#endif
	end subroutine

	subroutine SetMFFISetAlarmSwitch(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetMFFISetAlarmSwitch
	!DEC$ ATTRIBUTES ALIAS: 'SetMFFISetAlarmSwitch' :: SetMFFISetAlarmSwitch
		implicit none
		integer, intent(in) :: v
		MFFISetAlarmSwitch = v
#ifdef deb
		print*, 'MFFISetAlarmSwitch=', MFFISetAlarmSwitch
#endif
	end subroutine

	subroutine SetMFFIPowerSwitch(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetMFFIPowerSwitch
	!DEC$ ATTRIBUTES ALIAS: 'SetMFFIPowerSwitch' :: SetMFFIPowerSwitch
		implicit none
		logical, intent(in) :: v
		MFFIPowerSwitch = v
#ifdef deb
		print*, 'MFFIPowerSwitch=', MFFIPowerSwitch
#endif
	end subroutine

	subroutine SetMFFIHornSwitch(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetMFFIHornSwitch
	!DEC$ ATTRIBUTES ALIAS: 'SetMFFIHornSwitch' :: SetMFFIHornSwitch
		implicit none
		logical, intent(in) :: v
		MFFIHornSwitch = v
#ifdef deb
		print*, 'MFFIHornSwitch=', MFFIHornSwitch
#endif
    end subroutine
    
    subroutine SetTotalWellDepth(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetTotalWellDepth
	!DEC$ ATTRIBUTES ALIAS: 'SetTotalWellDepth' :: SetTotalWellDepth
		implicit none
        real(8), intent(in) :: v
		call Set_TotalDepth(v)
#ifdef deb
		print*, 'TotalWellDepth=', v
#endif
    end subroutine
    
    subroutine SetResetWob(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetResetWob
	!DEC$ ATTRIBUTES ALIAS: 'SetResetWob' :: SetResetWob
		implicit none
		logical, intent(in) :: v
		ResetWob = v
#ifdef deb
		print*, 'ResetWob=', ResetWob
#endif
    end subroutine
    
    subroutine SetClutch(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetClutch
	!DEC$ ATTRIBUTES ALIAS: 'SetClutch' :: SetClutch
		implicit none
		logical, intent(in) :: v
		Clutch = v
#ifdef deb
		print*, 'Clutch=', Clutch
#endif
    end subroutine


	! Output routines
	real(8) function GetWOBPointer()
	!DEC$ ATTRIBUTES DLLEXPORT :: GetWOBPointer
	!DEC$ ATTRIBUTES ALIAS: 'GetWOBPointer' :: GetWOBPointer
		implicit none
		GetWOBPointer = WOBPointer
	end function

	real(8) function GetHookLoadPointer()
	!DEC$ ATTRIBUTES DLLEXPORT :: GetHookLoadPointer
	!DEC$ ATTRIBUTES ALIAS: 'GetHookLoadPointer' :: GetHookLoadPointer
		implicit none
		GetHookLoadPointer = HookLoadPointer
	end function

	real(8) function GetTripTankGauge()
	!DEC$ ATTRIBUTES DLLEXPORT :: GetTripTankGauge
	!DEC$ ATTRIBUTES ALIAS: 'GetTripTankGauge' :: GetTripTankGauge
		implicit none
		GetTripTankGauge = TripTankGauge / 42.0
		!GetTripTankGauge = 23
	end function

	integer function GetTripTankAlarmLED()
	!DEC$ ATTRIBUTES DLLEXPORT :: GetTripTankAlarmLED
	!DEC$ ATTRIBUTES ALIAS: 'GetTripTankAlarmLED' :: GetTripTankAlarmLED
		implicit none
		GetTripTankAlarmLED = TripTankAlarmLED
		!GetTripTankAlarmLED = 1
	end function

	integer function GetTripTankPumpLED()
	!DEC$ ATTRIBUTES DLLEXPORT :: GetTripTankPumpLED
	!DEC$ ATTRIBUTES ALIAS: 'GetTripTankPumpLED' :: GetTripTankPumpLED
		implicit none
		GetTripTankPumpLED = TripTankPumpLED
	end function

	real(8) function GetStandPipePressureGauge()
	!DEC$ ATTRIBUTES DLLEXPORT :: GetStandPipePressureGauge
	!DEC$ ATTRIBUTES ALIAS: 'GetStandPipePressureGauge' :: GetStandPipePressureGauge
		implicit none
		GetStandPipePressureGauge = StandPipePressureGauge
	end function

	real(8) function GetCasingPressureGauge()
	!DEC$ ATTRIBUTES DLLEXPORT :: GetCasingPressureGauge
	!DEC$ ATTRIBUTES ALIAS: 'GetCasingPressureGauge' :: GetCasingPressureGauge
		implicit none
		GetCasingPressureGauge = CasingPressureGauge
	end function

	real(8) function GetMP1SPMGauge()
	!DEC$ ATTRIBUTES DLLEXPORT :: GetMP1SPMGauge
	!DEC$ ATTRIBUTES ALIAS: 'GetMP1SPMGauge' :: GetMP1SPMGauge
		implicit none
		GetMP1SPMGauge = MP1SPMGauge
	end function

	real(8) function GetMP2SPMGauge()
	!DEC$ ATTRIBUTES DLLEXPORT :: GetMP2SPMGauge
	!DEC$ ATTRIBUTES ALIAS: 'GetMP2SPMGauge' :: GetMP2SPMGauge
		implicit none
		GetMP2SPMGauge = MP2SPMGauge
	end function

	real(8) function GetReturnLineTempGauge()
	!DEC$ ATTRIBUTES DLLEXPORT :: GetReturnLineTempGauge
	!DEC$ ATTRIBUTES ALIAS: 'GetReturnLineTempGauge' :: GetReturnLineTempGauge
		implicit none
		GetReturnLineTempGauge = ReturnLineTempGauge
	end function

	real(8) function GetRotaryTorqueGauge()
	!DEC$ ATTRIBUTES DLLEXPORT :: GetRotaryTorqueGauge
	!DEC$ ATTRIBUTES ALIAS: 'GetRotaryTorqueGauge' :: GetRotaryTorqueGauge
		implicit none
		GetRotaryTorqueGauge = RotaryTorqueGauge
	end function

	real(8) function GetRotaryRPMGauge()
	!DEC$ ATTRIBUTES DLLEXPORT :: GetRotaryRPMGauge
	!DEC$ ATTRIBUTES ALIAS: 'GetRotaryRPMGauge' :: GetRotaryRPMGauge
		implicit none
		GetRotaryRPMGauge = RotaryRPMGauge
	end function

	integer function GetAcidGasDetectionLED()
	!DEC$ ATTRIBUTES DLLEXPORT :: GetAcidGasDetectionLED
	!DEC$ ATTRIBUTES ALIAS: 'GetAcidGasDetectionLED' :: GetAcidGasDetectionLED
		implicit none
		GetAcidGasDetectionLED = AcidGasDetectionLED
	end function

	real(8) function GetTotalStrokeCounter()
	!DEC$ ATTRIBUTES DLLEXPORT :: GetTotalStrokeCounter
	!DEC$ ATTRIBUTES ALIAS: 'GetTotalStrokeCounter' :: GetTotalStrokeCounter
		implicit none
		GetTotalStrokeCounter = TotalStrokeCounter
		!GetTotalStrokeCounter = 456.9
	end function

	real(8) function GetPitGainLossGauge()
	!DEC$ ATTRIBUTES DLLEXPORT :: GetPitGainLossGauge
	!DEC$ ATTRIBUTES ALIAS: 'GetPitGainLossGauge' :: GetPitGainLossGauge
		implicit none
		GetPitGainLossGauge = PitGainLossGauge
		!GetPitGainLossGauge = 44
	end function

	real(8) function GetMudTanksVolumeGauge()
	!DEC$ ATTRIBUTES DLLEXPORT :: GetMudTanksVolumeGauge
	!DEC$ ATTRIBUTES ALIAS: 'GetMudTanksVolumeGauge' :: GetMudTanksVolumeGauge
		implicit none
		GetMudTanksVolumeGauge = MudTanksVolumeGauge / 42.0
	end function

	integer function GetMVTAlarmLED()
	!DEC$ ATTRIBUTES DLLEXPORT :: GetMVTAlarmLED
	!DEC$ ATTRIBUTES ALIAS: 'GetMVTAlarmLED' :: GetMVTAlarmLED
		implicit none
		GetMVTAlarmLED = MVTAlarmLED
		!GetMVTAlarmLED = 1
	end function

	real(8) function GetReturnMudFlowGauge()
	!DEC$ ATTRIBUTES DLLEXPORT :: GetReturnMudFlowGauge
	!DEC$ ATTRIBUTES ALIAS: 'GetReturnMudFlowGauge' :: GetReturnMudFlowGauge
		implicit none
		GetReturnMudFlowGauge = ReturnMudFlowGauge
		!GetReturnMudFlowGauge = 12
	end function

	real(8) function GetFillStrokeCounter()
	!DEC$ ATTRIBUTES DLLEXPORT :: GetFillStrokeCounter
	!DEC$ ATTRIBUTES ALIAS: 'GetFillStrokeCounter' :: GetFillStrokeCounter
		implicit none
		GetFillStrokeCounter = FillStrokeCounter
	end function

	real(8) function GetMFFITotalStrokeCounter()
	!DEC$ ATTRIBUTES DLLEXPORT :: GetMFFITotalStrokeCounter
	!DEC$ ATTRIBUTES ALIAS: 'GetMFFITotalStrokeCounter' :: GetMFFITotalStrokeCounter
		implicit none
		GetMFFITotalStrokeCounter = MFFITotalStrokeCounter
	end function

	integer function GetMFFIAlarmLED()
	!DEC$ ATTRIBUTES DLLEXPORT :: GetMFFIAlarmLED
	!DEC$ ATTRIBUTES ALIAS: 'GetMFFIAlarmLED' :: GetMFFIAlarmLED
		implicit none
		GetMFFIAlarmLED = MFFIAlarmLED
		!GetMFFIAlarmLED = 1
	end function

	integer function GetMFFIPumpLED()
	!DEC$ ATTRIBUTES DLLEXPORT :: GetMFFIPumpLED
	!DEC$ ATTRIBUTES ALIAS: 'GetMFFIPumpLED' :: GetMFFIPumpLED
		implicit none
		GetMFFIPumpLED = MFFIPumpLED
	end function

	real(8) function GetTotalWellDepth()
	!DEC$ ATTRIBUTES DLLEXPORT :: GetTotalWellDepth
	!DEC$ ATTRIBUTES ALIAS: 'GetTotalWellDepth' :: GetTotalWellDepth
		implicit none
		GetTotalWellDepth = TotalWellDepth
	end function

	real(8) function GetBitDepth()
	!DEC$ ATTRIBUTES DLLEXPORT :: GetBitDepth
	!DEC$ ATTRIBUTES ALIAS: 'GetBitDepth' :: GetBitDepth
		implicit none
		GetBitDepth = BitDepth
	end function

	real(8) function GetHookLoad()
	!DEC$ ATTRIBUTES DLLEXPORT :: GetHookLoad
	!DEC$ ATTRIBUTES ALIAS: 'GetHookLoad' :: GetHookLoad
		implicit none
		GetHookLoad = HookLoad
	end function

	real(8) function GetStandPipePressure2()
	!DEC$ ATTRIBUTES DLLEXPORT :: GetStandPipePressure2
	!DEC$ ATTRIBUTES ALIAS: 'GetStandPipePressure2' :: GetStandPipePressure2
		implicit none
		GetStandPipePressure2 = StandPipePressure
	end function

	real(8) function GetCasingPressure2()
	!DEC$ ATTRIBUTES DLLEXPORT :: GetCasingPressure2
	!DEC$ ATTRIBUTES ALIAS: 'GetCasingPressure2' :: GetCasingPressure2
		implicit none
		GetCasingPressure2 = CasingPressure
	end function

	real(8) function GetMP1SPM()
	!DEC$ ATTRIBUTES DLLEXPORT :: GetMP1SPM
	!DEC$ ATTRIBUTES ALIAS: 'GetMP1SPM' :: GetMP1SPM
		implicit none
		GetMP1SPM = MP1SPM
	end function

	real(8) function GetMP2SPM()
	!DEC$ ATTRIBUTES DLLEXPORT :: GetMP2SPM
	!DEC$ ATTRIBUTES ALIAS: 'GetMP2SPM' :: GetMP2SPM
		implicit none
		GetMP2SPM = MP2SPM
	end function

	real(8) function GetRTTorque()
	!DEC$ ATTRIBUTES DLLEXPORT :: GetRTTorque
	!DEC$ ATTRIBUTES ALIAS: 'GetRTTorque' :: GetRTTorque
		implicit none
		GetRTTorque = RTTorque
	end function

	real(8) function GetRTRPM()
	!DEC$ ATTRIBUTES DLLEXPORT :: GetRTRPM
	!DEC$ ATTRIBUTES ALIAS: 'GetRTRPM' :: GetRTRPM
		implicit none
		GetRTRPM = RTRPM
	end function

	real(8) function GetWOP()
	!DEC$ ATTRIBUTES DLLEXPORT :: GetWOP
	!DEC$ ATTRIBUTES ALIAS: 'GetWOP' :: GetWOP
		implicit none
		GetWOP = WOP
	end function

	real(8) function GetROP()
	!DEC$ ATTRIBUTES DLLEXPORT :: GetROP
	!DEC$ ATTRIBUTES ALIAS: 'GetROP' :: GetROP
		implicit none
		GetROP = ROP
	end function

	real(8) function GetMudWeightIn()
	!DEC$ ATTRIBUTES DLLEXPORT :: GetMudWeightIn
	!DEC$ ATTRIBUTES ALIAS: 'GetMudWeightIn' :: GetMudWeightIn
		implicit none
		GetMudWeightIn = MudWeightIn
	end function

	real(8) function GetMudWeightOut()
	!DEC$ ATTRIBUTES DLLEXPORT :: GetMudWeightOut
	!DEC$ ATTRIBUTES ALIAS: 'GetMudWeightOut' :: GetMudWeightOut
		implicit none
		GetMudWeightOut = MudWeightOut
    end function
    
    logical function GetBuzzer1()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetBuzzer1
    !DEC$ ATTRIBUTES ALIAS: 'GetBuzzer1' :: GetBuzzer1
	    implicit none
	    GetBuzzer1 = Buzzer1
	    !GetBuzzer1 = .true.
    end function

    logical function GetBuzzer2()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetBuzzer2
    !DEC$ ATTRIBUTES ALIAS: 'GetBuzzer2' :: GetBuzzer2
	    implicit none
	    GetBuzzer2 = Buzzer2
	    !GetBuzzer2 = .true.
    end function

    logical function GetBuzzer3()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetBuzzer3
    !DEC$ ATTRIBUTES ALIAS: 'GetBuzzer3' :: GetBuzzer3
	    implicit none
	    GetBuzzer3 = Buzzer3
	    !GetBuzzer3 = .true.
    end function

    logical function GetBuzzer4()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetBuzzer4
    !DEC$ ATTRIBUTES ALIAS: 'GetBuzzer4' :: GetBuzzer4
	    implicit none
	    GetBuzzer4 = Buzzer4
	    !GetBuzzer4 = .true.
    end function
    
    
    
    
    
    
    
    
    
    
    !portable
    real(8) function GetPortWeightOnBit()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetPortWeightOnBit
    !DEC$ ATTRIBUTES ALIAS: 'GetPortWeightOnBit' :: GetPortWeightOnBit
	    implicit none
	    GetPortWeightOnBit = PortWeightOnBit
    end function

    real(8) function GetPortHookLoad()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetPortHookLoad
    !DEC$ ATTRIBUTES ALIAS: 'GetPortHookLoad' :: GetPortHookLoad
	    implicit none
	    GetPortHookLoad = PortHookLoad
    end function

    real(8) function GetPortCasingPressure()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetPortCasingPressure
    !DEC$ ATTRIBUTES ALIAS: 'GetPortCasingPressure' :: GetPortCasingPressure
	    implicit none
	    GetPortCasingPressure = PortCasingPressure
    end function

    real(8) function GetPortPumpPressure()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetPortPumpPressure
    !DEC$ ATTRIBUTES ALIAS: 'GetPortPumpPressure' :: GetPortPumpPressure
	    implicit none
	    GetPortPumpPressure = PortPumpPressure
    end function


end module CDataDisplayConsole