module CTdsConnectionModesEnum
    use COperationScenariosVariables
    implicit none
    contains
    
    subroutine Evaluate_TdsConnectionModes()
        implicit none
        
        
        
        if (DriveType == TopDrive_DriveType) then
#ifdef OST
            print*, 'Evaluate_TdsConnectionModes=TopDrive'
#endif

            !TOPDRIVE-CODE=3
            if (Get_TdsStemIn() .and.&
                Get_TdsSpine() == TDS_SPINE_CONNECT_END .and.&
                !TopDriveDrillTorqueState == TdsMu_SPINE
                Get_TdsConnectionModes() == TDS_CONNECTION_NOTHING) then
            
                call Set_TdsConnectionModes(TDS_CONNECTION_SPINE)
                return
            end if
                
                
            !TOPDRIVE-CODE=4
            if (Get_TdsTong() == TDS_TONG_MAKEUP_END .and.&
                Get_TdsConnectionModes() == TDS_CONNECTION_SPINE ) then
            
                call Set_TdsConnectionModes(TDS_CONNECTION_STRING)
                TopDriveTorqueWrenchLed = LED_OFF
                return
            end if
                
                
            !TOPDRIVE-CODE=5
            if (Get_TdsTong() == TDS_TONG_BREAKOUT_END .and.&
                Get_TdsConnectionModes() == TDS_CONNECTION_STRING ) then
            
                call Set_TdsConnectionModes(TDS_CONNECTION_SPINE)
                TopDriveTorqueWrenchLed = LED_OFF
                return
            end if
                
                
                
            !TOPDRIVE-CODE=6
            if (Get_TdsSpine() == TDS_SPINE_DISCONNECT_END .and.&
                !Get_TdsStemIn() == .false. .and.&
                Get_TdsConnectionModes() == TDS_CONNECTION_SPINE) then
            
                call Set_TdsConnectionModes(TDS_CONNECTION_NOTHING)
                return
            end if


        endif
        
        
        
        
        if (DriveType == Kelly_DriveType) then
#ifdef OST
            print*, 'Evaluate_TdsConnectionModes=Kelly'
#endif
        endif
        
        
        
        
        
        
    end subroutine
    
    subroutine Subscribe_TdsConnectionModes()
        use CDrillingConsoleVariables
        implicit none
    end subroutine
    
end module CTdsConnectionModesEnum