module CCloseKellyCockLedNotificationVariables
    use CVoidEventHandlerCollection
    implicit none
    logical :: CloseKellyCockLed = .false.
    
    public
    
    type(VoidEventHandlerCollection) :: OnCloseKellyCockLedChange
        
    private :: CloseKellyCockLed
    
    contains
    
    subroutine Set_CloseKellyCockLed(v)
        use CDrillingConsoleVariables, only: CloseKellyCockLedHw => CloseKellyCockLed
        use CManifolds, only: CloseKellyCock
        implicit none
        logical , intent(in) :: v
#ifdef ExcludeExtraChanges
        if(CloseKellyCockLed == v) return
#endif
        CloseKellyCockLed = v
        
        if(CloseKellyCockLed) then
            call CloseKellyCock()
        endif 
        
        !if(CloseKellyCockLed) then
        !    CloseKellyCockLedHw = 1
        !else 
        !    CloseKellyCockLedHw = 0
        !endif
        call OnCloseKellyCockLedChange%RunAll()
    end subroutine
    
    logical function Get_CloseKellyCockLed()
        implicit none
        Get_CloseKellyCockLed = CloseKellyCockLed
    end function
    
    
    
    
    
    
    
    
    
    
    
    subroutine Set_CloseKellyCockLed_WN(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: Set_CloseKellyCockLed_WN
    !DEC$ ATTRIBUTES ALIAS: 'Set_CloseKellyCockLed_WN' :: Set_CloseKellyCockLed_WN
        implicit none
        logical , intent(in) :: v
        call Set_CloseKellyCockLed(v)
    end subroutine
    
    
    logical function Get_CloseKellyCockLed_WN()
    !DEC$ ATTRIBUTES DLLEXPORT :: Get_CloseKellyCockLed_WN
    !DEC$ ATTRIBUTES ALIAS: 'Get_CloseKellyCockLed_WN' :: Get_CloseKellyCockLed_WN
        implicit none
        Get_CloseKellyCockLed_WN = CloseKellyCockLed
    end function
    
end module CCloseKellyCockLedNotificationVariables