module COpenKellyCockLedNotificationVariables
    use CVoidEventHandlerCollection
    implicit none
    logical :: OpenKellyCockLed = .false.
    
    public
    
    type(VoidEventHandlerCollection) :: OnOpenKellyCockLedChange
        
    private :: OpenKellyCockLed
    
    contains
    
    subroutine Set_OpenKellyCockLed(v)
        use CDrillingConsoleVariables, only: OpenKellyCockLedHw => OpenKellyCockLed
        use CManifolds, only: OpenKellyCock
        implicit none
        logical , intent(in) :: v
#ifdef ExcludeExtraChanges
        if(OpenKellyCockLed == v) return
#endif
        OpenKellyCockLed = v
        
        if(OpenKellyCockLed) then
            call OpenKellyCock()
        endif  
        
        ! HAS BEEN IMPLEMENTED IN CMANIFOLD
        
        !if(OpenKellyCockLed) then
        !    OpenKellyCockLedHw = 1
        !else 
        !    OpenKellyCockLedHw = 0
        !endif
        
        call OnOpenKellyCockLedChange%RunAll()
    end subroutine
    
    logical function Get_OpenKellyCockLed()
        implicit none
        Get_OpenKellyCockLed = OpenKellyCockLed
    end function
    
    
    
    
    
    subroutine Set_OpenKellyCockLed_WN(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: Set_OpenKellyCockLed_WN
    !DEC$ ATTRIBUTES ALIAS: 'Set_OpenKellyCockLed_WN' :: Set_OpenKellyCockLed_WN
        implicit none
        logical , intent(in) :: v
        call Set_OpenKellyCockLed(v)
    end subroutine
    
    logical function Get_OpenKellyCockLed_WN()
    !DEC$ ATTRIBUTES DLLEXPORT :: Get_OpenKellyCockLed_WN
    !DEC$ ATTRIBUTES ALIAS: 'Get_OpenKellyCockLed_WN' :: Get_OpenKellyCockLed_WN
        implicit none
        Get_OpenKellyCockLed_WN = OpenKellyCockLed
    end function
    
end module COpenKellyCockLedNotificationVariables