module CInstallFillupHeadPermissionVariables
    use CVoidEventHandlerCollection
    implicit none
    logical :: InstallFillupHeadPermission = .false.
    
    public
    
    type(VoidEventHandlerCollection) :: OnInstallFillupHeadPermissionChange
        
    private :: InstallFillupHeadPermission
    
    contains
    
    subroutine Set_InstallFillupHeadPermission(v)
        implicit none
        logical , intent(in) :: v
#ifdef ExcludeExtraChanges
        if(InstallFillupHeadPermission == v) return
#endif
        InstallFillupHeadPermission = v
#ifdef deb
        print*, 'InstallFillupHeadPermission=', InstallFillupHeadPermission
#endif
        call OnInstallFillupHeadPermissionChange%RunAll()
    end subroutine
    
    logical function Get_InstallFillupHeadPermission()
        implicit none
        Get_InstallFillupHeadPermission = InstallFillupHeadPermission
    end function
    
    
    
    subroutine Set_InstallFillupHeadPermission_WN(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: Set_InstallFillupHeadPermission_WN
    !DEC$ ATTRIBUTES ALIAS: 'Set_InstallFillupHeadPermission_WN' :: Set_InstallFillupHeadPermission_WN
        implicit none
        logical , intent(in) :: v
        call Set_InstallFillupHeadPermission(v)
    end subroutine
    
    
    logical function Get_InstallFillupHeadPermission_WN()
    !DEC$ ATTRIBUTES DLLEXPORT :: Get_InstallFillupHeadPermission_WN
    !DEC$ ATTRIBUTES ALIAS: 'Get_InstallFillupHeadPermission_WN' :: Get_InstallFillupHeadPermission_WN
        implicit none
        Get_InstallFillupHeadPermission_WN = InstallFillupHeadPermission
    end function
    
    
    
    
end module CInstallFillupHeadPermissionVariables