module CInstallMudBucketPermissionVariables
    use CVoidEventHandlerCollection
    implicit none
    logical :: InstallMudBucketPermission = .false.
    
    public
    
    type(VoidEventHandlerCollection) :: OnInstallMudBucketPermissionChange
        
    private :: InstallMudBucketPermission
    
    contains
    
    subroutine Set_InstallMudBucketPermission(v)
        implicit none
        logical , intent(in) :: v
#ifdef ExcludeExtraChanges
        if(InstallMudBucketPermission == v) return
#endif
        InstallMudBucketPermission = v
#ifdef deb
        print*, 'InstallMudBucketPermission=', InstallMudBucketPermission
#endif
        call OnInstallMudBucketPermissionChange%RunAll()
    end subroutine
    
    logical function Get_InstallMudBucketPermission()
        implicit none
        Get_InstallMudBucketPermission = InstallMudBucketPermission
    end function
    
    
    
    
    subroutine Set_InstallMudBucketPermission_WN(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: Set_InstallMudBucketPermission_WN
    !DEC$ ATTRIBUTES ALIAS: 'Set_InstallMudBucketPermission_WN' :: Set_InstallMudBucketPermission_WN
        implicit none
        logical , intent(in) :: v
        call Set_InstallMudBucketPermission(v)
    end subroutine
    
    
    logical function Get_InstallMudBucketPermission_WN()
    !DEC$ ATTRIBUTES DLLEXPORT :: Get_InstallMudBucketPermission_WN
    !DEC$ ATTRIBUTES ALIAS: 'Get_InstallMudBucketPermission_WN' :: Get_InstallMudBucketPermission_WN
        implicit none
        Get_InstallMudBucketPermission_WN = InstallMudBucketPermission
    end function
    
end module CInstallMudBucketPermissionVariables