module CIrSafetyValvePermissionVariables
    use CVoidEventHandlerCollection
    implicit none
    logical :: IrSafetyValvePermission = .false.
    
    public
    
    type(VoidEventHandlerCollection) :: OnIrSafetyValvePermissionChange
        
    private :: IrSafetyValvePermission
    
    contains
    
    subroutine Set_IrSafetyValvePermission(v)
        implicit none
        logical , intent(in) :: v
#ifdef ExcludeExtraChanges
        if(IrSafetyValvePermission == v) return
#endif
        IrSafetyValvePermission = v
#ifdef deb
        print*, 'IrSafetyValvePermission=', IrSafetyValvePermission
#endif
        call OnIrSafetyValvePermissionChange%RunAll()
    end subroutine
    
    logical function Get_IrSafetyValvePermission()
        implicit none
        Get_IrSafetyValvePermission = IrSafetyValvePermission
    end function
    
    
    
    
    subroutine Set_IrSafetyValvePermission_WN(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: Set_IrSafetyValvePermission_WN
    !DEC$ ATTRIBUTES ALIAS: 'Set_IrSafetyValvePermission_WN' :: Set_IrSafetyValvePermission_WN
        implicit none
        logical , intent(in) :: v
        call Set_IrSafetyValvePermission(v)
    end subroutine
    
    logical function Get_IrSafetyValvePermission_WN()
    !DEC$ ATTRIBUTES DLLEXPORT :: Get_IrSafetyValvePermission_WN
    !DEC$ ATTRIBUTES ALIAS: 'Get_IrSafetyValvePermission_WN' :: Get_IrSafetyValvePermission_WN
        implicit none
        Get_IrSafetyValvePermission_WN = IrSafetyValvePermission
    end function
    
    
end module CIrSafetyValvePermissionVariables