module CRemoveFillupHeadPermissionVariables
    use CVoidEventHandlerCollection
    implicit none
    logical :: RemoveFillupHeadPermission = .false.
    
    public
    
    type(VoidEventHandlerCollection) :: OnRemoveFillupHeadPermissionChange
        
    private :: RemoveFillupHeadPermission
    
    contains
    
    subroutine Set_RemoveFillupHeadPermission(v)
        implicit none
        logical , intent(in) :: v
#ifdef ExcludeExtraChanges
        if(RemoveFillupHeadPermission == v) return
#endif
        RemoveFillupHeadPermission = v
#ifdef deb
        print*, 'RemoveFillupHeadPermission=', RemoveFillupHeadPermission
#endif
        call OnRemoveFillupHeadPermissionChange%RunAll()
    end subroutine
    
    logical function Get_RemoveFillupHeadPermission()
        implicit none
        Get_RemoveFillupHeadPermission = RemoveFillupHeadPermission
    end function
    
    
    
    
    subroutine Set_RemoveFillupHeadPermission_WN(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: Set_RemoveFillupHeadPermission_WN
    !DEC$ ATTRIBUTES ALIAS: 'Set_RemoveFillupHeadPermission_WN' :: Set_RemoveFillupHeadPermission_WN
        implicit none
        logical , intent(in) :: v
        call Set_RemoveFillupHeadPermission(v)
    end subroutine
    
    logical function Get_RemoveFillupHeadPermission_WN()
    !DEC$ ATTRIBUTES DLLEXPORT :: Get_RemoveFillupHeadPermission_WN
    !DEC$ ATTRIBUTES ALIAS: 'Get_RemoveFillupHeadPermission_WN' :: Get_RemoveFillupHeadPermission_WN
        implicit none
        Get_RemoveFillupHeadPermission_WN = RemoveFillupHeadPermission
    end function
    
    
end module CRemoveFillupHeadPermissionVariables