module CRemoveMudBucketPermissionVariables
    use CVoidEventHandlerCollection
    implicit none
    logical :: RemoveMudBucketPermission = .false.
    
    public
    
    type(VoidEventHandlerCollection) :: OnRemoveMudBucketPermissionChange
        
    private :: RemoveMudBucketPermission
    
    contains
    
    subroutine Set_RemoveMudBucketPermission(v)
        implicit none
        logical , intent(in) :: v
#ifdef ExcludeExtraChanges
        if(RemoveMudBucketPermission == v) return
#endif
        RemoveMudBucketPermission = v
#ifdef deb
        print*, 'RemoveMudBucketPermission=', RemoveMudBucketPermission
#endif
        call OnRemoveMudBucketPermissionChange%RunAll()
    end subroutine
    
    logical function Get_RemoveMudBucketPermission()
        implicit none
        Get_RemoveMudBucketPermission = RemoveMudBucketPermission
    end function
    
    
    
    
    subroutine Set_RemoveMudBucketPermission_WN(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: Set_RemoveMudBucketPermission_WN
    !DEC$ ATTRIBUTES ALIAS: 'Set_RemoveMudBucketPermission_WN' :: Set_RemoveMudBucketPermission_WN
        implicit none
        logical , intent(in) :: v
        call Set_RemoveMudBucketPermission(v)
    end subroutine
    
    logical function Get_RemoveMudBucketPermission_WN()
    !DEC$ ATTRIBUTES DLLEXPORT :: Get_RemoveMudBucketPermission_WN
    !DEC$ ATTRIBUTES ALIAS: 'Get_RemoveMudBucketPermission_WN' :: Get_RemoveMudBucketPermission_WN
        implicit none
        Get_RemoveMudBucketPermission_WN = RemoveMudBucketPermission
    end function
    
    
end module CRemoveMudBucketPermissionVariables