module CSwingTiltPermissionVariables
    use CVoidEventHandlerCollection
    implicit none
    logical :: SwingTiltPermission = .false.
    
    public
    
    type(VoidEventHandlerCollection) :: OnSwingTiltPermissionChange
        
    private :: SwingTiltPermission
    
    contains
    
    subroutine Set_SwingTiltPermission(v)
        implicit none
        logical , intent(in) :: v
#ifdef ExcludeExtraChanges
        if(SwingTiltPermission == v) return
#endif
        SwingTiltPermission = v
#ifdef deb
        print*, 'SwingTiltPermission=', SwingTiltPermission
#endif
        call OnSwingTiltPermissionChange%RunAll()
    end subroutine
    
    logical function Get_SwingTiltPermission()
        implicit none
        Get_SwingTiltPermission = SwingTiltPermission
    end function
    
    
    
    subroutine Set_SwingTiltPermission_WN(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: Set_SwingTiltPermission_WN
    !DEC$ ATTRIBUTES ALIAS: 'Set_SwingTiltPermission_WN' :: Set_SwingTiltPermission_WN
        implicit none
        logical , intent(in) :: v
        call Set_SwingTiltPermission(v)
    end subroutine
    
    
    logical function Get_SwingTiltPermission_WN()
    !DEC$ ATTRIBUTES DLLEXPORT :: Get_SwingTiltPermission_WN
    !DEC$ ATTRIBUTES ALIAS: 'Get_SwingTiltPermission_WN' :: Get_SwingTiltPermission_WN
        implicit none
        Get_SwingTiltPermission_WN = SwingTiltPermission
    end function
    
end module CSwingTiltPermissionVariables