module CSafetyValveHeight
    use CVoidEventHandlerCollection
    implicit none
    real :: SafetyValveHeight = 0
    
    public
    
    type(VoidEventHandlerCollection) :: OnSafetyValveHeightChange
    
    private :: SafetyValveHeight
    
    contains
    
    
    subroutine Set_SafetyValveHeight(v)
        implicit none
        real , intent(in) :: v
#ifdef ExcludeExtraChanges
        if(SafetyValveHeight == v) return
#endif
        SafetyValveHeight = v
#ifdef deb
        print*, 'SafetyValveHeight=', SafetyValveHeight
#endif
        call OnSafetyValveHeightChange%RunAll()
    end subroutine
    
    real function Get_SafetyValveHeight()
        implicit none
        Get_SafetyValveHeight = SafetyValveHeight
        !Get_SafetyValveHeight = 23
    end function
    
    
    
    
    
    subroutine Set_SafetyValveHeight_WN(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: Set_SafetyValveHeight_WN
    !DEC$ ATTRIBUTES ALIAS: 'Set_SafetyValveHeight_WN' :: Set_SafetyValveHeight_WN
        implicit none
        real , intent(in) :: v
        call Set_SafetyValveHeight(v)
    end subroutine
    
    real function Get_SafetyValveHeight_WN()
    !DEC$ ATTRIBUTES DLLEXPORT :: Get_SafetyValveHeight_WN
    !DEC$ ATTRIBUTES ALIAS: 'Get_SafetyValveHeight_WN' :: Get_SafetyValveHeight_WN
        implicit none
        Get_SafetyValveHeight_WN = SafetyValveHeight
        !Get_SafetyValveHeight_WN = 23
    end function
    
    
    subroutine Subscribe_SafetyValveHeight()
        implicit none
    end subroutine
    
end module CSafetyValveHeight