module TestOperationScenarios
    use CKellyConnectionEnumVariables
    use CElevatorConnectionEnumVariables
    
    use CCloseKellyCockLedNotificationVariables
    use CCloseSafetyValveLedNotificationVariables
    use CFillMouseHoleLedNotificationVariables
    use CIrIBopLedNotificationVariables
    use CIrSafetyValveLedNotificationVariables
    use CLatchLedNotificationVariables
    use COpenKellyCockLedNotificationVariables        
    use COpenSafetyValveLedNotificationVariables
    use CSlipsNotificationVariables
    use CSwingLedNotificationVariables
    use CTongNotificationVariables
    use CUnlatchLedNotificationVariables
    
    use CInstallFillupHeadPermissionVariables
    use CInstallMudBucketPermissionVariables
    use CIrIbopPermissionVariables
    use CIrSafetyValvePermissionVariables
    use CRemoveFillupHeadPermissionVariables
    use CRemoveMudBucketPermissionVariables
    
    use CHookHeight
    use CIbopHeight
    use CNearFloorConnection
    use CSafetyValveHeight
    use CSlackOff
    use CStandRack
    use CStringPressure
    use CZeroStringSpeed
    
    use CUnityInputs
    !, only: &
    !    Get_ElevatorConnectionPossible, &
    !    Get_JointConnectionPossible, &
    !    Get_NearMonkeyBoardPosition, &
    !    Get_NearFloorPosition, &
    !    Get_SingleSetInMouseHole, &
    !    Get_SwingCenter, &
    !    Get_NewHookHeight
    use CUnityOutputs
    
    use CBucketEnumVariables
    use CElevatorEnumVariables
    use CHeadEnumVariables
    use CIbopEnumVariables
    use CKellyEnumVariables
    use CMouseHoleEnumVariables
    use COperationConditionEnumVariables
    use CSafetyValveEnumVariables
    use CSlipsEnumVariables
    use CSwingEnumVariables
    use CTongEnumVariables
    
    use CRigSizeVariables
    use CHoistingVariables
    
    use CFlowPipeDisconnectEnumVariables
    use CFlowKellyDisconnectEnumVariables
    
    use CStringUpdateVariables
    
    implicit none
    public
    contains
    
    
    integer function GetElevatorConnection()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetElevatorConnection
    !DEC$ ATTRIBUTES ALIAS: 'GetElevatorConnection' :: GetElevatorConnection
        implicit none
	    GetElevatorConnection = Get_ElevatorConnection()
        
    end function

    integer function GetKellyConnection()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetKellyConnection
    !DEC$ ATTRIBUTES ALIAS: 'GetKellyConnection' :: GetKellyConnection
        implicit none
	    GetKellyConnection = Get_KellyConnection()
    end function

    
    
    logical function GetCloseKellyCockLedU()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetCloseKellyCockLedU
    !DEC$ ATTRIBUTES ALIAS: 'GetCloseKellyCockLedU' :: GetCloseKellyCockLedU
	    implicit none
	    GetCloseKellyCockLedU = Get_CloseKellyCockLed()
    end function

    logical function GetCloseSafetyValveLedU()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetCloseSafetyValveLedU
    !DEC$ ATTRIBUTES ALIAS: 'GetCloseSafetyValveLedU' :: GetCloseSafetyValveLedU
	    implicit none
	    GetCloseSafetyValveLedU = Get_CloseSafetyValveLed()
    end function

    logical function GetFillMouseHoleLedU()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetFillMouseHoleLedU
    !DEC$ ATTRIBUTES ALIAS: 'GetFillMouseHoleLedU' :: GetFillMouseHoleLedU
	    implicit none
	    GetFillMouseHoleLedU = Get_FillMouseHoleLed()
    end function

    logical function GetIrIBopLedU()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetIrIBopLedU
    !DEC$ ATTRIBUTES ALIAS: 'GetIrIBopLedU' :: GetIrIBopLedU
	    implicit none
	    GetIrIBopLedU = Get_IrIBopLed()
    end function

    logical function GetIrSafetyValveLedU()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetIrSafetyValveLedU
    !DEC$ ATTRIBUTES ALIAS: 'GetIrSafetyValveLedU' :: GetIrSafetyValveLedU
	    implicit none
	    GetIrSafetyValveLedU = Get_IrSafetyValveLed()
    end function

    logical function GetLatchLedU()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetLatchLedU
    !DEC$ ATTRIBUTES ALIAS: 'GetLatchLedU' :: GetLatchLedU
	    implicit none
	    GetLatchLedU = Get_LatchLed()
    end function

    logical function GetOpenKellyCockLedU()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetOpenKellyCockLedU
    !DEC$ ATTRIBUTES ALIAS: 'GetOpenKellyCockLedU' :: GetOpenKellyCockLedU
	    implicit none
	    GetOpenKellyCockLedU = Get_OpenKellyCockLed()
    end function

    logical function GetOpenSafetyValveLedU()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetOpenSafetyValveLedU
    !DEC$ ATTRIBUTES ALIAS: 'GetOpenSafetyValveLedU' :: GetOpenSafetyValveLedU
	    implicit none
	    GetOpenSafetyValveLedU = Get_OpenSafetyValveLed()
    end function

    logical function GetSlipsNotification()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetSlipsNotification
    !DEC$ ATTRIBUTES ALIAS: 'GetSlipsNotification' :: GetSlipsNotification
	    implicit none
	    GetSlipsNotification = Get_SlipsNotification()
    end function

    logical function GetSwingLedU()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetSwingLedU
    !DEC$ ATTRIBUTES ALIAS: 'GetSwingLedU' :: GetSwingLedU
	    implicit none
	    GetSwingLedU = Get_SwingLed()
    end function

    logical function GetTongNotification()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetTongNotification
    !DEC$ ATTRIBUTES ALIAS: 'GetTongNotification' :: GetTongNotification
	    implicit none
	    GetTongNotification = Get_TongNotification()
    end function

    logical function GetUnlatchLed()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetUnlatchLed
    !DEC$ ATTRIBUTES ALIAS: 'GetUnlatchLed' :: GetUnlatchLed
	    implicit none
	    GetUnlatchLed = Get_UnlatchLed()
    end function

    logical function GetInstallFillupHeadPermission()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetInstallFillupHeadPermission
    !DEC$ ATTRIBUTES ALIAS: 'GetInstallFillupHeadPermission' :: GetInstallFillupHeadPermission
	    implicit none
	    GetInstallFillupHeadPermission = Get_InstallFillupHeadPermission()
    end function

    logical function GetInstallMudBucketPermission()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetInstallMudBucketPermission
    !DEC$ ATTRIBUTES ALIAS: 'GetInstallMudBucketPermission' :: GetInstallMudBucketPermission
	    implicit none
	    GetInstallMudBucketPermission = Get_InstallMudBucketPermission()
    end function

    logical function GetIrIbopPermission()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetIrIbopPermission
    !DEC$ ATTRIBUTES ALIAS: 'GetIrIbopPermission' :: GetIrIbopPermission
	    implicit none
	    GetIrIbopPermission = Get_IrIbopPermission()
    end function

    logical function GetIrSafetyValvePermission()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetIrSafetyValvePermission
    !DEC$ ATTRIBUTES ALIAS: 'GetIrSafetyValvePermission' :: GetIrSafetyValvePermission
	    implicit none
	    GetIrSafetyValvePermission = Get_IrSafetyValvePermission()
    end function

    logical function GetRemoveFillupHeadPermission()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetRemoveFillupHeadPermission
    !DEC$ ATTRIBUTES ALIAS: 'GetRemoveFillupHeadPermission' :: GetRemoveFillupHeadPermission
	    implicit none
	    GetRemoveFillupHeadPermission = Get_RemoveFillupHeadPermission()
    end function

    logical function GetRemoveMudBucketPermission()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetRemoveMudBucketPermission
    !DEC$ ATTRIBUTES ALIAS: 'GetRemoveMudBucketPermission' :: GetRemoveMudBucketPermission
	    implicit none
	    GetRemoveMudBucketPermission = Get_RemoveMudBucketPermission()
    end function

    real function GetHookHeightU()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetHookHeightU
    !DEC$ ATTRIBUTES ALIAS: 'GetHookHeightU' :: GetHookHeightU
	    implicit none
	    GetHookHeightU = Get_HookHeight()
    end function

    real(8) function GetIbopHeight()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetIbopHeight
    !DEC$ ATTRIBUTES ALIAS: 'GetIbopHeight' :: GetIbopHeight
	    implicit none
	    GetIbopHeight = Get_IbopHeight()
    end function

    real(8) function GetNearFloorConnection()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetNearFloorConnection
    !DEC$ ATTRIBUTES ALIAS: 'GetNearFloorConnection' :: GetNearFloorConnection
	    implicit none
	    GetNearFloorConnection = Get_NearFloorConnection()
    end function

    real(8) function GetSafetyValveHeight()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetSafetyValveHeight
    !DEC$ ATTRIBUTES ALIAS: 'GetSafetyValveHeight' :: GetSafetyValveHeight
	    implicit none
	    GetSafetyValveHeight = Get_SafetyValveHeight()
    end function

    logical function GetSlackOff()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetSlackOff
    !DEC$ ATTRIBUTES ALIAS: 'GetSlackOff' :: GetSlackOff
	    implicit none
	    GetSlackOff = Get_SlackOff()
    end function

    integer function GetStandRackU()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetStandRackU
    !DEC$ ATTRIBUTES ALIAS: 'GetStandRackU' :: GetStandRackU
	    implicit none
	    GetStandRackU = Get_StandRack()
    end function

    real(8) function GetRotaryRpmU()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetRotaryRpmU
    !DEC$ ATTRIBUTES ALIAS: 'GetRotaryRpmU' :: GetRotaryRpmU
	    implicit none
	    GetRotaryRpmU = GetRotaryRpm()
    end function

    real(8) function GetStringPressure()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetStringPressure
    !DEC$ ATTRIBUTES ALIAS: 'GetStringPressure' :: GetStringPressure
	    implicit none
	    GetStringPressure = Get_StringPressure()
    end function

    logical function GetZeroStringSpeed()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetZeroStringSpeed
    !DEC$ ATTRIBUTES ALIAS: 'GetZeroStringSpeed' :: GetZeroStringSpeed
	    implicit none
	    GetZeroStringSpeed = Get_ZeroStringSpeed()
    end function

    real(8) function GetFlowRateU()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetFlowRateU
    !DEC$ ATTRIBUTES ALIAS: 'GetFlowRateU' :: GetFlowRateU
	    implicit none
	    GetFlowRateU = GetFlowRate()
    end function

    real(8) function GetPedalU()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetPedalU
    !DEC$ ATTRIBUTES ALIAS: 'GetPedalU' :: GetPedalU
	    implicit none
	    GetPedalU = GetPedal()
    end function

    real(8) function GetFloorHeightU()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetFloorHeightU
    !DEC$ ATTRIBUTES ALIAS: 'GetFloorHeightU' :: GetFloorHeightU
	    implicit none
	    GetFloorHeightU = RigFloorHeight
    end function

    real(8) function GetCrownHeightU()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetCrownHeightU
    !DEC$ ATTRIBUTES ALIAS: 'GetCrownHeightU' :: GetCrownHeightU
	    implicit none
	    GetCrownHeightU = CrownHeight
    end function

    real(8) function GetKellyHoseVibrationRateU()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetKellyHoseVibrationRateU
    !DEC$ ATTRIBUTES ALIAS: 'GetKellyHoseVibrationRateU' :: GetKellyHoseVibrationRateU
	    implicit none
	    GetKellyHoseVibrationRateU = GetKellyHoseVibrationRate()
    end function

    integer function GetDriveTypeU()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetDriveTypeU
    !DEC$ ATTRIBUTES ALIAS: 'GetDriveTypeU' :: GetDriveTypeU
	    implicit none
        
	    GetDriveTypeU = DriveType
    end function

    logical function GetElevatorConnectionPossibility()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetElevatorConnectionPossibility
    !DEC$ ATTRIBUTES ALIAS: 'GetElevatorConnectionPossibility' :: GetElevatorConnectionPossibility
	    implicit none
	    GetElevatorConnectionPossibility = Get_ElevatorConnectionPossible()
    end function

    logical function GetJointConnectionPossibility()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetJointConnectionPossibility
    !DEC$ ATTRIBUTES ALIAS: 'GetJointConnectionPossibility' :: GetJointConnectionPossibility
	    implicit none
	    GetJointConnectionPossibility = Get_JointConnectionPossible()
    end function

    logical function GetElevatorPickup()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetElevatorPickup
    !DEC$ ATTRIBUTES ALIAS: 'GetElevatorPickup' :: GetElevatorPickup
	    implicit none
	    GetElevatorPickup = Get_ElevatorPickup()
    end function

    logical function GetNearFloorPosition()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetNearFloorPosition
    !DEC$ ATTRIBUTES ALIAS: 'GetNearFloorPosition' :: GetNearFloorPosition
	    implicit none
	    GetNearFloorPosition = Get_NearFloorPosition()
    end function

    logical function GetSingleSetInMouseHole()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetSingleSetInMouseHole
    !DEC$ ATTRIBUTES ALIAS: 'GetSingleSetInMouseHole' :: GetSingleSetInMouseHole
	    implicit none
	    GetSingleSetInMouseHole = Get_SingleSetInMouseHole()
    end function

    logical function GetSwingCenter()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetSwingCenter
    !DEC$ ATTRIBUTES ALIAS: 'GetSwingCenter' :: GetSwingCenter
	    implicit none
	    !GetSwingCenter = Get_SwingCenter()
	    GetSwingCenter = .false.
    end function

    integer function GetMudBucket()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetMudBucket
    !DEC$ ATTRIBUTES ALIAS: 'GetMudBucket' :: GetMudBucket
	    implicit none
	    GetMudBucket = Get_MudBucket()
    end function

    integer function GetElevator()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetElevator
    !DEC$ ATTRIBUTES ALIAS: 'GetElevator' :: GetElevator
	    implicit none
	    GetElevator = Get_Elevator()
    end function

    integer function GetFlow()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetFlow
    !DEC$ ATTRIBUTES ALIAS: 'GetFlow' :: GetFlow
	    implicit none
	    GetFlow = 0
    end function

    integer function GetFillupHead()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetFillupHead
    !DEC$ ATTRIBUTES ALIAS: 'GetFillupHead' :: GetFillupHead
	    implicit none
	    GetFillupHead = Get_FillupHead()
    end function

    integer function GetIbop()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetIbop
    !DEC$ ATTRIBUTES ALIAS: 'GetIbop' :: GetIbop
	    implicit none
	    GetIbop = Get_Ibop()
    end function

    integer function GetKelly()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetKelly
    !DEC$ ATTRIBUTES ALIAS: 'GetKelly' :: GetKelly
	    implicit none
	    GetKelly = Get_Kelly()
    end function

    integer function GetMouseHole()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetMouseHole
    !DEC$ ATTRIBUTES ALIAS: 'GetMouseHole' :: GetMouseHole
	    implicit none
	    GetMouseHole = Get_MouseHole()
    end function

    integer function GetOperationCondition()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetOperationCondition
    !DEC$ ATTRIBUTES ALIAS: 'GetOperationCondition' :: GetOperationCondition
	    implicit none
	    GetOperationCondition = Get_OperationCondition()
    end function

    integer function GetSafetyValve()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetSafetyValve
    !DEC$ ATTRIBUTES ALIAS: 'GetSafetyValve' :: GetSafetyValve
	    implicit none
	    GetSafetyValve = Get_SafetyValve()
    end function

    integer function GetSlips()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetSlips
    !DEC$ ATTRIBUTES ALIAS: 'GetSlips' :: GetSlips
	    implicit none
	    GetSlips = Get_Slips()
    end function

    integer function GetSwing()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetSwing
    !DEC$ ATTRIBUTES ALIAS: 'GetSwing' :: GetSwing
	    implicit none
	    GetSwing = Get_Swing()
    end function
    
    
    

    integer function GetTong()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetTong
    !DEC$ ATTRIBUTES ALIAS: 'GetTong' :: GetTong
	    implicit none
	    GetTong = Get_Tong()
    end function

    integer function GetStringUpdateU()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetStringUpdateU
    !DEC$ ATTRIBUTES ALIAS: 'GetStringUpdateU' :: GetStringUpdateU
	    implicit none
	    GetStringUpdateU = Get_StringUpdate()
    end function

    
    
    real(8) function GetNewHookHeightU()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetNewHookHeightU
    !DEC$ ATTRIBUTES ALIAS: 'GetNewHookHeightU' :: GetNewHookHeightU
	    implicit none
	    !GetNewHookHeightU = Get_NewHookHeight()
	    GetNewHookHeightU = 0d0
    end function

    real(8) function GetBlowoutFromStringPercentU()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetBlowoutFromStringPercentU
    !DEC$ ATTRIBUTES ALIAS: 'GetBlowoutFromStringPercentU' :: GetBlowoutFromStringPercentU
	    implicit none
	    GetBlowoutFromStringPercentU = GetBlowoutFromStringPercent()
    end function
    
    
    
    
    
    logical function GetMakeupTong()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetMakeupTong
    !DEC$ ATTRIBUTES ALIAS: 'GetMakeupTong' :: GetMakeupTong
	    implicit none
	    !GetMakeupTong = Get_MakeupTong()
	    GetMakeupTong = .false.
    end function

    logical function GetBreakupTong()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetBreakupTong
    !DEC$ ATTRIBUTES ALIAS: 'GetBreakupTong' :: GetBreakupTong
	    implicit none
	    !GetBreakupTong = Get_BreakupTong()
	    GetBreakupTong = .false.
    end function

    logical function GetSlipsSet()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetSlipsSet
    !DEC$ ATTRIBUTES ALIAS: 'GetSlipsSet' :: GetSlipsSet
	    implicit none
	    !GetSlipsSet = Get_SlipsSetU()
	    GetSlipsSet = .false.
    end function

    logical function GetSlipsUnSet()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetSlipsUnSet
    !DEC$ ATTRIBUTES ALIAS: 'GetSlipsUnSet' :: GetSlipsUnSet
	    implicit none
	    !GetSlipsUnSet = Get_SlipsUnSetU()
	    GetSlipsUnSet = .false.
    end function

    logical function GetLatch()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetLatch
    !DEC$ ATTRIBUTES ALIAS: 'GetLatch' :: GetLatch
	    implicit none
	    !GetLatch = Get_Latch()
	    GetLatch = .false.
    end function

    logical function GetUnlatch()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetUnlatch
    !DEC$ ATTRIBUTES ALIAS: 'GetUnlatch' :: GetUnlatch
	    implicit none
	    !GetUnlatch = Get_Unlatch()
	    GetUnlatch = .false.
    end function

    logical function GetOutOfMouseHole()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetOutOfMouseHole
    !DEC$ ATTRIBUTES ALIAS: 'GetOutOfMouseHole' :: GetOutOfMouseHole
	    implicit none
	    !GetOutOfMouseHole = Get_OutOfMouseHole()
	    GetOutOfMouseHole = .false.
    end function
    
    logical function GetIsKellyBushingSetInTable()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetIsKellyBushingSetInTable
    !DEC$ ATTRIBUTES ALIAS: 'GetIsKellyBushingSetInTable' :: GetIsKellyBushingSetInTable
	    implicit none
	    GetIsKellyBushingSetInTable = Get_IsKellyBushingSetInTable()
    end function
    
    
    
    
    
    
    
    
    
    ! TempVars
    logical function GetSignal1U()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetSignal1U
    !DEC$ ATTRIBUTES ALIAS: 'GetSignal1U' :: GetSignal1U
	    implicit none
	    !GetSignal1U = GetSignal1()
	    GetSignal1U = .false.
    end function

    logical function GetSignal2U()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetSignal2U
    !DEC$ ATTRIBUTES ALIAS: 'GetSignal2U' :: GetSignal2U
	    implicit none
	    !GetSignal2U = GetSignal2()
	    GetSignal2U = .false.
    end function

    logical function GetSignal3U()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetSignal3U
    !DEC$ ATTRIBUTES ALIAS: 'GetSignal3U' :: GetSignal3U
	    implicit none
	    !GetSignal3U = GetSignal3()
	    GetSignal3U = .false.
    end function

    logical function GetSignal4U()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetSignal4U
    !DEC$ ATTRIBUTES ALIAS: 'GetSignal4U' :: GetSignal4U
	    implicit none
	    !GetSignal4U = GetSignal4()
	    GetSignal4U = .false.
    end function

    logical function GetSignal5U()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetSignal5U
    !DEC$ ATTRIBUTES ALIAS: 'GetSignal5U' :: GetSignal5U
	    implicit none
	    !GetSignal5U = GetSignal5()
	    GetSignal5U = .false.
    end function

    logical function GetSignal6U()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetSignal6U
    !DEC$ ATTRIBUTES ALIAS: 'GetSignal6U' :: GetSignal6U
	    implicit none
	    !GetSignal6U = GetSignal6()
	    GetSignal6U = .false.
    end function

    logical function GetSignal7U()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetSignal7U
    !DEC$ ATTRIBUTES ALIAS: 'GetSignal7U' :: GetSignal7U
	    implicit none
	    !GetSignal7U = GetSignal7()
	    GetSignal7U = .false.
    end function

    logical function GetSignal8U()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetSignal8U
    !DEC$ ATTRIBUTES ALIAS: 'GetSignal8U' :: GetSignal8U
	    implicit none
	    !GetSignal8U = GetSignal8()
	    GetSignal8U = .false.
    end function

    logical function GetSignal9U()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetSignal9U
    !DEC$ ATTRIBUTES ALIAS: 'GetSignal9U' :: GetSignal9U
	    implicit none
	    !GetSignal9U = GetSignal9()
	    GetSignal9U = .false.
    end function

    logical function GetSignal10U()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetSignal10U
    !DEC$ ATTRIBUTES ALIAS: 'GetSignal10U' :: GetSignal10U
	    implicit none
	    !GetSignal10U = GetSignal10()
	    GetSignal10U = .false.
    end function

    
    real(8) function GetTopJiontHeight()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetTopJiontHeight
    !DEC$ ATTRIBUTES ALIAS: 'GetTopJiontHeight' :: GetTopJiontHeight
        use TD_DrillStemComponents
	    implicit none
	    GetTopJiontHeight = TD_TopJointHeight
    end function
    
    
    
    logical function GetBlowoutFromStringT()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetBlowoutFromStringT
    !DEC$ ATTRIBUTES ALIAS: 'GetBlowoutFromStringT' :: GetBlowoutFromStringT
	    implicit none
	    GetBlowoutFromStringT = Get_BlowoutFromString()
    end function

    logical function GetBlowoutFromAnnularT()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetBlowoutFromAnnularT
    !DEC$ ATTRIBUTES ALIAS: 'GetBlowoutFromAnnularT' :: GetBlowoutFromAnnularT
	    implicit none
	    GetBlowoutFromAnnularT = Get_BlowoutFromAnnular()
    end function

    logical function GetFlowFromReturnLineT()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetFlowFromReturnLineT
    !DEC$ ATTRIBUTES ALIAS: 'GetFlowFromReturnLineT' :: GetFlowFromReturnLineT
	    implicit none
	    GetFlowFromReturnLineT = Get_FlowFromReturnLine()
    end function

    real function GetFlowFromKellyT()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetFlowFromKellyT
    !DEC$ ATTRIBUTES ALIAS: 'GetFlowFromKellyT' :: GetFlowFromKellyT
	    implicit none
	    GetFlowFromKellyT = Get_FlowFromKelly()
    end function

    logical function GetFlowKellyDisconnectT()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetFlowKellyDisconnectT
    !DEC$ ATTRIBUTES ALIAS: 'GetFlowKellyDisconnectT' :: GetFlowKellyDisconnectT
	    implicit none
	    GetFlowKellyDisconnectT = Get_FlowKellyDisconnect()
    end function

    logical function GetFlowPipeDisconnectT()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetFlowPipeDisconnectT
    !DEC$ ATTRIBUTES ALIAS: 'GetFlowPipeDisconnectT' :: GetFlowPipeDisconnectT
	    implicit none
	    GetFlowPipeDisconnectT = Get_FlowPipeDisconnect()
    end function
    
    
    !integer function GetFlowKellyDisconnectT2()
    !!DEC$ ATTRIBUTES DLLEXPORT :: GetFlowKellyDisconnectT2
    !!DEC$ ATTRIBUTES ALIAS: 'GetFlowKellyDisconnectT2' :: GetFlowKellyDisconnectT2
	   ! implicit none
	   ! GetFlowKellyDisconnectT2 = Get_FlowKellyDisconnect2()
    !end function

    !integer function GetFlowPipeDisconnectT2()
    !!DEC$ ATTRIBUTES DLLEXPORT :: GetFlowPipeDisconnectT2
    !!DEC$ ATTRIBUTES ALIAS: 'GetFlowPipeDisconnectT2' :: GetFlowPipeDisconnectT2
	   ! implicit none
	   ! GetFlowPipeDisconnectT2 = Get_FlowPipeDisconnect2()
    !end function
    
    
    logical function GetSingleOutOfMouseHole()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetSingleOutOfMouseHole
    !DEC$ ATTRIBUTES ALIAS: 'GetSingleOutOfMouseHole' :: GetSingleOutOfMouseHole
	    implicit none
	    GetSingleOutOfMouseHole = .true. !Get_SingleOutOfMouseHole()
    end function

    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    integer function GetTdsSwing()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetTdsSwing
    !DEC$ ATTRIBUTES ALIAS: 'GetTdsSwing' :: GetTdsSwing
        use CTdsSwingEnumVariables
	    implicit none
	    GetTdsSwing = Get_TdsSwing()
    end function
    
    integer function GetTdsSpine()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetTdsSpine
    !DEC$ ATTRIBUTES ALIAS: 'GetTdsSpine' :: GetTdsSpine
        use CTdsSpineEnumVariables
	    implicit none
	    GetTdsSpine = Get_TdsSpine()
    end function
    
    integer function GetTdsTong()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetTdsTong
    !DEC$ ATTRIBUTES ALIAS: 'GetTdsTong' :: GetTdsTong
        use CTdsTongEnumVariables
	    implicit none
	    GetTdsTong = Get_TdsTong()
    end function
    
    integer function GetTdsBackupClamp()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetTdsBackupClamp
    !DEC$ ATTRIBUTES ALIAS: 'GetTdsBackupClamp' :: GetTdsBackupClamp
        use CTdsBackupClampVariables
	    implicit none
	    GetTdsBackupClamp = Get_TdsBackupClamp()
    end function
    
    
    
    
    
    logical function GetTdsConnectionPossibility()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetTdsConnectionPossibility
    !DEC$ ATTRIBUTES ALIAS: 'GetTdsConnectionPossibility' :: GetTdsConnectionPossibility
	    implicit none
	    GetTdsConnectionPossibility = Get_TdsConnectionPossible()
    end function
    
    logical function GetTdsStemIn()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetTdsStemIn
    !DEC$ ATTRIBUTES ALIAS: 'GetTdsStemIn' :: GetTdsStemIn
	    implicit none
	    GetTdsStemIn = Get_TdsStemIn()
    end function
    
    
    
    logical function GetFillupHeadPermission()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetFillupHeadPermission
    !DEC$ ATTRIBUTES ALIAS: 'GetFillupHeadPermission' :: GetFillupHeadPermission
        use CFillupHeadPermissionVariables
	    implicit none
	    GetFillupHeadPermission = Get_FillupHeadPermission()
    end function
    
    logical function GetSwingDrillPermission()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetSwingDrillPermission
    !DEC$ ATTRIBUTES ALIAS: 'GetSwingDrillPermission' :: GetSwingDrillPermission
        use CSwingDrillPermissionVariables
	    implicit none
	    GetSwingDrillPermission = Get_SwingDrillPermission()
    end function
    
    logical function GetSwingOffPermission()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetSwingOffPermission
    !DEC$ ATTRIBUTES ALIAS: 'GetSwingOffPermission' :: GetSwingOffPermission
        use CSwingOffPermissionVariables
	    implicit none
	    GetSwingOffPermission = Get_SwingOffPermission()
    end function
    
    logical function GetSwingTiltPermission()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetSwingTiltPermission
    !DEC$ ATTRIBUTES ALIAS: 'GetSwingTiltPermission' :: GetSwingTiltPermission
        use CSwingTiltPermissionVariables
	    implicit none
	    GetSwingTiltPermission = Get_SwingTiltPermission()
    end function
    
    
    real(8) function GetTdsStemJointHeight()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetTdsStemJointHeight
    !DEC$ ATTRIBUTES ALIAS: 'GetTdsStemJointHeight' :: GetTdsStemJointHeight
	    implicit none
	    GetTdsStemJointHeight = 10.0
    end function
    
    
    
    integer function GetTdsConnectionModes()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetTdsConnectionModes
    !DEC$ ATTRIBUTES ALIAS: 'GetTdsConnectionModes' :: GetTdsConnectionModes
        use CTdsConnectionModesEnumVariables
	    implicit none
	    GetTdsConnectionModes = Get_TdsConnectionModes()
    end function
    
    integer function GetTdsElevatorModes()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetTdsElevatorModes
    !DEC$ ATTRIBUTES ALIAS: 'GetTdsElevatorModes' :: GetTdsElevatorModes
        use CTdsElevatorModesEnumVariables
	    implicit none
	    GetTdsElevatorModes = Get_TdsElevatorModes()
    end function
    
end module TestOperationScenarios