module CTdsBackupClampVariables
    use CVoidEventHandlerCollection
    implicit none
    integer :: TdsBackupClamp = 0
    
    public
    
    type(VoidEventHandlerCollection) :: OnTdsBackupClampChange
    
    enum, bind(c)
        enumerator BACKUP_CLAMP_OFF_END
        enumerator BACKUP_CLAMP_OFF_BEGIN
        enumerator BACKUP_CLAMP_FW_BEGIN
        enumerator BACKUP_CLAMP_FW_END
    end enum
    
    private :: TdsBackupClamp
    contains
    
    subroutine Set_TdsBackupClamp(v)
        implicit none
        integer , intent(in) :: v
#ifdef ExcludeExtraChanges
        if(TdsBackupClamp == v) return
#endif
        TdsBackupClamp = v
#ifdef deb
        print*, 'TdsBackupClamp=', TdsBackupClamp
#endif
        call OnTdsBackupClampChange%RunAll()
    end subroutine
    
    integer function Get_TdsBackupClamp()
        implicit none
        Get_TdsBackupClamp = TdsBackupClamp
    end function
    
    
    
    subroutine Set_TdsBackupClamp_WN(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: Set_TdsBackupClamp_WN
    !DEC$ ATTRIBUTES ALIAS: 'Set_TdsBackupClamp_WN' :: Set_TdsBackupClamp_WN
        implicit none
        integer , intent(in) :: v
        call Set_TdsBackupClamp(v)
    end subroutine
    
    integer function Get_TdsBackupClamp_WN()
    !DEC$ ATTRIBUTES DLLEXPORT :: Get_TdsBackupClamp_WN
    !DEC$ ATTRIBUTES ALIAS: 'Get_TdsBackupClamp_WN' :: Get_TdsBackupClamp_WN
        implicit none
        Get_TdsBackupClamp_WN = TdsBackupClamp
    end function
    
    
    
    
    
    subroutine TdsBackupClampFwEnd()
    !DEC$ ATTRIBUTES DLLEXPORT :: TdsBackupClampFwEnd
    !DEC$ ATTRIBUTES ALIAS: 'TdsBackupClampFwEnd' :: TdsBackupClampFwEnd
        implicit none
        call Set_TdsBackupClamp(BACKUP_CLAMP_FW_END)
#ifdef deb
        print*, 'BACKUP_CLAMP_FW_END'
#endif
    end subroutine
    
    
    subroutine TdsBackupClampOffEnd()
    !DEC$ ATTRIBUTES DLLEXPORT :: TdsBackupClampOffEnd
    !DEC$ ATTRIBUTES ALIAS: 'TdsBackupClampOffEnd' :: TdsBackupClampOffEnd
        implicit none
        call Set_TdsBackupClamp(BACKUP_CLAMP_OFF_END)
#ifdef deb
        print*, 'BACKUP_CLAMP_OFF_END'
#endif
    end subroutine
    
    
    
    
end module CTdsBackupClampVariables