module CBopProblems
    use CBopProblemsVariables
	implicit none    
	public 
    contains   
    
    ! Input routines
    
    subroutine SetAnnularWash(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetAnnularWash
    !DEC$ ATTRIBUTES ALIAS: 'SetAnnularWash' :: SetAnnularWash
	    implicit none
	    type(CProblem), intent(in) :: v
	    AnnularWash = SetDue(v, ChangeAnnularWash)
#ifdef deb
	    print*, 'AnnularWash%ProblemType=', AnnularWash%ProblemType
	    print*, 'AnnularWash%StatusType=', AnnularWash%StatusType
	    print*, 'AnnularWash%Value=', AnnularWash%Value
#endif
    end subroutine
    
    subroutine SetAnnularFail(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetAnnularFail
    !DEC$ ATTRIBUTES ALIAS: 'SetAnnularFail' :: SetAnnularFail
	    implicit none
	    type(CProblem), intent(in) :: v
	    AnnularFail = SetDue(v, ChangeAnnularFail)
#ifdef deb
	    print*, 'AnnularFail%ProblemType=', AnnularFail%ProblemType
	    print*, 'AnnularFail%StatusType=', AnnularFail%StatusType
	    print*, 'AnnularFail%Value=', AnnularFail%Value
#endif
    end subroutine

    subroutine SetAnnularLeak(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetAnnularLeak
    !DEC$ ATTRIBUTES ALIAS: 'SetAnnularLeak' :: SetAnnularLeak
	    implicit none
	    type(CProblem), intent(in) :: v
	    AnnularLeak = SetDue(v, ChangeAnnularLeak)
#ifdef deb
	    print*, 'AnnularLeak%ProblemType=', AnnularLeak%ProblemType
	    print*, 'AnnularLeak%StatusType=', AnnularLeak%StatusType
	    print*, 'AnnularLeak%Value=', AnnularLeak%Value
#endif
    end subroutine

    subroutine SetUpperRamWash(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetUpperRamWash
    !DEC$ ATTRIBUTES ALIAS: 'SetUpperRamWash' :: SetUpperRamWash
	    implicit none
	    type(CProblem), intent(in) :: v
	    UpperRamWash = SetDue(v, ChangeUpperRamWash)
#ifdef deb
	    print*, 'UpperRamWash%ProblemType=', UpperRamWash%ProblemType
	    print*, 'UpperRamWash%StatusType=', UpperRamWash%StatusType
	    print*, 'UpperRamWash%Value=', UpperRamWash%Value
#endif
    end subroutine
    
    subroutine SetUpperRamFail(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetUpperRamFail
    !DEC$ ATTRIBUTES ALIAS: 'SetUpperRamFail' :: SetUpperRamFail
	    implicit none
	    type(CProblem), intent(in) :: v
	    UpperRamFail = SetDue(v, ChangeUpperRamFail)
#ifdef deb
	    print*, 'UpperRamFail%ProblemType=', UpperRamFail%ProblemType
	    print*, 'UpperRamFail%StatusType=', UpperRamFail%StatusType
	    print*, 'UpperRamFail%Value=', UpperRamFail%Value
#endif
    end subroutine

    subroutine SetUpperRamLeak(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetUpperRamLeak
    !DEC$ ATTRIBUTES ALIAS: 'SetUpperRamLeak' :: SetUpperRamLeak
	    implicit none
	    type(CProblem), intent(in) :: v
	    UpperRamLeak = SetDue(v, ChangeUpperRamLeak)
#ifdef deb
	    print*, 'UpperRamLeak%ProblemType=', UpperRamLeak%ProblemType
	    print*, 'UpperRamLeak%StatusType=', UpperRamLeak%StatusType
	    print*, 'UpperRamLeak%Value=', UpperRamLeak%Value
#endif
    end subroutine

    subroutine SetMiddleRamWash(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetMiddleRamWash
    !DEC$ ATTRIBUTES ALIAS: 'SetMiddleRamWash' :: SetMiddleRamWash
	    implicit none
	    type(CProblem), intent(in) :: v
	    MiddleRamWash = SetDue(v, ChangeMiddleRamWash)
#ifdef deb
	    print*, 'MiddleRamWash%ProblemType=', MiddleRamWash%ProblemType
	    print*, 'MiddleRamWash%StatusType=', MiddleRamWash%StatusType
	    print*, 'MiddleRamWash%Value=', MiddleRamWash%Value
#endif
    end subroutine
    
    subroutine SetMiddleRamFail(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetMiddleRamFail
    !DEC$ ATTRIBUTES ALIAS: 'SetMiddleRamFail' :: SetMiddleRamFail
	    implicit none
	    type(CProblem), intent(in) :: v
	    MiddleRamFail = SetDue(v, ChangeMiddleRamFail)
#ifdef deb
	    print*, 'MiddleRamFail%ProblemType=', MiddleRamFail%ProblemType
	    print*, 'MiddleRamFail%StatusType=', MiddleRamFail%StatusType
	    print*, 'MiddleRamFail%Value=', MiddleRamFail%Value
#endif
    end subroutine

    subroutine SetMiddleRamLeak(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetMiddleRamLeak
    !DEC$ ATTRIBUTES ALIAS: 'SetMiddleRamLeak' :: SetMiddleRamLeak
	    implicit none
	    type(CProblem), intent(in) :: v
	    MiddleRamLeak = SetDue(v, ChangeMiddleRamLeak)
#ifdef deb
	    print*, 'MiddleRamLeak%ProblemType=', MiddleRamLeak%ProblemType
	    print*, 'MiddleRamLeak%StatusType=', MiddleRamLeak%StatusType
	    print*, 'MiddleRamLeak%Value=', MiddleRamLeak%Value
#endif
    end subroutine

    subroutine SetLowerRamWash(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetLowerRamWash
    !DEC$ ATTRIBUTES ALIAS: 'SetLowerRamWash' :: SetLowerRamWash
	    implicit none
	    type(CProblem), intent(in) :: v
	    LowerRamWash = SetDue(v, ChangeLowerRamWash)
#ifdef deb
	    print*, 'LowerRamWash%ProblemType=', LowerRamWash%ProblemType
	    print*, 'LowerRamWash%StatusType=', LowerRamWash%StatusType
	    print*, 'LowerRamWash%Value=', LowerRamWash%Value
#endif
    end subroutine
    
    subroutine SetLowerRamFail(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetLowerRamFail
    !DEC$ ATTRIBUTES ALIAS: 'SetLowerRamFail' :: SetLowerRamFail
	    implicit none
	    type(CProblem), intent(in) :: v
	    LowerRamFail = SetDue(v, ChangeLowerRamFail)
#ifdef deb
	    print*, 'LowerRamFail%ProblemType=', LowerRamFail%ProblemType
	    print*, 'LowerRamFail%StatusType=', LowerRamFail%StatusType
	    print*, 'LowerRamFail%Value=', LowerRamFail%Value
#endif
    end subroutine

    subroutine SetLowerRamLeak(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetLowerRamLeak
    !DEC$ ATTRIBUTES ALIAS: 'SetLowerRamLeak' :: SetLowerRamLeak
	    implicit none
	    type(CProblem), intent(in) :: v
	    LowerRamLeak = SetDue(v, ChangeLowerRamLeak)
#ifdef deb
	    print*, 'LowerRamLeak%ProblemType=', LowerRamLeak%ProblemType
	    print*, 'LowerRamLeak%StatusType=', LowerRamLeak%StatusType
	    print*, 'LowerRamLeak%Value=', LowerRamLeak%Value
#endif
    end subroutine

    subroutine SetAccumulatorPumpFail(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetAccumulatorPumpFail
    !DEC$ ATTRIBUTES ALIAS: 'SetAccumulatorPumpFail' :: SetAccumulatorPumpFail
	    implicit none
	    type(CProblem), intent(in) :: v
	    AccumulatorPumpFail = SetDue(v, ChangeAccumulatorPumpFail)
#ifdef deb
	    print*, 'AccumulatorPumpFail%ProblemType=', AccumulatorPumpFail%ProblemType
	    print*, 'AccumulatorPumpFail%StatusType=', AccumulatorPumpFail%StatusType
	    print*, 'AccumulatorPumpFail%Value=', AccumulatorPumpFail%Value
#endif
    end subroutine

    subroutine SetAccumulatorPumpLeak(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetAccumulatorPumpLeak
    !DEC$ ATTRIBUTES ALIAS: 'SetAccumulatorPumpLeak' :: SetAccumulatorPumpLeak
	    implicit none
	    type(CProblem), intent(in) :: v
	    AccumulatorPumpLeak = SetDue(v, ChangeAccumulatorPumpLeak)
#ifdef deb
	    print*, 'AccumulatorPumpLeak%ProblemType=', AccumulatorPumpLeak%ProblemType
	    print*, 'AccumulatorPumpLeak%StatusType=', AccumulatorPumpLeak%StatusType
	    print*, 'AccumulatorPumpLeak%Value=', AccumulatorPumpLeak%Value
#endif
    end subroutine

    subroutine SetAccumulatorSystemFail(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetAccumulatorSystemFail
    !DEC$ ATTRIBUTES ALIAS: 'SetAccumulatorSystemFail' :: SetAccumulatorSystemFail
	    implicit none
	    type(CProblem), intent(in) :: v
	    AccumulatorSystemFail = SetDue(v, ChangeAccumulatorSystemFail)
#ifdef deb
	    print*, 'AccumulatorSystemFail%ProblemType=', AccumulatorSystemFail%ProblemType
	    print*, 'AccumulatorSystemFail%StatusType=', AccumulatorSystemFail%StatusType
	    print*, 'AccumulatorSystemFail%Value=', AccumulatorSystemFail%Value
#endif
    end subroutine

    subroutine SetAccumulatorSystemLeak(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetAccumulatorSystemLeak
    !DEC$ ATTRIBUTES ALIAS: 'SetAccumulatorSystemLeak' :: SetAccumulatorSystemLeak
	    implicit none
	    type(CProblem), intent(in) :: v
	    AccumulatorSystemLeak = SetDue(v, ChangeAccumulatorSystemLeak)
#ifdef deb
	    print*, 'AccumulatorSystemLeak%ProblemType=', AccumulatorSystemLeak%ProblemType
	    print*, 'AccumulatorSystemLeak%StatusType=', AccumulatorSystemLeak%StatusType
	    print*, 'AccumulatorSystemLeak%Value=', AccumulatorSystemLeak%Value
#endif
    end subroutine

end module CBopProblems