module CGaugesProblems
	use CGaugesProblemsVariables
	implicit none    
	public 
    contains   	
    
    ! Input routines
    subroutine SetWeightIndicator(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetWeightIndicator
    !DEC$ ATTRIBUTES ALIAS: 'SetWeightIndicator' :: SetWeightIndicator
	    implicit none
	    type(CProblem), intent(in) :: v
	    WeightIndicator = SetDue(v, ChangeWeightIndicator)
#ifdef deb
	    print*, 'WeightIndicator%ProblemType=', WeightIndicator%ProblemType
	    print*, 'WeightIndicator%StatusType=', WeightIndicator%StatusType
	    print*, 'WeightIndicator%Value=', WeightIndicator%Value
#endif
    end subroutine

    subroutine SetRotaryRpm(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetRotaryRpm
    !DEC$ ATTRIBUTES ALIAS: 'SetRotaryRpm' :: SetRotaryRpm
	    implicit none
	    type(CProblem), intent(in) :: v
	    RotaryRpm = SetDue(v, ChangeRotaryRpm)
#ifdef deb
	    print*, 'RotaryRpm%ProblemType=', RotaryRpm%ProblemType
	    print*, 'RotaryRpm%StatusType=', RotaryRpm%StatusType
	    print*, 'RotaryRpm%Value=', RotaryRpm%Value
#endif
    end subroutine

    subroutine SetRotaryTorque(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetRotaryTorque
    !DEC$ ATTRIBUTES ALIAS: 'SetRotaryTorque' :: SetRotaryTorque
	    implicit none
	    type(CProblem), intent(in) :: v
	    RotaryTorque = SetDue(v, ChangeRotaryTorque)
#ifdef deb
	    print*, 'RotaryTorque%ProblemType=', RotaryTorque%ProblemType
	    print*, 'RotaryTorque%StatusType=', RotaryTorque%StatusType
	    print*, 'RotaryTorque%Value=', RotaryTorque%Value
#endif
    end subroutine

    subroutine SetStandPipePressure(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetStandPipePressure
    !DEC$ ATTRIBUTES ALIAS: 'SetStandPipePressure' :: SetStandPipePressure
	    implicit none
	    type(CProblem), intent(in) :: v
	    StandPipePressure = SetDue(v, ChangeStandPipePressure)
#ifdef deb
	    print*, 'StandPipePressure%ProblemType=', StandPipePressure%ProblemType
	    print*, 'StandPipePressure%StatusType=', StandPipePressure%StatusType
	    print*, 'StandPipePressure%Value=', StandPipePressure%Value
#endif
    end subroutine

    subroutine SetCasingPressure(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetCasingPressure
    !DEC$ ATTRIBUTES ALIAS: 'SetCasingPressure' :: SetCasingPressure
	    implicit none
	    type(CProblem), intent(in) :: v
	    CasingPressure = SetDue(v, ChangeCasingPressure)
#ifdef deb
	    print*, 'CasingPressure%ProblemType=', CasingPressure%ProblemType
	    print*, 'CasingPressure%StatusType=', CasingPressure%StatusType
	    print*, 'CasingPressure%Value=', CasingPressure%Value
#endif
    end subroutine

    subroutine SetPump1Strokes(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetPump1Strokes
    !DEC$ ATTRIBUTES ALIAS: 'SetPump1Strokes' :: SetPump1Strokes
	    implicit none
	    type(CProblem), intent(in) :: v
	    Pump1Strokes = SetDue(v, ChangePump1Strokes)
#ifdef deb
	    print*, 'Pump1Strokes%ProblemType=', Pump1Strokes%ProblemType
	    print*, 'Pump1Strokes%StatusType=', Pump1Strokes%StatusType
	    print*, 'Pump1Strokes%Value=', Pump1Strokes%Value
#endif
    end subroutine

    subroutine SetPump2Strokes(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetPump2Strokes
    !DEC$ ATTRIBUTES ALIAS: 'SetPump2Strokes' :: SetPump2Strokes
	    implicit none
	    type(CProblem), intent(in) :: v
	    Pump2Strokes = SetDue(v, ChangePump2Strokes)
#ifdef deb
	    print*, 'Pump2Strokes%ProblemType=', Pump2Strokes%ProblemType
	    print*, 'Pump2Strokes%StatusType=', Pump2Strokes%StatusType
	    print*, 'Pump2Strokes%Value=', Pump2Strokes%Value
#endif
    end subroutine

    subroutine SetReturnLineTemperature(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetReturnLineTemperature
    !DEC$ ATTRIBUTES ALIAS: 'SetReturnLineTemperature' :: SetReturnLineTemperature
	    implicit none
	    type(CProblem), intent(in) :: v
	    ReturnLineTemperature = SetDue(v, ChangeReturnLineTemperature)
#ifdef deb
	    print*, 'ReturnLineTemperature%ProblemType=', ReturnLineTemperature%ProblemType
	    print*, 'ReturnLineTemperature%StatusType=', ReturnLineTemperature%StatusType
	    print*, 'ReturnLineTemperature%Value=', ReturnLineTemperature%Value
#endif
    end subroutine

    subroutine SetTripTank(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetTripTank
    !DEC$ ATTRIBUTES ALIAS: 'SetTripTank' :: SetTripTank
	    implicit none
	    type(CProblem), intent(in) :: v
	    TripTank = SetDue(v, ChangeTripTank)
#ifdef deb
	    print*, 'TripTank%ProblemType=', TripTank%ProblemType
	    print*, 'TripTank%StatusType=', TripTank%StatusType
	    print*, 'TripTank%Value=', TripTank%Value
#endif
    end subroutine

    subroutine SetPitGainLoss(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetPitGainLoss
    !DEC$ ATTRIBUTES ALIAS: 'SetPitGainLoss' :: SetPitGainLoss
	    implicit none
	    type(CProblem), intent(in) :: v
	    PitGainLoss = SetDue(v, ChangePitGainLoss)
#ifdef deb
	    print*, 'PitGainLoss%ProblemType=', PitGainLoss%ProblemType
	    print*, 'PitGainLoss%StatusType=', PitGainLoss%StatusType
	    print*, 'PitGainLoss%Value=', PitGainLoss%Value
#endif
    end subroutine

    subroutine SetMudTankVolume(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetMudTankVolume
    !DEC$ ATTRIBUTES ALIAS: 'SetMudTankVolume' :: SetMudTankVolume
	    implicit none
	    type(CProblem), intent(in) :: v
	    MudTankVolume = SetDue(v, ChangeMudTankVolume)
#ifdef deb
	    print*, 'MudTankVolume%ProblemType=', MudTankVolume%ProblemType
	    print*, 'MudTankVolume%StatusType=', MudTankVolume%StatusType
	    print*, 'MudTankVolume%Value=', MudTankVolume%Value
#endif
    end subroutine

    subroutine SetReturnMudFlow(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetReturnMudFlow
    !DEC$ ATTRIBUTES ALIAS: 'SetReturnMudFlow' :: SetReturnMudFlow
	    implicit none
	    type(CProblem), intent(in) :: v
	    ReturnMudFlow = SetDue(v, ChangeReturnMudFlow)
#ifdef deb
	    print*, 'ReturnMudFlow%ProblemType=', ReturnMudFlow%ProblemType
	    print*, 'ReturnMudFlow%StatusType=', ReturnMudFlow%StatusType
	    print*, 'ReturnMudFlow%Value=', ReturnMudFlow%Value
#endif
    end subroutine

    subroutine SetTorqueLimit(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetTorqueLimit
    !DEC$ ATTRIBUTES ALIAS: 'SetTorqueLimit' :: SetTorqueLimit
	    implicit none
	    type(CProblem), intent(in) :: v
	    TorqueLimit = SetDue(v, ChangeTorqueLimit)
#ifdef deb
	    print*, 'TorqueLimit%ProblemType=', TorqueLimit%ProblemType
	    print*, 'TorqueLimit%StatusType=', TorqueLimit%StatusType
	    print*, 'TorqueLimit%Value=', TorqueLimit%Value
#endif
    end subroutine

    subroutine SetPowerLimit(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetPowerLimit
    !DEC$ ATTRIBUTES ALIAS: 'SetPowerLimit' :: SetPowerLimit
	    implicit none
	    type(CProblem), intent(in) :: v
	    PowerLimit = SetDue(v, ChangePowerLimit)
#ifdef deb
	    print*, 'PowerLimit%ProblemType=', PowerLimit%ProblemType
	    print*, 'PowerLimit%StatusType=', PowerLimit%StatusType
	    print*, 'PowerLimit%Value=', PowerLimit%Value
#endif
    end subroutine

    subroutine SetAccumulatorPressure(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetAccumulatorPressure
    !DEC$ ATTRIBUTES ALIAS: 'SetAccumulatorPressure' :: SetAccumulatorPressure
	    implicit none
	    type(CProblem), intent(in) :: v
	    AccumulatorPressure = SetDue(v, ChangeAccumulatorPressure)
#ifdef deb
	    print*, 'AccumulatorPressure%ProblemType=', AccumulatorPressure%ProblemType
	    print*, 'AccumulatorPressure%StatusType=', AccumulatorPressure%StatusType
	    print*, 'AccumulatorPressure%Value=', AccumulatorPressure%Value
#endif
    end subroutine

    subroutine SetManifoldPressure(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetManifoldPressure
    !DEC$ ATTRIBUTES ALIAS: 'SetManifoldPressure' :: SetManifoldPressure
	    implicit none
	    type(CProblem), intent(in) :: v
	    ManifoldPressure = SetDue(v, ChangeManifoldPressure)
#ifdef deb
	    print*, 'ManifoldPressure%ProblemType=', ManifoldPressure%ProblemType
	    print*, 'ManifoldPressure%StatusType=', ManifoldPressure%StatusType
	    print*, 'ManifoldPressure%Value=', ManifoldPressure%Value
#endif
    end subroutine

    subroutine SetAnnularPressure(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetAnnularPressure
    !DEC$ ATTRIBUTES ALIAS: 'SetAnnularPressure' :: SetAnnularPressure
	    implicit none
	    type(CProblem), intent(in) :: v
	    AnnularPressure = SetDue(v, ChangeAnnularPressure)
#ifdef deb
	    print*, 'AnnularPressure%ProblemType=', AnnularPressure%ProblemType
	    print*, 'AnnularPressure%StatusType=', AnnularPressure%StatusType
	    print*, 'AnnularPressure%Value=', AnnularPressure%Value
#endif
    end subroutine

    subroutine SetRigAirPressure(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetRigAirPressure
    !DEC$ ATTRIBUTES ALIAS: 'SetRigAirPressure' :: SetRigAirPressure
	    implicit none
	    type(CProblem), intent(in) :: v
	    RigAirPressure = SetDue(v, ChangeRigAirPressure)
#ifdef deb
	    print*, 'RigAirPressure%ProblemType=', RigAirPressure%ProblemType
	    print*, 'RigAirPressure%StatusType=', RigAirPressure%StatusType
	    print*, 'RigAirPressure%Value=', RigAirPressure%Value
#endif
    end subroutine

    subroutine SetStandPipe1(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetStandPipe1
    !DEC$ ATTRIBUTES ALIAS: 'SetStandPipe1' :: SetStandPipe1
	    implicit none
	    type(CProblem), intent(in) :: v
	    StandPipe1 = SetDue(v, ChangeStandPipe1)
#ifdef deb
	    print*, 'StandPipe1%ProblemType=', StandPipe1%ProblemType
	    print*, 'StandPipe1%StatusType=', StandPipe1%StatusType
	    print*, 'StandPipe1%Value=', StandPipe1%Value
#endif
    end subroutine

    subroutine SetStandPipe2(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetStandPipe2
    !DEC$ ATTRIBUTES ALIAS: 'SetStandPipe2' :: SetStandPipe2
	    implicit none
	    type(CProblem), intent(in) :: v
	    StandPipe2 = SetDue(v, ChangeStandPipe2)
#ifdef deb
	    print*, 'StandPipe2%ProblemType=', StandPipe2%ProblemType
	    print*, 'StandPipe2%StatusType=', StandPipe2%StatusType
	    print*, 'StandPipe2%Value=', StandPipe2%Value
#endif
    end subroutine

    subroutine SetDrillPipePressure(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetDrillPipePressure
    !DEC$ ATTRIBUTES ALIAS: 'SetDrillPipePressure' :: SetDrillPipePressure
	    implicit none
	    type(CProblem), intent(in) :: v
	    DrillPipePressure = SetDue(v, ChangeDrillPipePressure)
#ifdef deb
	    print*, 'DrillPipePressure%ProblemType=', DrillPipePressure%ProblemType
	    print*, 'DrillPipePressure%StatusType=', DrillPipePressure%StatusType
	    print*, 'DrillPipePressure%Value=', DrillPipePressure%Value
#endif
    end subroutine

    subroutine SetChokePosition(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetChokePosition
    !DEC$ ATTRIBUTES ALIAS: 'SetChokePosition' :: SetChokePosition
	    implicit none
	    type(CProblem), intent(in) :: v
	    ChokePosition = SetDue(v, ChangeChokePosition)
#ifdef deb
	    print*, 'ChokePosition%ProblemType=', ChokePosition%ProblemType
	    print*, 'ChokePosition%StatusType=', ChokePosition%StatusType
	    print*, 'ChokePosition%Value=', ChokePosition%Value
#endif
    end subroutine

    subroutine SetCasingPressure2(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetCasingPressure2
    !DEC$ ATTRIBUTES ALIAS: 'SetCasingPressure2' :: SetCasingPressure2
	    implicit none
	    type(CProblem), intent(in) :: v
	    CasingPressure2 = SetDue(v, ChangeCasingPressure2)
#ifdef deb
	    print*, 'CasingPressure2%ProblemType=', CasingPressure2%ProblemType
	    print*, 'CasingPressure2%StatusType=', CasingPressure2%StatusType
	    print*, 'CasingPressure2%Value=', CasingPressure2%Value
#endif
    end subroutine

end module CGaugesProblems