module CKickProblems
    use CKickProblemsVariables
	implicit none    
	public 
    contains
    
    ! Input routines
    subroutine SetKick(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetKick
    !DEC$ ATTRIBUTES ALIAS: 'SetKick' :: SetKick
	    implicit none
	    type(CProblem), intent(in) :: v
	    Kick = SetDue(v, ChangeKick)
#ifdef deb
	    print*, 'Kick%ProblemType=', Kick%ProblemType
	    print*, 'Kick%StatusType=', Kick%StatusType
	    print*, 'Kick%Value=', Kick%Value
#endif
    end subroutine
    
    subroutine SetFluidTypeP(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetFluidTypeP
    !DEC$ ATTRIBUTES ALIAS: 'SetFluidTypeP' :: SetFluidTypeP
	    implicit none
	    integer, intent(in) :: v
	    FluidType = v
#ifdef deb
	    print*, 'FluidType=', FluidType
#endif
    end subroutine

    subroutine SetFlowRateP(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetFlowRateP
    !DEC$ ATTRIBUTES ALIAS: 'SetFlowRateP' :: SetFlowRateP
	    implicit none
	    real*8, intent(in) :: v
	    FlowRate = v
#ifdef deb
	    print*, 'FlowRate=', FlowRate
#endif
    end subroutine

    subroutine SetOverBalancePressure(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetOverBalancePressure
    !DEC$ ATTRIBUTES ALIAS: 'SetOverBalancePressure' :: SetOverBalancePressure
	    implicit none
	    real*8, intent(in) :: v
	    OverBalancePressure = v
#ifdef deb
	    print*, 'OverBalancePressure=', OverBalancePressure
#endif
    end subroutine

    subroutine SetIsAutoMigrationRateSelectedP(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetIsAutoMigrationRateSelectedP
    !DEC$ ATTRIBUTES ALIAS: 'SetIsAutoMigrationRateSelectedP' :: SetIsAutoMigrationRateSelectedP
	    implicit none
	    logical, intent(in) :: v
	    IsAutoMigrationRateSelected = v
#ifdef deb
	    print*, 'IsAutoMigrationRateSelected=', IsAutoMigrationRateSelected
#endif
    end subroutine

    subroutine SetAutoMigrationRateP(v)
    !DEC$ ATTRIBUTES DLLEXPORT :: SetAutoMigrationRateP
    !DEC$ ATTRIBUTES ALIAS: 'SetAutoMigrationRateP' :: SetAutoMigrationRateP
	    implicit none
	    real*8, intent(in) :: v
	    AutoMigrationRate = v
#ifdef deb
	    print*, 'AutoMigrationRate=', AutoMigrationRate
#endif
    end subroutine

end module CKickProblems