module CStudentStation
	use CStudentStationVariables
    use CManifolds
	implicit none    
	public    
	contains  
	
	! Input routines
	subroutine SetFillupHeadInstallation(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetFillupHeadInstallation
	!DEC$ ATTRIBUTES ALIAS: 'SetFillupHeadInstallation' :: SetFillupHeadInstallation
		implicit none
		logical, intent(in) :: v
		FillupHeadInstallation = v
        if(v)then
            call OnFillupHeadInstallationPress%RunAll()
        else
            call OnFillupHeadRemovePress%RunAll()
        endif
#ifdef deb
		print*, 'FillupHeadInstallation=', FillupHeadInstallation
#endif
	end subroutine

	subroutine SetMudBoxInstallation(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetMudBoxInstallation
	!DEC$ ATTRIBUTES ALIAS: 'SetMudBoxInstallation' :: SetMudBoxInstallation
		implicit none
		logical, intent(in) :: v
		MudBoxInstallation = v
        if(v)then
            call OnMudBoxInstallationPress%RunAll()
        else
            call OnMudBoxRemovePress%RunAll()
        endif
#ifdef deb
		print*, 'MudBoxInstallation=', MudBoxInstallation
#endif
    end subroutine


    subroutine SetTapSelector(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetTapSelector
	!DEC$ ATTRIBUTES ALIAS: 'SetTapSelector' :: SetTapSelector
		implicit none
		logical, intent(in) :: v
		TapSelector = v
#ifdef deb
		print*, 'TapSelector=', TapSelector
#endif
	end subroutine
    
    
    subroutine SetPitGainLossZero(v)
	!DEC$ ATTRIBUTES DLLEXPORT :: SetPitGainLossZero
	!DEC$ ATTRIBUTES ALIAS: 'SetPitGainLossZero' :: SetPitGainLossZero
		implicit none
		logical, intent(in) :: v
		PitGainLossZero = v
#ifdef deb
		print*, 'PitGainLossZero=', PitGainLossZero
#endif
	end subroutine
    
    
    
    
    
    
    
    
    
	! Output routines
	logical function GetFillupHeadInstallation()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetFillupHeadInstallation
    !DEC$ ATTRIBUTES ALIAS: 'GetFillupHeadInstallation' :: GetFillupHeadInstallation
	    implicit none
	    GetFillupHeadInstallation = FillupHeadInstallation
	    !GetFillupHeadInstallation = .true.
    end function

    logical function GetMudBoxInstallation()
    !DEC$ ATTRIBUTES DLLEXPORT :: GetMudBoxInstallation
    !DEC$ ATTRIBUTES ALIAS: 'GetMudBoxInstallation' :: GetMudBoxInstallation
	    implicit none
	    GetMudBoxInstallation = MudBoxInstallation
	    !GetMudBoxInstallation = .true.
    end function
    
    !logical function GetTapSelector()
    !!DEC$ ATTRIBUTES DLLEXPORT :: GetTapSelector
    !!DEC$ ATTRIBUTES ALIAS: 'GetTapSelector' :: GetTapSelector
	   ! implicit none
	   ! GetTapSelector = TapSelector
    !end function
    

end module CStudentStation