module CWarningsActions
    use CIActionReference
    implicit none    
    public 
    
    procedure (ActionBool), pointer :: PumpWithKellyDisconnectedPtr
    procedure (ActionBool), pointer :: PumpWithTopdriveDisconnectedPtr
    procedure (ActionBool), pointer :: Pump1PopOffValveBlownPtr
    procedure (ActionBool), pointer :: Pump1FailurePtr
    procedure (ActionBool), pointer :: Pump2PopOffValveBlownPtr
    procedure (ActionBool), pointer :: Pump2FailurePtr
    procedure (ActionBool), pointer :: Pump3PopOffValveBlownPtr
    procedure (ActionBool), pointer :: Pump3FailurePtr
    procedure (ActionBool), pointer :: DrawworksGearsAbusePtr
    procedure (ActionBool), pointer :: RotaryGearsAbusePtr
    procedure (ActionBool), pointer :: HoistLineBreakPtr
    procedure (ActionBool), pointer :: PartedDrillStringPtr
    procedure (ActionBool), pointer :: ActiveTankOverflowPtr
    procedure (ActionBool), pointer :: ActiveTankUnderVolumePtr
    procedure (ActionBool), pointer :: TripTankOverflowPtr
    procedure (ActionBool), pointer :: DrillPipeTwistOffPtr
    procedure (ActionBool), pointer :: DrillPipePartedPtr
    procedure (ActionBool), pointer :: TripWithSlipsSetPtr
    procedure (ActionBool), pointer :: BlowoutPtr
    procedure (ActionBool), pointer :: UndergroundBlowoutPtr
    procedure (ActionBool), pointer :: MaximumWellDepthExceededPtr
    procedure (ActionBool), pointer :: CrownCollisionPtr
    procedure (ActionBool), pointer :: FloorCollisionPtr
    procedure (ActionBool), pointer :: TopdriveRotaryTableConfilictPtr
    
    contains  
    subroutine SubscribePumpWithKellyDisconnected(a) 
    !DEC$ ATTRIBUTES DLLEXPORT :: SubscribePumpWithKellyDisconnected
    !DEC$ ATTRIBUTES ALIAS: 'SubscribePumpWithKellyDisconnected' :: SubscribePumpWithKellyDisconnected
        implicit none
        procedure (ActionBool) :: a
        PumpWithKellyDisconnectedPtr => a
    end subroutine
    
    subroutine SubscribePumpWithTopdriveDisconnected(a)
	!DEC$ ATTRIBUTES DLLEXPORT :: SubscribePumpWithTopdriveDisconnected
	!DEC$ ATTRIBUTES ALIAS: 'SubscribePumpWithTopdriveDisconnected' :: SubscribePumpWithTopdriveDisconnected
		implicit none
		procedure (ActionBool) :: a
        PumpWithTopdriveDisconnectedPtr => a
    end subroutine
    
    subroutine SubscribePump1PopOffValveBlown(a)
	!DEC$ ATTRIBUTES DLLEXPORT :: SubscribePump1PopOffValveBlown
	!DEC$ ATTRIBUTES ALIAS: 'SubscribePump1PopOffValveBlown' :: SubscribePump1PopOffValveBlown
		implicit none
		procedure (ActionBool) :: a
        Pump1PopOffValveBlownPtr => a
    end subroutine
    
    subroutine SubscribePump1Failure(a)
	!DEC$ ATTRIBUTES DLLEXPORT :: SubscribePump1Failure
	!DEC$ ATTRIBUTES ALIAS: 'SubscribePump1Failure' :: SubscribePump1Failure
		implicit none
		procedure (ActionBool) :: a
        Pump1FailurePtr => a
    end subroutine
    
    subroutine SubscribePump2PopOffValveBlown(a)
	!DEC$ ATTRIBUTES DLLEXPORT :: SubscribePump2PopOffValveBlown
	!DEC$ ATTRIBUTES ALIAS: 'SubscribePump2PopOffValveBlown' :: SubscribePump2PopOffValveBlown
		implicit none
		procedure (ActionBool) :: a
        Pump2PopOffValveBlownPtr => a
    end subroutine
    
    subroutine SubscribePump2Failure(a)
	!DEC$ ATTRIBUTES DLLEXPORT :: SubscribePump2Failure
	!DEC$ ATTRIBUTES ALIAS: 'SubscribePump2Failure' :: SubscribePump2Failure
		implicit none
		procedure (ActionBool) :: a
        Pump2FailurePtr => a
    end subroutine
    
    subroutine SubscribePump3PopOffValveBlown(a)
	!DEC$ ATTRIBUTES DLLEXPORT :: SubscribePump3PopOffValveBlown
	!DEC$ ATTRIBUTES ALIAS: 'SubscribePump3PopOffValveBlown' :: SubscribePump3PopOffValveBlown
		implicit none
		procedure (ActionBool) :: a
        Pump3PopOffValveBlownPtr => a
    end subroutine
    
    subroutine SubscribePump3Failure(a)
	!DEC$ ATTRIBUTES DLLEXPORT :: SubscribePump3Failure
	!DEC$ ATTRIBUTES ALIAS: 'SubscribePump3Failure' :: SubscribePump3Failure
		implicit none
		procedure (ActionBool) :: a
        Pump3FailurePtr => a
    end subroutine
    
    subroutine SubscribeDrawworksGearsAbuse(a)
	!DEC$ ATTRIBUTES DLLEXPORT :: SubscribeDrawworksGearsAbuse
	!DEC$ ATTRIBUTES ALIAS: 'SubscribeDrawworksGearsAbuse' :: SubscribeDrawworksGearsAbuse
		implicit none
		procedure (ActionBool) :: a
        DrawworksGearsAbusePtr => a
    end subroutine
    
    subroutine SubscribeRotaryGearsAbuse(a)
	!DEC$ ATTRIBUTES DLLEXPORT :: SubscribeRotaryGearsAbuse
	!DEC$ ATTRIBUTES ALIAS: 'SubscribeRotaryGearsAbuse' :: SubscribeRotaryGearsAbuse
		implicit none
		procedure (ActionBool) :: a
        RotaryGearsAbusePtr => a
    end subroutine
    
    subroutine SubscribeHoistLineBreak(a)
	!DEC$ ATTRIBUTES DLLEXPORT :: SubscribeHoistLineBreak
	!DEC$ ATTRIBUTES ALIAS: 'SubscribeHoistLineBreak' :: SubscribeHoistLineBreak
		implicit none
		procedure (ActionBool) :: a
        HoistLineBreakPtr => a
    end subroutine
    
    subroutine SubscribePartedDrillString(a)
	!DEC$ ATTRIBUTES DLLEXPORT :: SubscribePartedDrillString
	!DEC$ ATTRIBUTES ALIAS: 'SubscribePartedDrillString' :: SubscribePartedDrillString
		implicit none
		procedure (ActionBool) :: a
        PartedDrillStringPtr => a
    end subroutine
    
    subroutine SubscribeActiveTankOverflow(a)
	!DEC$ ATTRIBUTES DLLEXPORT :: SubscribeActiveTankOverflow
	!DEC$ ATTRIBUTES ALIAS: 'SubscribeActiveTankOverflow' :: SubscribeActiveTankOverflow
		implicit none
		procedure (ActionBool) :: a
        ActiveTankOverflowPtr => a
    end subroutine
    
    subroutine SubscribeActiveTankUnderVolume(a)
	!DEC$ ATTRIBUTES DLLEXPORT :: SubscribeActiveTankUnderVolume
	!DEC$ ATTRIBUTES ALIAS: 'SubscribeActiveTankUnderVolume' :: SubscribeActiveTankUnderVolume
		implicit none
		procedure (ActionBool) :: a
        ActiveTankUnderVolumePtr => a
    end subroutine
    
    subroutine SubscribeTripTankOverflow(a)
	!DEC$ ATTRIBUTES DLLEXPORT :: SubscribeTripTankOverflow
	!DEC$ ATTRIBUTES ALIAS: 'SubscribeTripTankOverflow' :: SubscribeTripTankOverflow
		implicit none
		procedure (ActionBool) :: a
        TripTankOverflowPtr => a
    end subroutine
    
    subroutine SubscribeDrillPipeTwistOff(a)
	!DEC$ ATTRIBUTES DLLEXPORT :: SubscribeDrillPipeTwistOff
	!DEC$ ATTRIBUTES ALIAS: 'SubscribeDrillPipeTwistOff' :: SubscribeDrillPipeTwistOff
		implicit none
		procedure (ActionBool) :: a
        DrillPipeTwistOffPtr => a
    end subroutine
    
    subroutine SubscribeDrillPipeParted(a)
	!DEC$ ATTRIBUTES DLLEXPORT :: SubscribeDrillPipeParted
	!DEC$ ATTRIBUTES ALIAS: 'SubscribeDrillPipeParted' :: SubscribeDrillPipeParted
		implicit none
		procedure (ActionBool) :: a
        DrillPipePartedPtr => a
    end subroutine
    
    subroutine SubscribeTripWithSlipsSet(a)
	!DEC$ ATTRIBUTES DLLEXPORT :: SubscribeTripWithSlipsSet
	!DEC$ ATTRIBUTES ALIAS: 'SubscribeTripWithSlipsSet' :: SubscribeTripWithSlipsSet
		implicit none
		procedure (ActionBool) :: a
        TripWithSlipsSetPtr => a
    end subroutine
    
    subroutine SubscribeBlowout(a)
	!DEC$ ATTRIBUTES DLLEXPORT :: SubscribeBlowout
	!DEC$ ATTRIBUTES ALIAS: 'SubscribeBlowout' :: SubscribeBlowout
		implicit none
		procedure (ActionBool) :: a
        BlowoutPtr => a
    end subroutine
    
    subroutine SubscribeUndergroundBlowout(a)
	!DEC$ ATTRIBUTES DLLEXPORT :: SubscribeUndergroundBlowout
	!DEC$ ATTRIBUTES ALIAS: 'SubscribeUndergroundBlowout' :: SubscribeUndergroundBlowout
		implicit none
		procedure (ActionBool) :: a
        UndergroundBlowoutPtr => a
    end subroutine
    
    subroutine SubscribeMaximumWellDepthExceeded(a)
	!DEC$ ATTRIBUTES DLLEXPORT :: SubscribeMaximumWellDepthExceeded
	!DEC$ ATTRIBUTES ALIAS: 'SubscribeMaximumWellDepthExceeded' :: SubscribeMaximumWellDepthExceeded
		implicit none
		procedure (ActionBool) :: a
        MaximumWellDepthExceededPtr => a
    end subroutine
    
    subroutine SubscribeCrownCollision(a)
	!DEC$ ATTRIBUTES DLLEXPORT :: SubscribeCrownCollision
	!DEC$ ATTRIBUTES ALIAS: 'SubscribeCrownCollision' :: SubscribeCrownCollision
		implicit none
		procedure (ActionBool) :: a
        CrownCollisionPtr => a
    end subroutine
    
    subroutine SubscribeFloorCollision(a)
	!DEC$ ATTRIBUTES DLLEXPORT :: SubscribeFloorCollision
	!DEC$ ATTRIBUTES ALIAS: 'SubscribeFloorCollision' :: SubscribeFloorCollision
		implicit none
		procedure (ActionBool) :: a
        FloorCollisionPtr => a
    end subroutine
    
    subroutine SubscribeTopdriveRotaryTableConfilict(a)
	!DEC$ ATTRIBUTES DLLEXPORT :: SubscribeTopdriveRotaryTableConfilict
	!DEC$ ATTRIBUTES ALIAS: 'SubscribeTopdriveRotaryTableConfilict' :: SubscribeTopdriveRotaryTableConfilict
		implicit none
		procedure (ActionBool) :: a
        TopdriveRotaryTableConfilictPtr => a
    end subroutine
    
end module CWarningsActions