!----------------------------------------------
!             subroutine dia
!----------------------------------------------

subroutine dia(x1,x2,x3,x5,x6,x7)  !dia(t ia w fii x y)
    
     Use Drawworks_VARIABLES

     IMPLICIT NONE
     REAL :: x1,x2,x3,x5,x6,x7
     
        !Drawworks%Vt = x6+Kpi*(Kpn*((30.*Drawworks%w_ref/pi)-(30.*x3/pi))-x2)
        Drawworks%ia_ref = x7+Kpn*((30.0d0*Drawworks%w_ref/pi)-(30.0d0*x3/pi))
        if ( Drawworks%ia_ref>1400. ) then
            Drawworks%ia_ref = 1400.
        end if
        
        Drawworks%Vt = x6+(Kpi*(Drawworks%ia_ref-x2))
        IF (Drawworks%Vt>810.0d0) THEN
            Drawworks%Vt = 810.0d0
        ELSE IF (Drawworks%Vt<0.0d0) THEN
            Drawworks%Vt = 0.0d0
        END IF
        
        IF (x2<=1150.0d0) THEN
            x5 = 6.3304d-3*x2
        ELSE IF (x2>1150.0d0) THEN
            x5 = (2.8571d-7)*(x2-1150.0d0)+7.280d0
        END IF
        
        Drawworks%Ea  = x5*x3
        Drawworks%dia = (Drawworks%Vt-(Ra+Rf)*x2-Drawworks%Ea)/(La+Lf)
        
    end subroutine
    
    
    
    
    
    
    
!----------------------------------------------
!             subroutine dw
!----------------------------------------------
    
subroutine dw(x1,x2,x3,x4,x5)   !x1=t, x2=ia, x3=w, x4=fii, x5=TL
    
    Use Drawworks_VARIABLES
    
    IMPLICIT NONE
    REAL :: x1,x2,x3,x4,x5
       
        IF (x2<=1150.) THEN
            x4 = 6.3304d-3*x2
        ELSE IF (x2>1150.0d0) THEN
            x4 = 2.8571d-7*(x2-1150.0d0)+7.280d0
        END IF
        
        Drawworks%Te = x4*x2
        IF (Drawworks%Conv_Ratio==1.) THEN
            Drawworks%Te = 0.0d0
        END IF
        
        Drawworks%EddyTorque = (1.039d5*exp(4.343d-4*(30.0d0*(x3/Drawworks%Conv_Ratio)/pi)))+(-1.036d5*exp(-.047920d0*(30.0d0*(x3/Drawworks%Conv_Ratio)/pi)))   ![Lbf.ft]
        !IF (Drawworks%EddyTorque>115000.0d0) THEN
        !    Drawworks%EddyTorque = 115000.0d0
        !END IF
        Drawworks%EddyTorque = 1.3558179480d0*Drawworks%EddyTorque      ![N.m]
        
        Drawworks%TL = ((Drawworks%F_fastline*(Drawworks%Diameter/2.0d0))+(Drawworks%EddyTorque*(Drawworks%EddyBreak/100.0d0))+(((Drawworks%Diameter/2.0d0)*Drawworks%BreakLoad)*(Drawworks%ManualBreak/100.0d0)))/Drawworks%Conv_Ratio
        Drawworks%TL = Drawworks%TL/Drawworks%NumberOfTracMotor
        
        Drawworks%dw = (Drawworks%Te-Drawworks%TL)/Drawworks%J_coef
        
end subroutine
    
    
    
    
    
    
    
!----------------------------------------------
!             subroutine dx
!----------------------------------------------

subroutine dx(x1,x2,x3,x4,x5)
    
    Use Drawworks_VARIABLES
    
    IMPLICIT NONE
    REAL :: x1,x2,x3,x4,x5
       
       Drawworks%ia_ref = x5+Kpn*((30.0d0*Drawworks%w_ref/pi)-(30.0d0*x3/pi))
       if ( Drawworks%ia_ref>1400. ) then
            Drawworks%ia_ref = 1400.
       end if
   
       Drawworks%dx = Kii*(Drawworks%ia_ref-x2)       
       
end subroutine
    
    

    
    
    
    
!----------------------------------------------
!             subroutine dy
!----------------------------------------------
    
subroutine dy(x1,x2,x3,x4,x5)
    
    Use Drawworks_VARIABLES
    
    IMPLICIT NONE
    REAL :: x1,x2,x3,x4,x5
   
       Drawworks%dy = Kin*((30.0d0*Drawworks%w_ref/pi)-(30.0d0*x3/pi))
       
end subroutine




    
    
    

!----------------------------------------------
!       subroutine dw_freeTrac_Dmotion
!----------------------------------------------
    
subroutine dw_freeTrac_Dmotion(x1,x2)   !x1=t , x2=w
    
    Use Drawworks_VARIABLES
    
    IMPLICIT NONE
    REAL :: x1, x2
          
         Drawworks%EddyTorque = (1.039d5*exp(4.343d-4*(30.0d0*(x2)/pi)))+(-1.036d5*exp(-.047920d0*(30.0d0*(x2)/pi)))   ![Lbf.ft]
         IF (Drawworks%EddyTorque>115000.0d0) THEN
              Drawworks%EddyTorque = 115000.0d0
         END IF
         Drawworks%EddyTorque = 1.3558179480d0*Drawworks%EddyTorque           ![N.m]
         
         Drawworks%dw_freeTrac_Dmotion = ((Drawworks%F_fastline*(Drawworks%Diameter/2.0d0))-(Drawworks%EddyTorque*(Drawworks%EddyBreak/100.0d0))-(((Drawworks%Diameter/2.0d0)*Drawworks%BreakLoad)*(Drawworks%ManualBreak/100.0d0)))/Drawworks%J_coef
         
end subroutine

    
    
    
    
    
    
    
    
!----------------------------------------------
!           subroutine dw_freeTrac
!----------------------------------------------
subroutine dw_freeTrac(x1,x2)   !x1=t, x2=w
    
    Use Drawworks_VARIABLES
    
    IMPLICIT NONE
    REAL :: x1, x2
          
         Drawworks%EddyTorque = (1.039d5*exp(4.343d-4*(30.0d0*(x2)/pi)))+(-1.036d5*exp(-.047920d0*(30.0d0*(x2)/pi)))   ![Lbf.ft]
         IF (Drawworks%EddyTorque>115000.0d0) THEN
              Drawworks%EddyTorque = 115000.0d0
         END IF
         Drawworks%EddyTorque  = 1.3558179480d0*Drawworks%EddyTorque           ![N.m]
         
         Drawworks%dw_freeTrac = (-(Drawworks%F_fastline*(Drawworks%Diameter/2.0d0))-(Drawworks%EddyTorque*(Drawworks%EddyBreak/100.0d0))-(((Drawworks%Diameter/2.0d0)*Drawworks%BreakLoad)*(Drawworks%ManualBreak/100.0d0)))/Drawworks%J_coef
         
end subroutine
    
    
    
    
    
    
    
    
    
!----------------------------------------------
!       subroutine dw_DawnMotion
!----------------------------------------------
    
subroutine dw_DawnMotion(x1,x2,x3,x4,x5)   !x1=t, x2=ia, x3=w, x4=fii, x5=TL
    
    Use Drawworks_VARIABLES
    
    IMPLICIT NONE
    REAL :: x1,x2,x3,x4,x5
       
        IF (x2<=1150.0d0) THEN
            x4 = 6.3304d-3*x2
        ELSE IF (x2>1150.0d0) THEN
            x4 = 2.8571d-7*(x2-1150.0d0)+7.280d0
        END IF
        
        Drawworks%Te = x4*x2
        
        Drawworks%EddyTorque = (1.039d5*exp(4.343d-4*(30.0d0*(x3/Drawworks%Conv_Ratio)/pi)))+(-1.036d5*exp(-.047920d0*(30.0d0*(x3/Drawworks%Conv_Ratio)/pi)))   ![Lbf.ft]
        IF (Drawworks%EddyTorque>115000.0d0) THEN
            Drawworks%EddyTorque = 115000.0d0
        END IF
        Drawworks%EddyTorque = 1.3558179480d0*Drawworks%EddyTorque           ![N.m]
         
        Drawworks%TL = ((Drawworks%F_fastline*(Drawworks%Diameter/2.0d0))-(Drawworks%EddyTorque*(Drawworks%EddyBreak/100.0d0))-(((Drawworks%Diameter/2.0d0)*Drawworks%BreakLoad)*(Drawworks%ManualBreak/100.0d0)))/Drawworks%Conv_Ratio
        Drawworks%TL = Drawworks%TL/Drawworks%NumberOfTracMotor
        
        Drawworks%dw_DawnMotion = (Drawworks%TL-Drawworks%Te)/Drawworks%J_coef
        
end subroutine