subroutine Drawworks_Free_Traction_motor

    
    use CDrillingConsoleVariables
    use CDataDisplayConsoleVariables
    use Drawworks_VARIABLES
   
    IMPLICIT NONE
   
    
    REAL, allocatable, dimension(:) :: w_array
    Integer :: jj, kk
    REAL    :: sigma_w
    
    
    
    
    
    !Drawworks%w_drum = Drawworks%w/Drawworks%Conv_Ratio
    
    Drawworks%time  = Drawworks%time_step
    Drawworks%dt    = 1.d-5
    Drawworks%error = .001
    
!>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
    
    Drawworks%n = Drawworks%time/Drawworks%dt
    
    if (allocated(w_array))  deallocate(w_array)
    allocate(w_array(0:Drawworks%n))
    w_array(0) = Drawworks%w_drum
    
    Drawworks%i = 1
    
!>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<   
    DO WHILE (Drawworks%i<=Drawworks%n)
        
        
          !>>>>>>>>>>>>  Runge-Kutta Method (2nd order)  <<<<<<<<<<<<<<
          
          call dw_freeTrac((Drawworks%i*Drawworks%dt),Drawworks%w_drum)
          Drawworks%K1w = Drawworks%dt*Drawworks%dw_freeTrac
          
          call dw_freeTrac((Drawworks%i*Drawworks%dt)+(Drawworks%dt),Drawworks%w_drum+(Drawworks%K1w))
          Drawworks%K2w = Drawworks%dt*Drawworks%dw_freeTrac 

          Drawworks%w_new_drum = Drawworks%w_old_drum+((Drawworks%K1w+Drawworks%K2w)/2.)
          
          Drawworks%w_old_drum = Drawworks%w_new_drum
          Drawworks%w_drum     = Drawworks%w_new_drum
          
          w_array(Drawworks%i) = Drawworks%w_new_drum
                                
          Drawworks%i = Drawworks%i+1
        
          
    END DO
!>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

    
    
    
    
   
!>>>>>>>>>  Hook Height Calculation  <<<<<<<<<<<                  
    !>>>>>>>>>>>>  Simpson1/3 Method  <<<<<<<<<<<<<<
    sigma_w = w_array(0)+w_array(Drawworks%n)
    
    do jj = 1,Drawworks%n-1,2
        sigma_w = sigma_w+(4.0d0*w_array(jj))
    end do
              
    do kk = 2,Drawworks%n-2,2
        sigma_w = sigma_w+(2.0d0*w_array(kk))
    end do
              
    Drawworks%Hook_Height = Drawworks%Hook_Height+(((Drawworks%Diameter/2.0d0)*(Drawworks%dt*sigma_w/3.0d0))/Drawworks%NumberOfLine)
        
   
        
    
    

    
        
END subroutine Drawworks_Free_Traction_motor