subroutine Drawworks_Solver_FreeTractionMotor

    Use CDrillingConsoleVariables
    Use CDataDisplayConsoleVariables
    Use CHoistingVariables
    Use CUnityInputs
    Use CHookVariables
    Use COperationConditionEnumVariables
    Use CSlipsEnumVariables
    Use CElevatorConnectionEnumVariables
    Use CTdsConnectionModesEnumVariables
    Use CTdsElevatorModesEnumVariables
    Use Drawworks_VARIABLES
    Use CWarningsVariables
    Use TD_DrillStemComponents
    Use TD_WellGeometry
    Use CWarningsVariables
    Use TD_GeneralData
    Use CSounds
    
    
	IMPLICIT NONE
    
    
    Integer :: j
    Integer :: CrownCollision_Status , FloorCollision_Status , CrownWarning_Status , FloorWarning_Status
    
    
    
    
    
    Call Drawworks_INPUTS
    Drawworks%Conv_Ratio = 1.d0
    
    
    !=====> Drawworks Gears Abuse
    if ( DW_OldTransMode==0 .and. Drawworks%TransMode/=0 .and. Drawworks%w_drum/=0. .and. Drawworks%ClutchMode/=0 ) then
        Call Activate_DrawworksGearsAbuse()
        Drawworks%SoundGearCrash = .true.
        Call SetSoundDwGearCrash(Drawworks%SoundGearCrash)
        Drawworks%ManualBreak = 100.
        !Drawworks%N_ref      = 0.
        Call DWFixModeMotion
        Drawworks%SoundRev = INT(Drawworks%w_drum)  ![rpm] , Integer
        Call SetSoundDwRev( Drawworks%SoundRev )   
        return
    else
        Drawworks%SoundGearCrash = .false.
        Call SetSoundDwGearCrash(Drawworks%SoundGearCrash)
    end if
    if ( DrawworksGearsAbuse==1 ) then
        return
    end if
    
    
    Call Drawworks_Direction
    
    
    
!====================================================
!               Collision & Warning
!====================================================
     
     if ( CrownCollision == .false. ) then
         CrownCollision_Status = 0
     end if
     if ( FloorCollision == .false. ) then
         FloorCollision_Status = 0
     end if
     
     !if ( CrownWarning == .false. ) then
     !    CrownWarning_Status = 0
     !end if
     !if ( FloorWarning == .false. ) then
     !    FloorWarning_Status = 0
     !end if
     
     
     
     
     
     
     
     !====================================================
     !        Crown Collision (Max_Hook_Height)
     !====================================================
     if ( ((3.280839895*Drawworks%Hook_Height)>=Drawworks%max_Hook_Height) .and. (any(DW_DrillModeCond==(/3,4,7,10,11,12,14/))) ) then
         if ( CrownCollision_Status==0 .and. Drawworks%motion==1 ) then
           Call Activate_CrownCollision()
           CrownCollision_Status = 1
           Drawworks%SoundCrownCollision = .true.
           Call SetSoundCrownCollision(Drawworks%SoundCrownCollision)
         else
             Drawworks%SoundCrownCollision = .false.
           Call SetSoundCrownCollision(Drawworks%SoundCrownCollision)
         end if
         do While ( CrownCollision==1 )
             Call DWFixModeMotion
         end do
         if ( Drawworks%motion==-1 ) then
               Drawworks%Hook_Height_final = 3.280839895*Drawworks%Hook_Height    ![ft]
               Call Set_HookHeight(real(Drawworks%Hook_Height_final))
         else
               Call DWFixModeMotion
         end if
         return
     end if
     
     
     
     
     
     
     
     !====================================================
     !        Floor Collision (Min_Hook_Height)
     !====================================================
     if ( ((3.280839895*Drawworks%Hook_Height)<=Drawworks%min_Hook_Height) .and. (any(DW_DrillModeCond==(/3,4,7,10,11,12,14/)))  ) then
         if ( FloorCollision_Status==0 .and. Drawworks%motion==-1 ) then
           Call Activate_FloorCollision()
           Drawworks%SoundFloorCollision = .true.
           Call SetSoundFloorCollision(Drawworks%SoundFloorCollision)
           FloorCollision_Status = 1
         else
           Drawworks%SoundFloorCollision = .false.
           Call SetSoundFloorCollision(Drawworks%SoundFloorCollision)
         end if
         Do While ( FloorCollision ==1 )
             Call DWFixModeMotion
         End Do
         if ( Drawworks%motion==1 ) then
               Drawworks%Hook_Height_final = 3.280839895*Drawworks%Hook_Height    ![ft]
               Call Set_HookHeight(real(Drawworks%Hook_Height_final))
         else
               Call DWFixModeMotion
         end if
         return
     end if
     
     
     
     
     
     
     
     
     !====================================================
     !            Warning (Max_Hook_Height)
     !====================================================
     if ( ((3.280839895*Drawworks%Hook_Height)>=Drawworks%max_Hook_Height) .and. (any(DW_DrillModeCond==(/1,2,5,6,8,9,13/))) ) then
         !if ( CrownWarning_Status==0 .and. Drawworks%motion==1 ) then  ??????????
         !  Call Activate_crownwarning()   ??????????
         !Drawworks%SoundCrownCollision = .true.
         !Call SetSoundCrownCollision(Drawworks%SoundCrownCollision)
         !  CrownWarning_Status = 1   ??????????
         !else
         !  Drawworks%SoundCrownCollision = .false.
         !Call SetSoundCrownCollision(Drawworks%SoundCrownCollision)
         !end if   ??????????
         if ( Drawworks%motion==-1 ) then
               Drawworks%Hook_Height_final = 3.280839895*Drawworks%Hook_Height    ![ft]
               Call Set_HookHeight(real(Drawworks%Hook_Height_final))
         else
               Call DWFixModeMotion
         end if
         return
     end if
     
     
     
     
     
     
     
     !====================================================
     !            Warning (Min_Hook_Height)
     !====================================================
     if ( ((3.280839895*Drawworks%Hook_Height)<=Drawworks%min_Hook_Height) .and. (any(DW_DrillModeCond==(/1,2,5,6,8,9,13/)))  ) then
         !if ( floorwarning_Status==0 .and. Drawworks%motion==-1 ) then  ??????????
         !  Call Activate_floorwarning()   ??????????
         !Drawworks%SoundCrownCollision = .true.
         !Call SetSoundCrownCollision(Drawworks%SoundCrownCollision)
         !  floorwarning_Status = 1   ??????????
         !else
         !Drawworks%SoundCrownCollision = .false.
         !Call SetSoundCrownCollision(Drawworks%SoundCrownCollision)
         !end if   ??????????
         if ( Drawworks%motion==1 ) then
               Drawworks%Hook_Height_final = 3.280839895*Drawworks%Hook_Height    ![ft]
               Call Set_HookHeight(real(Drawworks%Hook_Height_final))
         else
               Call DWFixModeMotion
         end if
         return
     end if
     
     
     
     
     
     
     
     
     
     !====================================================
     ! ELEVATOR CONNECTION STRING (SLIPS SET , No Motion)
     !====================================================
     if ( DriveType==1 .and. Get_Slips() == SLIPS_SET_END .and. Get_ElevatorConnection() == ELEVATOR_CONNECTION_STRING .and. Drawworks%motion/=-1 ) then
         !if ( Drawworks%motion/=-1 ) then
               Call DWFixModeMotion
               return
         !end if
     end if
     
     if ( DriveType==0 .and. Get_Slips() == SLIPS_SET_END .and. (Get_TdsConnectionModes()==TDS_CONNECTION_NOTHING .and. Get_TdsElevatorModes()==TDS_ELEVATOR_CONNECTION_STRING) .and. Drawworks%motion/=-1 ) then
         !if ( Drawworks%motion/=-1 ) then
               Call DWFixModeMotion
               return
         !end if
     end if
     
     
     
     
     
     
     
     
     
     !====================================================
     !       RAM & ToolJoint Collision (Top of RAM)
     !====================================================
      Do j = 2,4  !startup problem ???????
          if ( TD_BOPElementNo(j)/=0 ) then
             if ( ((TD_BOPHeight(j)-TD_BOPThickness)<=(TD_DrillStems(TD_BOPElementNo(j))%TopDepth+TD_DrillStems(TD_BOPElementNo(j))%ToolJointRange)) .and. ((TD_BOPHeight(j)-TD_BOPThickness)>TD_DrillStems(TD_BOPElementNo(j))%TopDepth) .and. (TD_BOPRamDiam(j)<(2.d0*12.d0*TD_DrillStems(TD_BOPElementNo(j))%RtoolJoint)) ) then
                 if ( Drawworks%motion==1 ) then
                    Drawworks%Hook_Height_final = 3.280839895*Drawworks%Hook_Height    ![ft]
                    Call Set_HookHeight(real(Drawworks%Hook_Height_final))
                 else
                    Call DWFixModeMotion
                 end if
                 return
             end if
          end if
      End Do
     
     
     
     
     
     
      
     
     
     !====================================================
     !      RAM & ToolJoint Collision (Bottom of RAM)
     !====================================================
      Do j = 2,4
          if ( TD_BOPElementNo(j)/=0 ) then
             if ( ((TD_BOPHeight(j)+TD_BOPThickness)>=(TD_DrillStems(TD_BOPElementNo(j))%DownDepth-TD_DrillStems(TD_BOPElementNo(j))%ToolJointRange)) .and. ((TD_BOPHeight(j)+TD_BOPThickness)<TD_DrillStems(TD_BOPElementNo(j))%DownDepth) .and. (TD_BOPRamDiam(j)<(2.d0*12.d0*TD_DrillStems(TD_BOPElementNo(j))%RtoolJoint)) ) then
                 if ( Drawworks%motion==-1 ) then
                    Drawworks%Hook_Height_final = 3.280839895*Drawworks%Hook_Height    ![ft]
                    Call Set_HookHeight(real(Drawworks%Hook_Height_final))
                 else
                    Call DWFixModeMotion
                 end if
                 return
             end if
          end if
      End Do
     
     
     
     
      
      
      
      !====================================================
      !               TopDrive (TdsStemIn)
      !====================================================
      if ( (DriveType==0) .and. (Get_TdsStemIn()) .and. Get_Slips() == SLIPS_SET_END  ) then
         if ( Drawworks%motion==1 ) then
               Drawworks%Hook_Height_final = 3.280839895*Drawworks%Hook_Height    ![ft]
               Call Set_HookHeight(real(Drawworks%Hook_Height_final))
         else
               Call DWFixModeMotion
         end if
         return
      end if
      
      
      
      
     
     
     
     
     !print* , 'Drawworks%Hook_Height_final05=' , Drawworks%Hook_Height_final , TD_DrillStemBottom , int(TD_DrillStemBottom*1000.d0) , int((TD_WellTotalLength+TD_DlMax)*1000.d0) , (TD_WellTotalLength+TD_DlMax) , Drawworks%motion , StringIsBottomOfWell
     !=====> BottomHole ROP Condition
     if ( (int(TD_DrillStemBottom*10000.d0)>=(int((TD_WellTotalLength+TD_DlMax)*10000.d0))) .and. (Drawworks%motion==-1 .or. Drawworks%motion==0) ) then
         !print* , 'Drawworks%Hook_Height_final00=' , Drawworks%Hook_Height_final , TD_DrillStemBottom , (TD_WellTotalLength+TD_DlMax)
         if ( StringIsBottomOfWell==0 ) then
             Drawworks%Hook_Height_final = Drawworks%Hook_Height_final+(TD_DrillStemBottom-(TD_WellTotalLength+TD_DlMax))
             StringIsBottomOfWell = 1
             !print* , 'Drawworks%Hook_Height_final01=' , Drawworks%Hook_Height_final , TD_DrillStemBottom , (TD_WellTotalLength+TD_DlMax)
         end if
        Call DWFixModeMotion
        !print* , 'Drawworks%Hook_Height_final02=' , Drawworks%Hook_Height_final
        !print* , 'bef return0'
        return
        !print* , 'aft return0'
     else
         StringIsBottomOfWell = 0
     end if
     
     
     
     
     !print* , 'Drawworks%beffree2=' , DW_OldTransMode , Drawworks%TransMode , Drawworks%w_drum , Drawworks%ClutchMode , Drawworks%N_ref , DWThrottle , DWAcceleretor
     
     
     Drawworks%Hook_Height_final=3.280839895*Drawworks%Hook_Height    ![ft]
     call Set_HookHeight(real(Drawworks%Hook_Height_final))
     Drawworks%HookHeight_graph_output=0.1189*((3.280839895*Drawworks%Hook_Height)-28.0d0)-2.6    ![ft]
     
     
     !print*, 'Drawworks%motion0=' , Drawworks%motion
     !print*, 'Drawworks%Hook_Height_final0=' , Drawworks%Hook_Height_final
     !print*, 'Drawworks%ia_new0=' , Drawworks%ia_new
     !print*, 'Drawworks%ia_ref0=' , Drawworks%ia_ref
     !print*, 'Drawworks%dia0=' , Drawworks%dia
     !print*, 'Drawworks%dw0=' , Drawworks%dw
     !print*, 'Drawworks%w_new0=' , Drawworks%w_new
     
  
end subroutine Drawworks_Solver_FreeTractionMotor