subroutine Drawworks_StartUp

    Use CDrillingConsoleVariables
    Use CHoistingVariables
    Use Drawworks_VARIABLES
    !Use CWarningsVariables
    
	IMPLICIT NONE
    
    
    Integer :: jj, ii
    
    
    
    StringIsBottomOfWell = 0        ! 1=string is at the bottom of the well
    
    
    
    !===> Hook Height
    Drawworks%Hook_Height_ini              = 75.0d0                            ![ft]
    Drawworks%Hook_Height_ini_graph_output = -1.54090d0                        ![ft]
    Drawworks%Hook_Height_inim             = 0.3048*Drawworks%Hook_Height_ini  ![m]
    Drawworks%Hook_Height                  = Drawworks%Hook_Height_inim        ![m]
    Drawworks%Hook_Height_final            = 75.0                              ![ft]
    
    
    
    
    !===> Drum (Drawworks) Diameter
    Drawworks%Diameter = 2.50d0                       ![ft]
    Drawworks%Diameter = 0.3048*Drawworks%Diameter    ![m]
    
    
    
    
    !===> Number of Line
    Drawworks%NumberOfLine = NumberOfLine
    
    
    
    
    !===> Inertia Moment (Drawworks)
    Drawworks%Inertia_Moment = 23.261341               ! 23.261341 [kg.m^2] = 552 [Ib.ft^2]
    !Drawworks%J_coef        = Drawworks%Inertia_Moment+(9.*(Drawworks%Inertia_Moment))
    Drawworks%J_coef         = 1200.0d0                ![kg.m^2]
    
    
    
    
    !===> Simulation time step
    Drawworks%time_step = 0.10d0
    
    
    
    
    
    !CrownCollision = 0
    !FloorCollision = 0
    
    
    
    
    !>>>>>>>>>>>>>>>>>>> Transmission Ratio <<<<<<<<<<<<<<<<<<<
    
    DO ii=-1,1  !ii=clutch mode
        DO jj=-1,1  !jj=transmission mode
            if (ii==0 .or. jj==0) then
                Drawworks%FWD_Conv_Ratio(ii,jj) = 1.
            end if
        End DO
    End DO
    Drawworks%FWD_Conv_Ratio(1,1)   = 1.0d0/.380
    Drawworks%FWD_Conv_Ratio(1,-1)  = 1.0d0/.2170
    Drawworks%FWD_Conv_Ratio(-1,1)  = 1.0d0/.110
    Drawworks%FWD_Conv_Ratio(-1,-1) = 1.0d0/.0630
    
    DW_OldTransMode  = DWTransmisionLever
    DW_OldClutchMode = DWClutchLever
    
    
    
    
    
    !===> motor variables
    Drawworks%w_drum      = 0.
    Drawworks%w_old_drum  = 0.
    Drawworks%w           = 0.
    Drawworks%w_old       = 0.
    Drawworks%ia          = 0.   
    Drawworks%ia_old      = 0.  
    Drawworks%x           = 0.   
    Drawworks%x_old       = 0.  
    Drawworks%y           = 0.   
    Drawworks%y_old       = 0.  
    Drawworks%motion      = 0
    
    
    
    
    
    
end subroutine Drawworks_StartUp