subroutine Drawworks_Traction_motor_ClutchMode_Dir
    
    use CDrillingConsoleVariables
    use CDataDisplayConsoleVariables
    use Drawworks_VARIABLES
 
    IMPLICIT NONE
   
    
    Integer :: jj, kk
    REAL    :: numerator, Denominator
    
    
    
    
!>>>>>>>>>>>>>>>>>>>>>>>  DATA  <<<<<<<<<<<<<<<<<<<<<<<<<<< 
    
    La = 1700.*1d-6
    Lf = 260.*1d-6
    Ra = 9.5*1d-3
    Rf = 5.4*1d-3

    !******** controller *******
    Kpn = 50.0
    Kin = 3.0
    Kpi = 100.0
    Kii = 900.0
    !***************************
    
    Drawworks%time  = Drawworks%time_step
    Drawworks%dt    = 1.d-5
    Drawworks%error = .001
    
!>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
    
    Drawworks%x_Dir      = Drawworks%x
    Drawworks%y_Dir      = Drawworks%y
    Drawworks%w_Dir      = Drawworks%w
    Drawworks%ia_Dir     = Drawworks%ia
    Drawworks%w_old_Dir  = Drawworks%w
    Drawworks%x_old_Dir  = Drawworks%x
    Drawworks%y_old_Dir  = Drawworks%y
    Drawworks%ia_old_Dir = Drawworks%ia
    
    Drawworks%n     = Drawworks%time/Drawworks%dt
    Drawworks%w_ref = (pi*(Drawworks%N_ref)/30.0)
    
    !if (Drawworks%N_ref==0.) then
    !    Drawworks%w_ref = 0.0d0
    !end if
    
    Drawworks%ia_er = 1.
    Drawworks%w_er  = 1.
    Drawworks%x_er  = 1.
    Drawworks%y_er  = 1.
    
    Drawworks%i = 1
    
!>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
    DO WHILE (Drawworks%i<=Drawworks%n)        
   
    
        !>>>>>>>>>>>>  Runge-Kutta Method (4th order)  <<<<<<<<<<<<<<
        call dx((Drawworks%i*Drawworks%dt),Drawworks%ia_Dir,Drawworks%w_Dir,Drawworks%x_Dir,Drawworks%y_Dir)
        call dy((Drawworks%i*Drawworks%dt),Drawworks%ia_Dir,Drawworks%w_Dir,Drawworks%x_Dir,Drawworks%y_Dir)
        call dia((Drawworks%i*Drawworks%dt),Drawworks%ia_Dir,Drawworks%w_Dir,Drawworks%fii,Drawworks%x_Dir,Drawworks%y_Dir)
        call dw((Drawworks%i*Drawworks%dt),Drawworks%ia_Dir,Drawworks%w_Dir,Drawworks%fii,Drawworks%TL)
        Drawworks%K1x  = Drawworks%dt*Drawworks%dx
        Drawworks%K1y  = Drawworks%dt*Drawworks%dy
        Drawworks%K1ia = Drawworks%dt*Drawworks%dia
        Drawworks%K1w  = Drawworks%dt*Drawworks%dw
          
        call dx((Drawworks%i*Drawworks%dt)+(Drawworks%dt/2.),Drawworks%ia_Dir+(Drawworks%K1ia/2.),Drawworks%w_Dir+(Drawworks%K1w/2.),Drawworks%x_Dir+(Drawworks%K1x/2.),Drawworks%y_Dir+(Drawworks%K1y/2.))
        call dy((Drawworks%i*Drawworks%dt)+(Drawworks%dt/2.),Drawworks%ia_Dir+(Drawworks%K1ia/2.),Drawworks%w_Dir+(Drawworks%K1w/2.),Drawworks%x_Dir+(Drawworks%K1x/2.),Drawworks%y_Dir+(Drawworks%K1y/2.))
        call dia((Drawworks%i*Drawworks%dt)+(Drawworks%dt/2.),Drawworks%ia_Dir+(Drawworks%K1ia/2.),Drawworks%w_Dir+(Drawworks%K1w/2.),Drawworks%fii,Drawworks%x_Dir+(Drawworks%K1x/2.),Drawworks%y_Dir+(Drawworks%K1y/2.))
        call dw((Drawworks%i*Drawworks%dt)+(Drawworks%dt/2.),Drawworks%ia_Dir+(Drawworks%K1ia/2.),Drawworks%w_Dir+(Drawworks%K1w/2.),Drawworks%fii,Drawworks%TL)
        Drawworks%K2x  = Drawworks%dt*Drawworks%dx
        Drawworks%K2y  = Drawworks%dt*Drawworks%dy
        Drawworks%K2ia = Drawworks%dt*Drawworks%dia
        Drawworks%K2w  = Drawworks%dt*Drawworks%dw
          
        call dx((Drawworks%i*Drawworks%dt)+(Drawworks%dt/2.),Drawworks%ia_Dir+(Drawworks%K2ia/2.),Drawworks%w_Dir+(Drawworks%K2w/2.),Drawworks%x_Dir+(Drawworks%K2x/2.),Drawworks%y_Dir+(Drawworks%K2y/2.))
        call dy((Drawworks%i*Drawworks%dt)+(Drawworks%dt/2.),Drawworks%ia_Dir+(Drawworks%K2ia/2.),Drawworks%w_Dir+(Drawworks%K2w/2.),Drawworks%x_Dir+(Drawworks%K2x/2.),Drawworks%y_Dir+(Drawworks%K2y/2.))
        call dia((Drawworks%i*Drawworks%dt)+(Drawworks%dt/2.),Drawworks%ia_Dir+(Drawworks%K2ia/2.),Drawworks%w_Dir+(Drawworks%K2w/2.),Drawworks%fii,Drawworks%x_Dir+(Drawworks%K2x/2.),Drawworks%y_Dir+(Drawworks%K2y/2.))
        call dw((Drawworks%i*Drawworks%dt)+(Drawworks%dt/2.),Drawworks%ia_Dir+(Drawworks%K2ia/2.),Drawworks%w_Dir+(Drawworks%K2w/2.),Drawworks%fii,Drawworks%TL)
        Drawworks%K3x  = Drawworks%dt*Drawworks%dx
        Drawworks%K3y  = Drawworks%dt*Drawworks%dy
        Drawworks%K3ia = Drawworks%dt*Drawworks%dia
        Drawworks%K3w  = Drawworks%dt*Drawworks%dw
          
        call dx((Drawworks%i*Drawworks%dt)+Drawworks%dt,Drawworks%ia_Dir+Drawworks%K3ia,Drawworks%w_Dir+Drawworks%K3w,Drawworks%x_Dir+Drawworks%K3x,Drawworks%y_Dir+Drawworks%K3y)
        call dy((Drawworks%i*Drawworks%dt)+Drawworks%dt,Drawworks%ia_Dir+Drawworks%K3ia,Drawworks%w_Dir+Drawworks%K3w,Drawworks%x_Dir+Drawworks%K3x,Drawworks%y_Dir+Drawworks%K3y)
        call dia((Drawworks%i*Drawworks%dt)+Drawworks%dt,Drawworks%ia_Dir+Drawworks%K3ia,Drawworks%w_Dir+Drawworks%K3w,Drawworks%fii,Drawworks%x_Dir+Drawworks%K3x,Drawworks%y_Dir+Drawworks%K3y)
        call dw((Drawworks%i*Drawworks%dt)+Drawworks%dt,Drawworks%ia_Dir+Drawworks%K3ia,Drawworks%w_Dir+Drawworks%K3w,Drawworks%fii,Drawworks%TL)
        Drawworks%K4x  = Drawworks%dt*Drawworks%dx
        Drawworks%K4y  = Drawworks%dt*Drawworks%dy
        Drawworks%K4ia = Drawworks%dt*Drawworks%dia
        Drawworks%K4w  = Drawworks%dt*Drawworks%dw
          
        Drawworks%x_new_Dir  = Drawworks%x_old_Dir+((Drawworks%K1x+(2.0d0*Drawworks%K2x)+(2.0d0*Drawworks%K3x)+Drawworks%K4x)/6.0d0)
        Drawworks%y_new_Dir  = Drawworks%y_old_Dir+((Drawworks%K1y+(2.0d0*Drawworks%K2y)+(2.0d0*Drawworks%K3y)+Drawworks%K4y)/6.0d0)
        Drawworks%ia_new_Dir = Drawworks%ia_old_Dir+((Drawworks%K1ia+(2.0d0*Drawworks%K2ia)+(2.0d0*Drawworks%K3ia)+Drawworks%K4ia)/6.0d0)
        Drawworks%w_new_Dir  = Drawworks%w_old_Dir+((Drawworks%K1w+(2.0d0*Drawworks%K2w)+(2.0d0*Drawworks%K3w)+Drawworks%K4w)/6.0d0)

        Drawworks%x_old_Dir  = Drawworks%x_new_Dir
        Drawworks%y_old_Dir  = Drawworks%y_new_Dir
        Drawworks%ia_old_Dir = Drawworks%ia_new_Dir
        Drawworks%w_old_Dir  = Drawworks%w_new_Dir
        Drawworks%x_Dir      = Drawworks%x_new_Dir
        Drawworks%y_Dir      = Drawworks%y_new_Dir
        Drawworks%ia_Dir     = Drawworks%ia_new_Dir
        Drawworks%w_Dir      = Drawworks%w_new_Dir
        Drawworks%Te         = Drawworks%fii*Drawworks%ia_new_Dir
    
        Drawworks%ia_ref = Drawworks%y_new_Dir+Kpn*((30.0d0*Drawworks%w_ref/pi)-(30.0d0*Drawworks%w_new_Dir/pi))
        if ( Drawworks%ia_ref>1400. ) then
            Drawworks%ia_ref = 1400.
        end if
        
        Drawworks%Vt=Drawworks%x_new_Dir+(Kpi*(Drawworks%ia_ref-Drawworks%ia_new_Dir))
        IF (Drawworks%Vt>810.) THEN
            Drawworks%Vt = 810.0d0
        ELSE IF (Drawworks%Vt<0.) THEN
            Drawworks%Vt = 0.0d0
        END IF
          
        Drawworks%i = Drawworks%i+1
          
          
    END DO          
!>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
    
    
    

    
END subroutine Drawworks_Traction_motor_ClutchMode_Dir