subroutine Drawworks_Traction_motor_dawnmotion
    
    use CDrillingConsoleVariables
    use CDataDisplayConsoleVariables
    use Drawworks_VARIABLES
 
    IMPLICIT NONE
   
    
    Integer :: jj, kk
    REAL    :: numerator, Denominator
    REAL    :: sigma_w
    REAL, allocatable, dimension(:) :: w_array
    
    
    

!>>>>>>>>>>>>>>>>>>>>>>>  DATA  <<<<<<<<<<<<<<<<<<<<<<<<<<<        
    La = 1700.*1d-6
    Lf = 260.*1d-6
    Ra = 9.5*1d-3
    Rf = 5.4*1d-3

    !******** controller *******
    Kpn = 50.0
    Kin = 3.0
    Kpi = 100.0
    Kii = 900.0
    !***************************

    Drawworks%time  = Drawworks%time_step
    Drawworks%dt    = 1.d-5
    Drawworks%error = .001
    
!>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
    
    Drawworks%n     = Drawworks%time/Drawworks%dt
    Drawworks%w_ref = (pi*(Drawworks%N_ref)/30.0)
    
    !if (Drawworks%N_ref==0.) then
    !    Drawworks%w_ref = 0.0d0
    !end if
    
    allocate(w_array(0:Drawworks%n))
    w_array(0) = Drawworks%w/Drawworks%Conv_Ratio
    
    Drawworks%ia_er = 1.
    Drawworks%w_er  = 1.
    Drawworks%x_er  = 1.
    Drawworks%y_er  = 1.
    
    Drawworks%i = 1
    
!>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<   
    DO WHILE (Drawworks%i<=Drawworks%n)        

          
        !>>>>>>>>>>>>  Runge-Kutta Method (4th order)  <<<<<<<<<<<<<<
        call dx((Drawworks%i*Drawworks%dt),Drawworks%ia,Drawworks%w,Drawworks%x,Drawworks%y)
        call dy((Drawworks%i*Drawworks%dt),Drawworks%ia,Drawworks%w,Drawworks%x,Drawworks%y)
        call dia((Drawworks%i*Drawworks%dt),Drawworks%ia,Drawworks%w,Drawworks%fii,Drawworks%x,Drawworks%y)
        call dw_DawnMotion((Drawworks%i*Drawworks%dt),Drawworks%ia,Drawworks%w,Drawworks%fii,Drawworks%TL)
        Drawworks%K1x  = Drawworks%dt*Drawworks%dx
        Drawworks%K1y  = Drawworks%dt*Drawworks%dy
        Drawworks%K1ia = Drawworks%dt*Drawworks%dia
        Drawworks%K1w  = Drawworks%dt*Drawworks%dw_DawnMotion
          
        call dx((Drawworks%i*Drawworks%dt)+(Drawworks%dt/2.),Drawworks%ia+(Drawworks%K1ia/2.),Drawworks%w+(Drawworks%K1w/2.),Drawworks%x+(Drawworks%K1x/2.),Drawworks%y+(Drawworks%K1y/2.))
        call dy((Drawworks%i*Drawworks%dt)+(Drawworks%dt/2.),Drawworks%ia+(Drawworks%K1ia/2.),Drawworks%w+(Drawworks%K1w/2.),Drawworks%x+(Drawworks%K1x/2.),Drawworks%y+(Drawworks%K1y/2.))
        call dia((Drawworks%i*Drawworks%dt)+(Drawworks%dt/2.),Drawworks%ia+(Drawworks%K1ia/2.),Drawworks%w+(Drawworks%K1w/2.),Drawworks%fii,Drawworks%x+(Drawworks%K1x/2.),Drawworks%y+(Drawworks%K1y/2.))
        call dw_DawnMotion((Drawworks%i*Drawworks%dt)+(Drawworks%dt/2.),Drawworks%ia+(Drawworks%K1ia/2.),Drawworks%w+(Drawworks%K1w/2.),Drawworks%fii,Drawworks%TL)
        Drawworks%K2x  = Drawworks%dt*Drawworks%dx
        Drawworks%K2y  = Drawworks%dt*Drawworks%dy
        Drawworks%K2ia = Drawworks%dt*Drawworks%dia
        Drawworks%K2w  = Drawworks%dt*Drawworks%dw_DawnMotion
          
        call dx((Drawworks%i*Drawworks%dt)+(Drawworks%dt/2.),Drawworks%ia+(Drawworks%K2ia/2.),Drawworks%w+(Drawworks%K2w/2.),Drawworks%x+(Drawworks%K2x/2.),Drawworks%y+(Drawworks%K2y/2.))
        call dy((Drawworks%i*Drawworks%dt)+(Drawworks%dt/2.),Drawworks%ia+(Drawworks%K2ia/2.),Drawworks%w+(Drawworks%K2w/2.),Drawworks%x+(Drawworks%K2x/2.),Drawworks%y+(Drawworks%K2y/2.))
        call dia((Drawworks%i*Drawworks%dt)+(Drawworks%dt/2.),Drawworks%ia+(Drawworks%K2ia/2.),Drawworks%w+(Drawworks%K2w/2.),Drawworks%fii,Drawworks%x+(Drawworks%K2x/2.),Drawworks%y+(Drawworks%K2y/2.))
        call dw_DawnMotion((Drawworks%i*Drawworks%dt)+(Drawworks%dt/2.),Drawworks%ia+(Drawworks%K2ia/2.),Drawworks%w+(Drawworks%K2w/2.),Drawworks%fii,Drawworks%TL)
        Drawworks%K3x=Drawworks%dt*Drawworks%dx
        Drawworks%K3y=Drawworks%dt*Drawworks%dy
        Drawworks%K3ia=Drawworks%dt*Drawworks%dia
        Drawworks%K3w=Drawworks%dt*Drawworks%dw_DawnMotion
          
        call dx((Drawworks%i*Drawworks%dt)+Drawworks%dt,Drawworks%ia+Drawworks%K3ia,Drawworks%w+Drawworks%K3w,Drawworks%x+Drawworks%K3x,Drawworks%y+Drawworks%K3y)
        call dy((Drawworks%i*Drawworks%dt)+Drawworks%dt,Drawworks%ia+Drawworks%K3ia,Drawworks%w+Drawworks%K3w,Drawworks%x+Drawworks%K3x,Drawworks%y+Drawworks%K3y)
        call dia((Drawworks%i*Drawworks%dt)+Drawworks%dt,Drawworks%ia+Drawworks%K3ia,Drawworks%w+Drawworks%K3w,Drawworks%fii,Drawworks%x+Drawworks%K3x,Drawworks%y+Drawworks%K3y)
        call dw_DawnMotion((Drawworks%i*Drawworks%dt)+Drawworks%dt,Drawworks%ia+Drawworks%K3ia,Drawworks%w+Drawworks%K3w,Drawworks%fii,Drawworks%TL)
        Drawworks%K4x=Drawworks%dt*Drawworks%dx
        Drawworks%K4y=Drawworks%dt*Drawworks%dy
        Drawworks%K4ia=Drawworks%dt*Drawworks%dia
        Drawworks%K4w=Drawworks%dt*Drawworks%dw_DawnMotion
          
        Drawworks%x_new=Drawworks%x_old+((Drawworks%K1x+(2.0d0*Drawworks%K2x)+(2.0d0*Drawworks%K3x)+Drawworks%K4x)/6.0d0)
        Drawworks%y_new=Drawworks%y_old+((Drawworks%K1y+(2.0d0*Drawworks%K2y)+(2.0d0*Drawworks%K3y)+Drawworks%K4y)/6.0d0)
        Drawworks%ia_new=Drawworks%ia_old+((Drawworks%K1ia+(2.0d0*Drawworks%K2ia)+(2.0d0*Drawworks%K3ia)+Drawworks%K4ia)/6.0d0)
        Drawworks%w_new=Drawworks%w_old+((Drawworks%K1w+(2.0d0*Drawworks%K2w)+(2.0d0*Drawworks%K3w)+Drawworks%K4w)/6.0d0)
          
        Drawworks%x_old=Drawworks%x_new
        Drawworks%y_old=Drawworks%y_new
        Drawworks%ia_old=Drawworks%ia_new
        Drawworks%w_old=Drawworks%w_new
        Drawworks%x=Drawworks%x_new
        Drawworks%y=Drawworks%y_new
        Drawworks%ia=Drawworks%ia_new
        Drawworks%w=Drawworks%w_new
        Drawworks%Te=Drawworks%fii*Drawworks%ia_new
          
        Drawworks%ia_ref = Drawworks%y_new+Kpn*((30.0d0*Drawworks%w_ref/pi)-(30.0d0*Drawworks%w_new/pi))
        if ( Drawworks%ia_ref>1400. ) then
            Drawworks%ia_ref = 1400.
        end if
        
        Drawworks%Vt=Drawworks%x_new+(Kpi*(Drawworks%ia_ref-Drawworks%ia_new))
        IF (Drawworks%Vt>810.) THEN
            Drawworks%Vt=810.0d0
        ELSE IF (Drawworks%Vt<0.) THEN
            Drawworks%Vt=0.0d0
        END IF
           
        w_array(Drawworks%i)=Drawworks%w_new/Drawworks%Conv_Ratio
                  
        Drawworks%i=Drawworks%i+1
        
        
    END DO
!>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
    
    
    
    
    
!>>>>>>>>>  Hook Height Calculation  <<<<<<<<<<<
    !>>>>>>>>>>>>  Simpson 1/3 Method  <<<<<<<<<<<<<<
    sigma_w = w_array(0)+w_array(Drawworks%n)
    
    do jj = 1,Drawworks%n-1,2
        sigma_w = sigma_w+(4.0d0*w_array(jj))
    end do
    
    do kk = 2,Drawworks%n-2,2
        sigma_w = sigma_w+(2.0d0*w_array(kk))
    end do
    
    Drawworks%Hook_Height = Drawworks%Hook_Height-(((Drawworks%Diameter/2.0d0)*(Drawworks%dt*sigma_w/3.0d0))/Drawworks%NumberOfLine)     !m
    
    deallocate(w_array)
    
    
    
    
    
END subroutine Drawworks_Traction_motor_dawnmotion