MODULE Drawworks_VARIABLES
    
    use CDrillingConsoleVariables
    use CDataDisplayConsoleVariables
    
    IMPLICIT NONE
    PUBLIC
    
    
    
    REAL, PARAMETER :: pi=3.14159265
    REAL    :: La, Lf, Ra, Rf
    REAL    :: Kpn, Kin, Kpi, Kii
    INTEGER :: DW_OldTransMode , DW_DrillModeCond , DW_OldClutchMode , StringIsBottomOfWell
    REAL    :: DW_TDHookHeight
    
    
    
!**************************************************************************************************
!**************** Define Drawworks Array ****************************************************
    TYPE, PUBLIC :: Drawworks_Var
    
    
    
!*****  Drawworks_VARIABLES  **********************
    
    INTEGER :: AssignmentSwitch
    INTEGER :: ClutchMode, TransMode, Direction_Var
    INTEGER :: MotorFaileMalf , ClutchEngageMalf , ClutchDisengageMalf
    INTEGER :: motion

    REAL :: Diameter
    !REAL :: motion
    REAL :: EddyTorque, TracTorque, F_fastline
    REAL :: Hook_Height, Hook_Height_ini, Hook_Height_inim, Hook_Height_ini_graph_output, Hook_Height_final, max_Hook_Height, min_Hook_Height, HookHeight_graph_output
    REAL :: N_Throtle, N_Accelarator, Conv_Ratio, Inertia_Moment, NumberOfLine
    REAL :: EddyBreak, ManualBreak, BreakLoad , BrakeLeverCoefficient
    REAL, Dimension(-1:1,-1:1) :: FWD_Conv_Ratio
    
    REAL    :: simulation_time, time_step
    INTEGER :: INT_CPU_TIME, Dt_ref
    
    
!*****  Traction Motor_VARIABLES  *****************
    INTEGER :: i, n
    REAL    :: NumberOfTracMotor
    
    REAL :: TL, Vt, J_coef, Ea, fii, Te
    REAL :: time, dt, zaman
    REAL :: error, ia_er, w_er ,x_er, y_er
    REAL :: K1ia, K2ia, K3ia, K4ia
    REAL :: K1w, K2w, K3w, K4w
    REAL :: K1x, K2x, K3x, K4x
    REAL :: K1y, K2y, K3y, K4y
    REAL :: ia, w, ia_old, w_old, ia_new, w_new
    REAL :: ia_ref, ia_ref_limit, w_ref, N_ref   ! N[rpm]  ,  w[rad/s]
    REAL :: N_new, N_old
    REAL :: x, x_old, x_new
    REAL :: y, y_old, y_new
    REAL :: dia, dw, dx, dy, dw_freeTrac, dw_DawnMotion, dw_freeTrac_Dmotion
    
    REAL :: ia_Dir, w_Dir, ia_old_Dir, w_old_Dir, ia_new_Dir, w_new_Dir, x_Dir, x_old_Dir, x_new_Dir, y_Dir, y_old_Dir, y_new_Dir
    REAL :: w_drum_Dir, w_old_drum_Dir, w_new_drum_Dir, w_drum, w_old_drum, w_new_drum
    
    
!*************  Sound_VARIABLES  **********************
    INTEGER :: SoundFw , SoundRev , SoundDwBrake
    Logical :: SoundBlower , SoundGearCrash
    Logical :: SoundFloorCollision , SoundCrownCollision , SoundClutch
    
    
    
    
    END TYPE Drawworks_Var
    TYPE(Drawworks_Var) :: Drawworks
!***********************************************************************************************
!****************************************************************************************************    
    
    
    
    
    
END MODULE Drawworks_VARIABLES