subroutine DEALLOCATE_ARRAYS_NormalCirculation()    !  is called in module FluidFlowMain
    USE MudSystemVARIABLES
    implicit none


if(allocated(Xstart_PipeSection)) deallocate(Xstart_PipeSection)  
if(allocated(Xend_PipeSection)) deallocate(Xend_PipeSection)        
if(allocated(PipeSection_VolumeCapacity)) deallocate(PipeSection_VolumeCapacity)        
if(allocated(Area_PipeSectionFt)) deallocate(Area_PipeSectionFt)     
if(allocated(OD_PipeSectionInch)) deallocate(OD_PipeSectionInch)        
if(allocated(ID_PipeSectionInch)) deallocate(ID_PipeSectionInch)   
if(allocated(Xstart_OpSection)) deallocate(Xstart_OpSection)  
if(allocated(Xend_OpSection)) deallocate(Xend_OpSection)        
if(allocated(Area_OpSectionFt)) deallocate(Area_OpSectionFt)        
if(allocated(OD_OpSectionInch)) deallocate(OD_OpSectionInch)        
if(allocated(ID_OpSectionInch)) deallocate(ID_OpSectionInch)        
if(allocated(OpSection_VolumeCapacity)) deallocate(OpSection_VolumeCapacity)  
if(allocated(GeoTypeOp)) deallocate(GeoTypeOp)        
if(allocated(GeoType)) deallocate(GeoType)        


            call Hz_MudDischarged_Volume%Empty()
            call Hz_Mud_Backhead_X%Empty()
            call Hz_Mud_Backhead_section%Empty()
            call Hz_Mud_Forehead_X%Empty()
            call Hz_Mud_Forehead_section%Empty()
            call Hz_Density%Empty()
            call Hz_RemainedVolume_in_LastSection%Empty()
            call Hz_EmptyVolume_inBackheadLocation%Empty() 
            call Hz_MudOrKick%Empty()                                        
            
                                
            call St_MudDischarged_Volume%Empty()
            call St_Mud_Backhead_X%Empty()
            call St_Mud_Backhead_section%Empty()
            call St_Mud_Forehead_X%Empty()
            call St_Mud_Forehead_section%Empty()
            call St_Density%Empty()
            call St_RemainedVolume_in_LastSection%Empty()
            call St_EmptyVolume_inBackheadLocation%Empty()  
            call St_MudOrKick%Empty()                                        
            
                
            call Ann_MudDischarged_Volume%Empty()
            call Ann_Mud_Backhead_X%Empty()
            call Ann_Mud_Backhead_section%Empty()
            call Ann_Mud_Forehead_X%Empty()
            call Ann_Mud_Forehead_section%Empty()
            call Ann_Density%Empty()
            call Ann_RemainedVolume_in_LastSection%Empty()
            call Ann_EmptyVolume_inBackheadLocation%Empty()
            call Ann_MudOrKick%Empty() 
            call Ann_CuttingMud%Empty() 
            
            
            call Op_MudDischarged_Volume%Empty()
            call Op_Mud_Backhead_X%Empty()
            call Op_Mud_Backhead_section%Empty()
            call Op_Mud_Forehead_X%Empty()
            call Op_Mud_Forehead_section%Empty()
            call Op_Density%Empty()
            call Op_RemainedVolume_in_LastSection%Empty()
            call Op_EmptyVolume_inBackheadLocation%Empty()
            call Op_MudOrKick%Empty()                                        
            

            call ChokeLine_MudDischarged_Volume%Empty()
            call ChokeLine_Mud_Backhead_X%Empty()
            call ChokeLine_Mud_Backhead_section%Empty()
            call ChokeLine_Mud_Forehead_X%Empty()
            call ChokeLine_Mud_Forehead_section%Empty()
            call ChokeLine_Density%Empty()
            call ChokeLine_RemainedVolume_in_LastSection%Empty()
            call ChokeLine_EmptyVolume_inBackheadLocation%Empty()
            call ChokeLine_MudOrKick%Empty()  
            
            
        call Xend_MudElement%Empty()
        call Xstart_MudElement%Empty()
        call TVDend_MudElement%Empty()
        call TVDstart_MudElement%Empty()
        call Density_MudElement%Empty()
        call MudGeoType%Empty()
        call PipeID_MudElement%Empty()
        call PipeOD_MudElement%Empty()
        call MudType_MudElement%Empty()            
            
        call Xend_OpMudElement%Empty()
        call Xstart_OpMudElement%Empty()
        call TVDend_OpMudElement%Empty()
        call TVDstart_OPMudElement%Empty()
        call Density_OpMudElement%Empty()
        call PipeID_OpMudElement%Empty()
        call PipeOD_OpMudElement%Empty()
        call MudTypeOp_MudElement%Empty()            
            

     
    end subroutine
    
    
    
subroutine RemoveAnnulusMudArrays(ilocal)
    USE MudSystemVARIABLES
    implicit none
    
    INTEGER :: ilocal
    
    
                    call Ann_MudDischarged_Volume%Remove (ilocal)
                    call Ann_Mud_Backhead_X%Remove (ilocal)
                    call Ann_Mud_Backhead_section%Remove (ilocal)
                    call Ann_Mud_Forehead_X%Remove (ilocal)
                    call Ann_Mud_Forehead_section%Remove (ilocal)
                    call Ann_Density%Remove (ilocal)
                    call Ann_RemainedVolume_in_LastSection%Remove (ilocal)
                    call Ann_EmptyVolume_inBackheadLocation%Remove (ilocal)
                    call Ann_MudOrKick%Remove (ilocal)
                    call Ann_CuttingMud%Remove (ilocal)     
    
    
    
    end subroutine
    
    
subroutine RemoveStringMudArrays(ilocal)
    USE MudSystemVARIABLES
    implicit none
    
    INTEGER :: ilocal
    
    
                    call St_MudDischarged_Volume%Remove (ilocal)
                    call St_Mud_Backhead_X%Remove (ilocal)
                    call St_Mud_Backhead_section%Remove (ilocal)
                    call St_Mud_Forehead_X%Remove (ilocal)
                    call St_Mud_Forehead_section%Remove (ilocal)
                    call St_Density%Remove (ilocal)
                    call St_RemainedVolume_in_LastSection%Remove (ilocal)
                    call St_EmptyVolume_inBackheadLocation%Remove (ilocal)
                    call St_MudOrKick%Remove (ilocal)    
    
    
    
    end subroutine    
    
    
subroutine RemoveOpMudArrays(ilocal)
    USE MudSystemVARIABLES
    implicit none
    
    INTEGER :: ilocal
    
    
                    call Op_MudDischarged_Volume%Remove (ilocal)
                    call Op_Mud_Backhead_X%Remove (ilocal)
                    call Op_Mud_Backhead_section%Remove (ilocal)
                    call Op_Mud_Forehead_X%Remove (ilocal)
                    call Op_Mud_Forehead_section%Remove (ilocal)
                    call Op_Density%Remove (ilocal)
                    call Op_RemainedVolume_in_LastSection%Remove (ilocal)
                    call Op_EmptyVolume_inBackheadLocation%Remove (ilocal)
                    call Op_MudOrKick%Remove (ilocal)    
    
    
    
    end subroutine      
    
subroutine RemoveHzMudArrays(ilocal)
    USE MudSystemVARIABLES
    implicit none
    
    INTEGER :: ilocal
    
    
                    call Hz_MudDischarged_Volume%Remove (ilocal)
                    call Hz_Mud_Backhead_X%Remove (ilocal)
                    call Hz_Mud_Backhead_section%Remove (ilocal)
                    call Hz_Mud_Forehead_X%Remove (ilocal)
                    call Hz_Mud_Forehead_section%Remove (ilocal)
                    call Hz_Density%Remove (ilocal)
                    call Hz_RemainedVolume_in_LastSection%Remove (ilocal)
                    call Hz_EmptyVolume_inBackheadLocation%Remove (ilocal)
                    call Hz_MudOrKick%Remove (ilocal)    
    
    
    
     end subroutine      
   