MODULE Pump_VARIABLES
    
    
    IMPLICIT NONE
    PUBLIC
    
    
    REAL , PARAMETER :: pi=3.14159265
    REAL :: La, Lf, Ra, Rf
    REAL :: Kpn, Kin, Kpi, Kii
    REAL :: Total_Pump_GPM, Total_Pump_SPM, Total_Stroke_Counter_For_Plot
    
!****************************************************************************************************    
!**************** Define PUMP Array ************************************************************
    TYPE, PUBLIC :: Pump_Var
        
!*****  Pump_VARIABLES  ***************************
    INTEGER :: j , AssignmentSwitchh
    INTEGER :: PowerFailMalf , BlowPopOffMalf , SPMGaugeMalf

    REAL :: Stroke_Length, Piston_Area, Piston_Diameter, Inertia_Moment
    REAL :: Mech_Efficiency, Vol_Efficiency, Trans_Ratio
    REAL :: StandPipe_Pressure , Max_Pressure
    REAL :: Torque, Speed
    REAL :: Flow_Rate, Hydraulic_HorsePower, TracMotor_Horsepower , Max_Horsepower
    REAL :: simulation_time, time_step
    
    REAL(8) :: START_TIME, END_TIME
    INTEGER :: INT_CPU_TIME, Dt_ref
    
!*****  Traction Motor_VARIABLES  *****************
    INTEGER :: i, n
    
    REAL :: TL, Vt, J_coef, Ea, fii, Te
    REAL :: time, dt, zaman
    REAL :: ia, w, ia_old, w_old, ia_new, w_new
    REAL :: error, ia_er, w_er ,x_er, y_er
    REAL :: K1ia, K1w, K2ia, K2w, K3ia, K3w, K4ia, K4w
    REAL :: K1x, K1y, K2x, K2y, K3x, K3y, K4x, K4y
    REAL :: ia_ref, w_ref, N_ref   ! N(rpm)  ,  w(rad/s)
    REAL :: x, y, x_old, y_old, x_new, y_new
    REAL :: dia, dw, dx
    REAL :: N_new, N_old
    REAL :: Vt_old
    
    
!*************  Sound_VARIABLES  **********************
    INTEGER :: SoundSPM
    Logical :: SoundBlower
    
    
    END TYPE Pump_Var

    TYPE(Pump_Var), DIMENSION(1:3) :: PUMP
!***********************************************************************************************   
!****************************************************************************************************    
    
    
    
    
END MODULE Pump_VARIABLES