MODULE TopDrive_VARIABLES
    
    IMPLICIT NONE
    PUBLIC
    
    REAL, PARAMETER :: pi=3.14159265
    REAL :: La, Lf, Ra, Rf
    REAL :: Kpn, Kin, Kpi, Kii
    REAL :: TDS_wOld
    
    INTEGER :: TDS_OldTransMode , TDS_OldPowerMode
    REAL    :: TD_RPMUnityOutput
    
    
!****************************************************************************************************    
!**************** Difine Top Drive Array ****************************************************
    TYPE, PUBLIC :: TDS_Var
    
!*****  TopDrive_VARIABLES  *************************
    INTEGER :: j
    INTEGER :: MotorFaileMalf , OverideTorqueLimitMalf
    
    REAL :: Horsepower, Speed, Output_Current, Inertia_Moment, Mech_Efficiency, Torque
    REAL :: Conv_Ratio, High_Conv_Ratio, Low_Conv_Ratio
    REAL :: String_Torque, String_JCoef
    REAL :: TracTorque, ConstLoad
    REAL :: simulation_time, time_step
    
    INTEGER :: Dt_ref
    
!*****  Traction Motor_VARIABLES  *****************
    INTEGER :: i, n
    
    REAL :: TL, Vt, J_coef, Ea, fii, Te
    REAL :: time, dt, zaman
    REAL :: ia, w, ia_old, w_old, ia_new, w_new
    REAL :: error, ia_er, w_er ,x_er, y_er
    REAL :: K1ia, K1w, K2ia, K2w, K3ia, K3w, K4ia, K4w
    REAL :: K1x, K1y, K2x, K2y, K3x, K3y, K4x, K4y
    REAL :: ia_ref, ia_ref_limit, w_ref, N_ref   ! N(rpm)  ,  w(rad/s)
    REAL :: x, y, x_old, y_old, x_new, y_new
    REAL :: dia, dw, dx, dy
    REAL :: N_new, N_old
    
    
!*************  Sound_VARIABLES  **********************
    INTEGER :: SoundRPM
    Logical :: SoundBlower , SoundGearCrash
    
    

    END TYPE TDS_Var

    TYPE(TDS_Var) :: TDS
!***********************************************************************************************   
!****************************************************************************************************    
 
    
    
    
END MODULE