subroutine TD_WellGeoConfiguration
    
   Use TD_DrillStemComponents
   Use TD_WellElements
   Use TD_WellGeometry
   Use TD_GeneralData
   Use sROP_Variables
   Use CDataDisplayConsoleVariables
   Use CWarningsVariables
   
   

   implicit none 
  

!====================================================
!         Well Geometry Data Modification
!====================================================
   
   
!=====> ROP Calculation
   if ( TD_DrillStems(1)%ComponentType==0 .and. MaximumWellDepthExceeded==.false. ) then
       Call ROP_MainCalculation
   else
       Rate_of_Penetration = 0.d0
       Call Set_ROP(Rate_of_Penetration)
   end if
   
   
   
   
!=====> ROPHole Data correction
   TD_ROP = (Rate_of_Penetration/3600.d0)   ! [ft/s]
   TD_WellGeo(TD_WellIntervalsCount)%VerticalDepth  = TD_WellGeo(TD_WellIntervalsCount)%VerticalDepth++((TD_ROP*TD_TimeStep)*cos(TD_WellGeo(TD_WellIntervalsCount)%StartAngle))
   TD_WellGeo(TD_WellIntervalsCount)%IntervalLength = TD_WellGeo(TD_WellIntervalsCount)%IntervalLength+(TD_ROP*TD_TimeStep)           !????????check
   TD_WellGeo(TD_WellIntervalsCount)%DownDepth      = TD_WellGeo(TD_WellIntervalsCount)%TopDepth+TD_WellGeo(TD_WellIntervalsCount)%IntervalLength
   
   
   
  
   
!=====> Well Total Length Calculation 
   TD_WellTotalLength         = TD_WellGeo(TD_WellIntervalsCount)%DownDepth
   TD_WellTotalVerticalLength = TD_WellTotalVerticalLength+((TD_ROP*TD_TimeStep)*cos(TD_WellGeo(TD_WellIntervalsCount)%StartAngle))
   
   Call Set_TotalDepth(real(TD_WellTotalLength,8))
   
   
   
   
end subroutine