subroutine TVD_Calculator(MeasuredDepth,VerticalDepth)

   Use TD_DrillStemComponents
   Use TD_WellElements
   Use TD_WellGeometry
   Use TD_StringConnectionData
   

   implicit none

   Integer  :: kk
   REAL(8)  :: MeasuredDepth , VerticalDepth
   REAL(8)  :: mm , nn , dl , StartAngle , EndAngle
   
   
   
   
   
   if ( MeasuredDepth<=0. ) then
       VerticalDepth = MeasuredDepth
       !Angle(ii) = 0.d0
       return
   end if
   
   
   
   mm       = 0.d0    !last vertical depth
   nn       = 0.d0    !last measured depth
   EndAngle = TD_WellGeo(1)%StartAngle
   !Angle(jj) = EndAngle
   
   do kk = 1, TD_WellIntervalsCount
           StartAngle = EndAngle
           if ( MeasuredDepth>TD_WellGeo(kk)%TopDepth ) then
               if ( MeasuredDepth>TD_WellGeo(kk)%DownDepth ) then
                   dl = TD_WellGeo(kk)%DownDepth-nn                              ![ft]
                   nn = TD_WellGeo(kk)%DownDepth
                   if ( TD_WellGeo(kk)%HoleType==0 ) then
                       EndAngle      = StartAngle
                       VerticalDepth = mm+(dl*cos(TD_WellGeo(kk)%StartAngle))    ![ft]
                       !Angle(ii)    = EndAngle
                   else if ( TD_WellGeo(kk)%HoleType==1 ) then
                       EndAngle      = StartAngle+(dl/TD_WellGeo(kk)%RCurvature) !?????
                       VerticalDepth = mm+(TD_WellGeo(kk)%RCurvature*sin(abs(EndAngle)-abs(StartAngle))*cos(abs(StartAngle)))-(TD_WellGeo(kk)%RCurvature*(1.-cos(abs(EndAngle)-abs(StartAngle)))*sin(abs(StartAngle)))
                       !Angle(ii)    = EndAngle
                   else if ( TD_WellGeo(kk)%HoleType==2 ) then
                       EndAngle      = StartAngle-(dl/TD_WellGeo(kk)%RCurvature) !?????
                       VerticalDepth = mm+(TD_WellGeo(kk)%RCurvature*sin(abs(abs(EndAngle)-abs(StartAngle)))*cos(abs(StartAngle)))+(TD_WellGeo(kk)%RCurvature*(1.-cos(abs(abs(EndAngle)-abs(StartAngle))))*sin(abs(StartAngle)))
                       !Angle(ii)    = EndAngle
                   end if
                   mm = VerticalDepth
               else
                   dl = MeasuredDepth-nn
                   nn = MeasuredDepth
                   if ( TD_WellGeo(kk)%HoleType==0 ) then
                       EndAngle      = StartAngle
                       VerticalDepth = mm+(dl*cos(TD_WellGeo(kk)%StartAngle))
                       !Angle(ii)    = EndAngle
                   else if ( TD_WellGeo(kk)%HoleType==1 ) then
                       EndAngle      = StartAngle+(dl/TD_WellGeo(kk)%RCurvature) !?????
                       VerticalDepth = mm+(TD_WellGeo(kk)%RCurvature*sin(abs(EndAngle)-abs(StartAngle))*cos(abs(StartAngle)))-(TD_WellGeo(kk)%RCurvature*(1.-cos(abs(EndAngle)-abs(StartAngle)))*sin(abs(StartAngle)))
                       !Angle(ii)    = EndAngle
                   else if ( TD_WellGeo(kk)%HoleType==2 ) then
                       EndAngle      = StartAngle-(dl/TD_WellGeo(kk)%RCurvature) !?????
                       VerticalDepth = mm+(TD_WellGeo(kk)%RCurvature*sin(abs(abs(EndAngle)-abs(StartAngle)))*cos(abs(StartAngle)))+(TD_WellGeo(kk)%RCurvature*(1.-cos(abs(abs(EndAngle)-abs(StartAngle))))*sin(abs(StartAngle)))
                       !Angle(ii)    = EndAngle
                   end if
                   mm = VerticalDepth
                   exit
               end if
           end if
   end do
   
   
   
   
   
end subroutine