subroutine TD_ForceCalculation
    
   Use TD_DrillStemComponents
   Use TD_WellElements
   Use TD_WellGeometry
   Use TD_GeneralData
   

   implicit none
   
   Integer :: i
   Real(8) :: TD_SemiMudVisc
   
   
   
   
   if  (TD_DrillStemForceType == 1) then
       
       Do i = 1 , TD_DrillStemComponentsNumbs
           TD_SemiMudVisc = TD_DrillStems(i)%MudViscosity
           if (TD_DrillStems(i)%HoleType == 0) then
               Call TD_ForceUpS(i,TD_SemiMudVisc)
           else if (TD_DrillStems(i)%HoleType == 1) then
               Call TD_ForceUpB(i,TD_SemiMudVisc)
           else if (TD_DrillStems(i)%HoleType == 2) then
               Call TD_ForceUpD(i,TD_SemiMudVisc)
           end if
           Call TD_StrainCalculation(i)
           Call TD_TorqueCalculation(i)
       End Do
       
   else if (TD_DrillStemForceType == 2) then
       
       Do i = 1 , TD_DrillStemComponentsNumbs
           TD_SemiMudVisc = TD_DrillStems(i)%MudViscosity
           if (TD_DrillStems(i)%HoleType == 0) then
               Call TD_ForceUpSRot(i,TD_SemiMudVisc)
           else if (TD_DrillStems(i)%HoleType == 1) then
               Call TD_ForceUpBRot(i,TD_SemiMudVisc)
           else if (TD_DrillStems(i)%HoleType == 2) then
               Call TD_ForceUpDRot(i,TD_SemiMudVisc)
           end if
           Call TD_StrainCalculation(i)
           Call TD_TorqueCalculation(i)
       End Do
       
   else if (TD_DrillStemForceType == 3) then
       
       Do i = 1 , TD_DrillStemComponentsNumbs
           TD_SemiMudVisc = TD_DrillStems(i)%MudViscosity
           if (TD_DrillStems(i)%HoleType == 0) then
               Call TD_ForceDownS(i,TD_SemiMudVisc)
           else if (TD_DrillStems(i)%HoleType == 1) then
               Call TD_ForceDownB(i,TD_SemiMudVisc)
           else if (TD_DrillStems(i)%HoleType == 2) then
               Call TD_ForceDownD(i,TD_SemiMudVisc)
           end if
           Call TD_StrainCalculation(i)
           Call TD_TorqueCalculation(i)
       End Do
       
   else if (TD_DrillStemForceType == 4) then
       
       Do i = 1 , TD_DrillStemComponentsNumbs
           TD_SemiMudVisc = TD_DrillStems(i)%MudViscosity
           if (TD_DrillStems(i)%HoleType == 0) then
               Call TD_ForceDownSRot(i,TD_SemiMudVisc)
           else if (TD_DrillStems(i)%HoleType == 1) then
               Call TD_ForceDownBRot(i,TD_SemiMudVisc)
           else if (TD_DrillStems(i)%HoleType == 2) then
               Call TD_ForceDownDRot(i,TD_SemiMudVisc)
           end if
           Call TD_StrainCalculation(i)
           Call TD_TorqueCalculation(i)
       End Do
       
   else if (TD_DrillStemForceType == 5) then
       
       Do i = 1 , TD_DrillStemComponentsNumbs
           TD_SemiMudVisc = 0.0d0
           if (TD_DrillStems(i)%HoleType == 0) then
               Call TD_ForceUpS(i,TD_SemiMudVisc)
           else if (TD_DrillStems(i)%HoleType == 1) then
               Call TD_ForceUpB(i,TD_SemiMudVisc)
           else if (TD_DrillStems(i)%HoleType == 2) then
               Call TD_ForceUpD(i,TD_SemiMudVisc)
           end if
           Call TD_StrainCalculation(i)
           Call TD_TorqueCalculation(i)
       End Do
       
   end if
   
   
   
!-----------------------------------------------------------------------------------
!  
   !if (TD_DrillStemAxialVelocity>0.) then
   !    
   !     i = 1
   !     TD_DrillStems(i)%Force2 = TD_DrillStems(i)%Force2 - TD_DrillStems(i)%Drag
   !     TD_DrillStems(i)%Dl    = TD_DrillStems(i)%Force2 * TD_DrillStems(i)%Length / TD_DrillStems(i)%Area / TD_DrillStems(i)%ElasticModule
   !     TD_DrillStems(i)%DlTotal = TD_DrillStems(i)%Dl
   ! 
   !     do i = 2 , TD_DrillStemComponentsNumbs 
   !         TD_DrillStems(i)%Force2 = TD_DrillStems(i)%Force2 - TD_DrillStems(i)%Drag
   !         TD_DrillStems(i)%Dl    = TD_DrillStems(i)%Force2 * TD_DrillStems(i)%Length / TD_DrillStems(i)%Area / TD_DrillStems(i)%ElasticModule
   !         TD_DrillStems(i)%DlTotal = TD_DrillStems(i-1)%DlTotal + TD_DrillStems(i)%Dl
   !     end do
   !     !print*, 'i='     ,i
   !     !print*, 'TD_DrillStemComponentsNumbs='     ,TD_DrillStemComponentsNumbs
   !     
   !else if (TD_DrillStemAxialVelocity<0.) then
   !    i = 1
   !     TD_DrillStems(i)%Force2 = TD_DrillStems(i)%Force2 + TD_DrillStems(i)%Drag
   !     TD_DrillStems(i)%Dl    = TD_DrillStems(i)%Force2 * TD_DrillStems(i)%Length / TD_DrillStems(i)%Area / TD_DrillStems(i)%ElasticModule
   !     TD_DrillStems(i)%DlTotal = TD_DrillStems(i)%Dl
   ! 
   !     do i = 2 , TD_DrillStemComponentsNumbs 
   !         TD_DrillStems(i)%Force2 = TD_DrillStems(i)%Force2 + TD_DrillStems(i)%Drag
   !         TD_DrillStems(i)%Dl    = TD_DrillStems(i)%Force2 * TD_DrillStems(i)%Length / TD_DrillStems(i)%Area / TD_DrillStems(i)%ElasticModule
   !         TD_DrillStems(i)%DlTotal = TD_DrillStems(i-1)%DlTotal + TD_DrillStems(i)%Dl
   !     end do
   !end if
   
   
     TD_DlTotal = TD_DrillStems(TD_DrillStemComponentsNumbs)%DlTotal
    
    
    
    
!!=====> Modified Length of the Drill Stem
!    do i = 1 , TD_DrillStemComponentsNumbs 
!     TD_DrillStems(i)%Length = TD_DrillStems(i)%Length + TD_DrillStems(i)%Dl
!    end do
   
   
end subroutine