subroutine TD_HookLoadCalculation
    
   Use TD_DrillStemComponents
   Use TD_WellElements
   Use TD_WellGeometry
   Use TD_GeneralData
   Use TD_StringConnectionData
   Use Drawworks_VARIABLES, only: Drawworks
   Use CDataDisplayConsoleVariables
   Use CHoistingVariables
   Use CSlipsEnumVariables
   Use CBopStackVariables
   Use VARIABLES
   Use CUnityInputs
   
   
   implicit none
   
   Integer :: i , kk
   Real(8) :: TD_eConst=0.98d0 , TD_SumWeight
   
   
   
   
!====================================================
!             Torque & Hook Load Calculation
!====================================================

!=========> HookLoad
  TD_HookLoad = TD_DrillStems(TD_DrillStemComponentsNumbs)%Force2     ! [lb]
  !print* , 'TD_HookLoad1=' , TD_HookLoad
  
  if ( Drawworks%motion==1 ) then
      if ( PipeRam1_Situation_forTD==1 ) then  !Upper Ram
          TD_HookLoad = TD_HookLoad+RamStringDrag
      end if
      if ( PipeRam2_Situation_forTD==1 ) then  !Lower Ram
          TD_HookLoad = TD_HookLoad+RamStringDrag
      end if
      if ( ShearBop_Situation_forTD==1 ) then  !Blind Ram
          TD_HookLoad = TD_HookLoad+RamStringDrag   !????????????????????
      end if
      if ( Annular_Situation_forTD==1 ) then   !Annular Preventer
          TD_HookLoad = TD_HookLoad+(p_annular*AnnularStringDrag)
      end if
  else if ( Drawworks%motion==-1 ) then
      if ( PipeRam1_Situation_forTD==1 ) then  !Upper Ram
          TD_HookLoad = TD_HookLoad-RamStringDrag
      end if
      if ( PipeRam2_Situation_forTD==1 ) then  !Lower Ram
          TD_HookLoad = TD_HookLoad-RamStringDrag
      end if
      if ( ShearBop_Situation_forTD==1 ) then  !Blind Ram
          TD_HookLoad = TD_HookLoad-RamStringDrag    !????????????????????
      end if
      if ( Annular_Situation_forTD==1 ) then   !Annular Preventer
          TD_HookLoad = TD_HookLoad-(p_annular*AnnularStringDrag)
      end if
  end if
  
  !print* , 'TD_HookLoad2=' , TD_HookLoad
  
  
  
  
  
  !if ( UpperRamClose_withPossibility==1 ) then
  !    if ( Drawworks%motion==1 ) then
  !        TD_HookLoad = TD_HookLoad+RamStringDrag
  !    else if ( Drawworks%motion==-1 ) then
  !        TD_HookLoad = TD_HookLoad-RamStringDrag
  !    end if
  !end if
  !if ( LowerRamClose_withPossibility==1 ) then
  !    if ( Drawworks%motion==1 ) then
  !        TD_HookLoad = TD_HookLoad+RamStringDrag
  !    else if ( Drawworks%motion==-1 ) then
  !        TD_HookLoad = TD_HookLoad-RamStringDrag
  !    end if
  !end if
  !if ( BlindRamClose_withPossibility==1 ) then
  !    if ( Drawworks%motion==1 ) then
  !        TD_HookLoad = TD_HookLoad+RamStringDrag
  !    else if ( Drawworks%motion==-1 ) then
  !        TD_HookLoad = TD_HookLoad-RamStringDrag
  !    end if
  !end if
  !if ( AnnularPreventerClose_withPossibility==1 ) then
  !    if ( Drawworks%motion==1 ) then
  !        TD_HookLoad = TD_HookLoad+AnnularStringDrag
  !    else if ( Drawworks%motion==-1 ) then
  !        TD_HookLoad = TD_HookLoad-AnnularStringDrag
  !    end if
  !end if
  
  
  
  
  
  
  
  
!=========> Torque
  TD_StringTorque = TD_TotalTorque             ![lb.ft]     ??????????
  !print* , 'TD_StringTorque=' , TD_StringTorque
  
  
  
  
  
!====================================================
!             Weight Indicator Calculation
!====================================================
   
   kk = 0
   Do i = TD_DrillStemComponentsNumbs , 1 , -1
           if (TD_DrillStems(i)%ComponentType==3) then
               kk = i
               exit
           end if
   End Do
  
   
   
   
   
   if ( TD_KellyDriveTypeMode==0 ) then
       
       if ( TD_StringConnectionMode  == 1 ) then
           if ( Get_Slips() == SLIPS_SET_END ) then
               TD_SumWeight = TD_WeightTB+TD_KellyWeight
           else
               TD_SumWeight = TD_HookLoad+TD_WeightTB+TD_KellyWeight    ! TD_HookLoad = String Weight
           end if
       
       else if ( TD_StringConnectionMode  == 2 ) then
           if ( Get_JointConnectionPossible() ) then
               TD_SumWeight = TD_WeightTB
           else
               TD_SumWeight = TD_WeightTB+TD_KellyWeight
           end if
       
       else if ( TD_StringConnectionMode  == 3 ) then
           if ( Get_JointConnectionPossible() ) then
               TD_SumWeight = TD_WeightTB
           else
               TD_SumWeight = TD_WeightTB+TD_KellyWeight+TD_DrillStems(kk)%Weight
           end if
           
       end if
       
   else if ( TD_KellyDriveTypeMode==1 ) then
       
        if ( TD_StringConnectionMode  == 4 ) then
           if ( Get_Slips() == SLIPS_SET_END ) then
               TD_SumWeight = TD_WeightTB
           else
               TD_SumWeight = TD_HookLoad+TD_WeightTB
           end if
       
        else if ( TD_StringConnectionMode  == 5 ) then
           TD_SumWeight = TD_WeightTB
       
        else if ( TD_StringConnectionMode  == 6 ) then
           if ( Get_JointConnectionPossible() ) then
               TD_SumWeight = TD_WeightTB
           else
               TD_SumWeight = TD_WeightTB+(3.d0*TD_DrillStems(kk)%Weight)
           end if
       
        else if ( TD_StringConnectionMode  == 7 ) then
           if ( Get_JointConnectionPossible() ) then
               TD_SumWeight = TD_WeightTB
           else
               TD_SumWeight = TD_WeightTB+TD_DrillStems(kk)%Weight
           end if
       
        else if ( TD_StringConnectionMode  == 8 ) then
           TD_SumWeight = TD_WeightTB
           
        else if ( TD_StringConnectionMode  == 18 ) then
           TD_SumWeight = TD_WeightTB
           
        else if ( TD_StringConnectionMode  == 19 ) then
           TD_SumWeight = TD_WeightTB
           
        end if
        
   else if ( TD_KellyDriveTypeMode==2 ) then
       
        if ( TD_StringConnectionMode  == 9 ) then
           if ( Get_Slips() == SLIPS_SET_END ) then
               TD_SumWeight = TD_WeightTD
           else
               TD_SumWeight = TD_HookLoad+TD_WeightTD
           end if
       
        else if ( TD_StringConnectionMode  == 10 ) then
           if ( Get_Slips() == SLIPS_SET_END ) then
               TD_SumWeight = TD_WeightTD
           else
               TD_SumWeight = TD_HookLoad+TD_WeightTD
           end if
       
        else if ( TD_StringConnectionMode  == 11 ) then
           TD_SumWeight = TD_WeightTD
       
        else if ( TD_StringConnectionMode  == 12 ) then
           if ( Get_Slips() == SLIPS_SET_END ) then
               TD_SumWeight = TD_WeightTD
           else
               TD_SumWeight = TD_HookLoad+TD_WeightTD
           end if
       
        else if ( TD_StringConnectionMode  == 13 ) then
           TD_SumWeight = TD_WeightTD
       
        else if ( TD_StringConnectionMode  == 14 ) then
           TD_SumWeight = TD_WeightTD+(3.d0*TD_DrillStems(kk)%Weight)
       
        else if ( TD_StringConnectionMode  == 15 ) then
           TD_SumWeight = TD_WeightTD+(TD_DrillStems(kk)%Weight)
       
        else if ( TD_StringConnectionMode  == 16 ) then
           TD_SumWeight = TD_WeightTD
       
        else if ( TD_StringConnectionMode  == 17 ) then
           TD_SumWeight = TD_WeightTD
           
        end if
    
    end if
    
    
    
    !print* , 'TD_HookLoad3=' , TD_HookLoad
    
    
    
    
  !if ( DriveType==1 ) then          !==> Kelly_DriveType
  !    
  !    if ( TD_DrillStemForceType==1 .or. TD_DrillStemForceType==2 ) then
  !        TD_WeightIndicator = ( sngl(TD_NumOfCables)*(TD_eConst-1.d0)*(TD_SumWeight) )&
  !                              /( TD_eConst*(1.d0-(1.d0/(TD_eConst**TD_NumOfCables))) )
  !    else if ( TD_DrillStemForceType==3 .or. TD_DrillStemForceType==4 ) then
  !        TD_WeightIndicator = ( sngl(TD_NumOfCables)*(1.d0-TD_eConst)*(TD_SumWeight) )&
  !                              /( 1.d0-(TD_eConst**TD_NumOfCables) )
  !    else if ( TD_DrillStemForceType==5 ) then
          TD_WeightIndicator = TD_SumWeight
  !    end if
  !    
  !    
  !else if ( DriveType==0 ) then     !==> TopDrive_DriveType   ??????????????
  !    
  !    if ( TD_DrillStemForceType==1 .or. TD_DrillStemForceType==2 ) then
  !        TD_WeightIndicator = ( sngl(TD_NumOfCables)*(TD_eConst-1.d0)*(TD_SumWeight) )&
  !                              /( TD_eConst*(1.d0-(1.d0/(TD_eConst**TD_NumOfCables))) )
  !    else if ( TD_DrillStemForceType==3 .or. TD_DrillStemForceType==4 ) then
  !        TD_WeightIndicator = ( sngl(TD_NumOfCables)*(1.d0-TD_eConst)*(TD_SumWeight) )&
  !                              /( 1.d0-(TD_eConst**TD_NumOfCables) )
  !    else if ( TD_DrillStemForceType==5 ) then
  !        TD_WeightIndicator = TD_SumWeight
  !    end if
  !    
  !!else
  !!TD_WeightIndicator = 0.  !?????????????????
  !
  !end if
  

  
  
  
 TD_DrawworksLoadInput = TD_WeightIndicator/(sngl(TD_NumOfCables))                 ! [lb]
  !print* , 'TD_HookLoad4=' , TD_HookLoad
 !HookLoadPointer = TD_WeightIndicator/1.0d3                                       ! [klb]
 call Set_HookLoad ((1-TD_WeightIndicatorMalf)*AINT(TD_WeightIndicator/1.0d3))     ! [klb]
  
  
 
 
 
  
end subroutine