subroutine TD_ViscousDragForce
    
   Use TD_DrillStemComponents
   Use TD_WellElements
   Use TD_WellGeometry
   Use TD_GeneralData
   

   implicit none
   
   Integer :: i
   real(8) :: TDden, TDpreup , TDpredown , TDtem , TDmdup , TDmddown
   Real(8) :: TD_ThetaCoef1 , TD_ThetaCoef2 , TD_NCoef , TD_KCoef
   Real(8) :: TD_DragSum
   
   
   
   
   
   Do i = 1 , TD_DrillStemComponentsNumbs
       
       if ( TD_DrillStems(i)%MudDensityOut==0.d0 .or. TD_DrillStems(i)%MudDensityIn==0.d0 ) then
           TD_DrillStems(i)%Drag = 0.d0
           cycle
       end if
       TDmdup   = TD_DrillStems(i)%TopDepthIni
       Call AnnulusPropertyCalculator ( INT(TDmdup) , TDden , TDpreup , TDtem )
       TDmddown = TD_DrillStems(i)%DownDepthIni
       Call AnnulusPropertyCalculator ( INT(TDmddown) , TDden , TDpredown , TDtem )
       TD_DrillStems(i)%Drag = abs(TDpredown-TDpreup)*(pi*TD_DrillStems(i)%Length*12.d0*TD_DrillStems(i)%Od*12.d0)   ![psi]*[inch^2]=[lb]  ?????
       
       TD_DrillStems(i)%Drag = 0.0d0    !?????????????????????
       
   End Do
   

   
   
   
   
   !Do i = 1 , TD_DrillStemComponentsNumbs
   !    
   !    
   !    if ( TD_DrillStems(i)%MudDensityOut==0.d0 .or. TD_DrillStems(i)%MudDensityIn==0.d0 ) then
   !        TD_DrillStems(i)%Drag = 0.d0
   !        cycle
   !    end if
   !    
   !    !------------------------------------------------------------------------------------
   !    TD_DrillStems(i)%Od            = TD_DrillStems(i)%Od*12.d0                      ! [inch]
   !    TD_DrillStems(i)%HoleDiameter  = TD_DrillStems(i)%HoleDiameter*12.d0            ! [inch]
   !    TD_DrillStems(i)%MudDensityOut = TD_DrillStems(i)%MudDensityOut/7.48051948d0    ! [ppg]
   !    !------------------------------------------------------------------------------------
   !    
   !    
   !    TD_ThetaCoef1 = TD_DrillStems(i)%MudYieldPoint+TD_DrillStems(i)%MudPlasticVis
   !    TD_ThetaCoef2 = (2.0d0*TD_DrillStems(i)%MudPlasticVis)+TD_DrillStems(i)%MudYieldPoint
   !    TD_NCoef      = 3.32d0*log10(TD_ThetaCoef2/TD_ThetaCoef1)
   !    TD_KCoef      = (TD_ThetaCoef1)/(511.d0*TD_NCoef)
   !    
   !    
   !    
   !    If (TD_DrillStems(i)%TopDepth>0.d0) then
   !     
   !      TD_DrillStems(i)%PipeVelocity = abs(TD_DrillStemAxialVelocity)
   !
   !      TD_DrillStems(i)%DiamRatio = (TD_DrillStems(i)%Od)/TD_DrillStems(i)%HoleDiameter
   !      
   !
   !      TD_DrillStems(i)%MudClingingConst = ((TD_DrillStems(i)%DiamRatio**2) * (1.0d0 - (2.0d0*log(TD_DrillStems(i)%DiamRatio))) - 1.0d0) &
   !                                         / (2.0d0*(1.0d0-(TD_DrillStems(i)%DiamRatio**2))*log(TD_DrillStems(i)%DiamRatio))
   ! 
   !      TD_DrillStems(i)%AveEffVelocity = TD_DrillStems(i)%PipeVelocity * ( ((TD_DrillStems(i)%DiamRatio**2)/(1.0d0-(TD_DrillStems(i)%DiamRatio**2))) &
   !                                         + TD_DrillStems(i)%MudClingingConst)
   ! 
   !      TD_DrillStems(i)%ReNumber =  (926.4*(TD_DrillStems(i)%MudDensityOut * TD_DrillStems(i)%AveEffVelocity * (TD_DrillStems(i)%HoleDiameter - TD_DrillStems(i)%Od))) &
   !                                   / TD_DrillStems(i)%MudPlasticVis     !Bingham-plastic drilling fluid
   !      !TD_DrillStems(i)%ReNumber =  10.9d4*( TD_DrillStems(i)%MudDensityOut*(TD_DrillStems(i)%AveEffVelocity**(2-TD_NCoef))/TD_DrillStems(i)%MudPlasticVis ) &
   !      !                           *( (((TD_DrillStems(i)%HoleDiameter - TD_DrillStems(i)%Od)/48.)*(TD_NCoef/((2.*TD_NCoef)+1.)))**TD_NCoef )   !Power-law fluid
   !
   !      if ( TD_DrillStems(i)%ReNumber .le. 2.1d3 ) then                       !Bingham-plastic drilling fluid
   !      !if ( TD_DrillStems(i)%ReNumber .le. (3479.-(1370.*TD_NCoef)) ) then     !Power-law fluid
   ! 
   !           TD_DrillStems(i)%FricFactor = 1.60d1/TD_DrillStems(i)%ReNumber
   !           
   !           !TD_DrillStems(i)%Dp_Dl      = ( TD_KCoef/(14.4d4*(TD_DrillStems(i)%HoleDiameter - TD_DrillStems(i)%Od)) )&
   !           !                             *( ((48./(TD_DrillStems(i)%HoleDiameter - TD_DrillStems(i)%Od))*(((2.*TD_NCoef)+1.)/TD_NCoef))**TD_NCoef )    !Power-law fluid
   !           TD_DrillStems(i)%Dp_Dl = (TD_DrillStems(i)%FricFactor * (TD_DrillStems(i)%AveEffVelocity**2) * TD_DrillStems(i)%MudDensityOut) &
   !                                     / (25.78d0*(TD_DrillStems(i)%HoleDiameter - TD_DrillStems(i)%Od))   !Bingham-plastic drilling fluid
   ! 
   !      else   !Bingham-plastic drilling fluid
   !      !else if ( TD_DrillStems(i)%ReNumber .gt. (4270.-(1370.*TD_NCoef)) ) then    !Power-law fluid
   !      
   !           TD_DrillStems(i)%MudClingingConst = (sqrt(( (TD_DrillStems(i)%DiamRatio**4) + TD_DrillStems(i)%DiamRatio ) &
   !                                             /(1.0d0 + TD_DrillStems(i)%DiamRatio )) - (TD_DrillStems(i)%DiamRatio**2)) &
   !                                             /(1.0d0- (TD_DrillStems(i)%DiamRatio**2))
   ! 
   !           TD_DrillStems(i)%AveEffVelocity = TD_DrillStems(i)%PipeVelocity * ( ((TD_DrillStems(i)%DiamRatio**2)/(1.0d0-(TD_DrillStems(i)%DiamRatio**2))) &
   !                                             + TD_DrillStems(i)%MudClingingConst)
   ! 
   !           TD_DrillStems(i)%ReNumber =  (926.4d0*(TD_DrillStems(i)%MudDensityOut * TD_DrillStems(i)%AveEffVelocity * (TD_DrillStems(i)%HoleDiameter - TD_DrillStems(i)%Od))) &
   !                                       / TD_DrillStems(i)%MudPlasticVis     !Bingham-plastic drilling fluid
   !           !TD_DrillStems(i)%ReNumber =  10.9d4*( TD_DrillStems(i)%MudDensityOut*(TD_DrillStems(i)%AveEffVelocity**(2-TD_NCoef))/TD_DrillStems(i)%MudPlasticVis ) &
   !           !                          *( (((TD_DrillStems(i)%HoleDiameter - TD_DrillStems(i)%Od)/48.)*(TD_NCoef/((2.*TD_NCoef)+1.)))**TD_NCoef )   !Power-law fluid
   ! 
   !           TD_DrillStems(i)%FricFactor = 0.0791d0/(TD_DrillStems(i)%ReNumber**0.25d0)
   !           
   !           TD_DrillStems(i)%Dp_Dl = (TD_DrillStems(i)%FricFactor * (TD_DrillStems(i)%AveEffVelocity**2) * TD_DrillStems(i)%MudDensityOut) &
   !                                     / (25.78d0*(TD_DrillStems(i)%HoleDiameter - TD_DrillStems(i)%Od))   !Bingham-plastic drilling fluid
   !           !TD_DrillStems(i)%Dp_Dl = (TD_DrillStems(i)%FricFactor * (TD_DrillStems(i)%AveEffVelocity**2) * TD_DrillStems(i)%MudDensityOut) &
   !           !                          / (21.1*(TD_DrillStems(i)%HoleDiameter - TD_DrillStems(i)%Od))    !Power-law fluid
   !
   !      end if
   !    
   !
   !      TD_DrillStems(i)%Drag =  ( (pi/4.0d0)*TD_DrillStems(i)%Dp_Dl*TD_DrillStems(i)%Length*(TD_DrillStems(i)%Od**2)/10.d0 )   ! drag/10 = because of the value of drag force
   !      
   !    Else
   !        TD_DrillStems(i)%Drag =  0.0d0
   !        
   !    End if
   !    
   !    
   !    !------------------------------------------------------------------------------------
   !    TD_DrillStems(i)%Od            = TD_DrillStems(i)%Od/12.d0                     ! [ft]
   !    TD_DrillStems(i)%HoleDiameter  = TD_DrillStems(i)%HoleDiameter/12.d0           ! [ft]
   !    TD_DrillStems(i)%MudDensityOut = TD_DrillStems(i)%MudDensityOut*7.48051948d0   ! [lb/ft3]
   !    !------------------------------------------------------------------------------------
   !    
   ! 
   !end do
   
   if (TD_DrillStems(1)%ComponentType==0) then
       TD_DrillStems(1)%Drag = 50.d0*TD_DrillStems(1)%Od       !Od[ft]   , Drag[lb]?????
       if ( TD_DrillStems(1)%MudDensityOut==0.d0 .or. TD_DrillStems(1)%MudDensityIn==0.d0 ) then
           TD_DrillStems(1)%Drag = 0.d0
       end if
   end if
   
   !!TD_DragSum = 0.
   !!Do i = 1 , TD_DrillStemComponentsNumbs
   !!    TD_DragSum = TD_DragSum+TD_DrillStems(i)%Drag
   !!end do
   
        
        ! print*, 'TD_NCoef='   , TD_NCoef
        ! print*, 'TD_KCoef='   , TD_KCoef
        !
        ! print*, 'TD_DrillStems(1)%DiamRatio='   , TD_DrillStems(1)%DiamRatio
        ! print*, 'TD_DrillStems(1)%Od='   , TD_DrillStems(1)%Od
        ! print*, 'TD_DrillStems(1)%HoleDiameter='   , TD_DrillStems(1)%HoleDiameter
        ! !
        ! print*, 'TD_DrillStems(1)%MudClingingConst='   , TD_DrillStems(1)%MudClingingConst
        ! !
        ! print*, 'TD_DrillStems(1)%AveEffVelocity='   , TD_DrillStems(1)%AveEffVelocity
        ! !
        ! !print*, 'TD_DrillStems(1)%MudPlasticVis=' ,  TD_DrillStems(1)%MudPlasticVis
        ! print*, 'TD_DrillStems(1)%MudDensityOut=' ,  TD_DrillStems(1)%MudDensityOut
        ! print*, 'TD_DrillStems(1)%ReNumber='   , TD_DrillStems(1)%ReNumber
        ! !
        ! print*, 'TD_DrillStems(1)%FricFactor='   , TD_DrillStems(1)%FricFactor
        ! print*, 'TD_DrillStems(1)%Dp_Dl='   , TD_DrillStems(1)%Dp_Dl
        ! print*, 'TD_DrillStems(1)%Drag='   , TD_DrillStems(1)%Drag
        ! print*, 'TD_DrillStems(2)%Drag='   , TD_DrillStems(2)%Drag
        ! print*, 'TD_DrillStems(3)%Drag='   , TD_DrillStems(3)%Drag
        ! print*, 'TD_DragSum='   , TD_DragSum
        ! print*, 'TD_DrillStems(330)%Drag='   , TD_DrillStems(330)%Drag
        ! print*, 'TD_DrillStems(331)%Drag='   , TD_DrillStems(331)%Drag
        ! print*, 'TD_DrillStems(333)%Drag='   , TD_DrillStems(333)%Drag
   
   
   
   
   
   
end subroutine