subroutine TD_StartUp
    
    Use CCasingLinerChokeVariables
    Use CStringConfigurationVariables
    Use CSimulationVariables
    Use COperationConditionEnumVariables
    Use CHoistingVariables
    Use CPathGenerationVariables
    Use TD_DrillStemComponents
    Use TD_WellElements
    Use TD_WellGeometry
    Use TD_GeneralData
    Use TD_StringConnectionData
    Use Drawworks_VARIABLES!, only: Drawworks
    Use sROP_Variables
    Use sROP_Other_Variables
   
    
   implicit none
   
   
!!====================================================
!!                Allocate Modules
!!====================================================
!   !=====> Set WellGeo Dimension
!   TD_WellIntervalsCount = PathGenerationCount + 1    ! +1 is belong to ROP hole
!   Allocate (TD_WellGeo(TD_WellIntervalsCount))
!   
!   !=====> Set WellGeo Dimension
   
   
   !=====> Set ROP StartUp
   Bit_Wearing         = 0.d0
   Rate_of_Penetration = 0.d0
   Bearing_Wear        = 0.d0
   FormationNumber     = 0
   Old_ROPDepth        = PathGenerations(PathGenerationCount)%MeasuredDepth
   Old_ROPValue        = 0.d0
   Set_ROPGauge        = 0.d0
   
   
   
   !=====> Set BOP StartUp
   TD_BOPCondition = 0
   TD_BOPThickness = (0.13477d0/2.d0)*3.28d0 ![m]*3.28=[ft]  , Total Thickness (RAM)= 134.77mm
   TD_AnnularFillingFinal = 0.d0
   
   
   DW_TDHookHeight = 75.d0                ![ft]
   Drawworks%Hook_Height_ini   = 75.d0    ![ft]
   Drawworks%Hook_Height_final = 75.d0    ![ft]
   
  
  
   !=====> String Connection Mode
   if ( Get_OperationCondition()==OPERATION_TRIP ) then
       TD_OldOperationCondition = 1
   else
       TD_OldOperationCondition = 0
   end if
   TD_KellyDriveTypeMode        = 0          !Kelly Mode
   TD_FluidStringConnectionMode = 0
   TD_ConnectionHeight       = 3.48d0     ![ft]
   TD_RigidConnectionHeight  = 3.48d0     ![ft]
   TD_GRigidConnectionHeight = 3.48d0     ![ft]
   TD_TopJointHeight         = 3.48d0     ![ft]
   !TD_TouchConnectionHeight =
   TD_StringVelocity         = 0.0d0
   TD_HookHeightOld          = 75.d0      ![ft]
   TD_HookHeight             = 75.d0      ![ft]
   TD_HookVelocity           = 0.0d0
   
   !=====> Element Specification
   TD_HookHeight           = DW_TDHookHeight               ! unit: [ft]
   TD_ElevatorConst        = 17.985                        ! [ft]   Elevator Length(14.84)   ????????????????? adad ha daghigh shavand
   TD_ElevatorECG          = 2.217                         ! [ft]
   TD_KellyConst           = 63.280d0                      ! [ft]   Kelly Length(61.74) + Safety Valve Length(1.54)
   TD_KellyElementConst    = 41.840d0                      ! [ft]   Kelly Element Length(40.3) + Safety Valve Length(1.54)
   TD_TDSLength            = 24.08d0  !??????????????????? ! [ft]   
   TD_TDSToolJointLength   = 0.77d0  !???????????????????  ! [ft]   
   TD_TDSElevatorLength    = 26.837d0   !??????            ! TDS with Elevator Length [ft]
   TD_TDSElevatorToolLength= 0.859d0  !??????????????????? ! [ft]
   TD_TDSElevatorECG       = 2.454                         ! [ft]
   TD_NumOfCables          = NumberOfLine
   TD_WeightTB             = TravelingBlockWeight          ! [lb]
   TD_WeightTD             = TopDriveWeight                ! [lb]
   TD_KellyWeight          = KellyWeight                   ! [lb]
   TD_SafetyValveLength    = 1.54d0                        ! [ft]
   TD_IBOPLength           = 1.54d0                        ! [ft]
   TD_KellyElementID       = 3.0d0/12.d0                   ! [ft]
   TD_KellyElementOD       = 5.90d0/12.d0                  ! [ft]
   TD_DrawworksLoadInput   = TravelingBlockWeight/NumberOfLine
   
   TD_IBOPNewAdd           = 0
   TD_IBOPOldAdd           = 0     !Remove
   TD_SafetyValveNewAdd    = 0
   TD_SafetyValveOldAdd    = 1     !Install
   TD_KellyNewAdd          = 0
   TD_KellyOldAdd          = 0
   TD_IBOPNewRemove        = 0
   TD_IBOPOldRemove        = 1     !Remove
   TD_SafetyValveNewRemove = 0
   TD_SafetyValveOldRemove = 0     !Install
   TD_KellyNewRemove       = 0
   TD_KellyOldRemove       = 1
   
   TD_KellyOldStatus1 = 0
   TD_KellyNewStatus1 = 0
   TD_KellyOldStatus2 = 1          ! Kelly Connected Nothing
   TD_KellyNewStatus2 = 1          ! Kelly Connected Nothing
   TD_KellyOldStatus3 = 0
   TD_KellyNewStatus3 = 0
   
   TD_KellyOldStatus4 = 0
   TD_KellyNewStatus4 = 0
   TD_KellyOldStatus5 = 0
   TD_KellyNewStatus5 = 0
   TD_KellyOldStatus6 = 0
   TD_KellyNewStatus6 = 0
   TD_KellyOldStatus7 = 0
   TD_KellyNewStatus7 = 0
   TD_KellyOldStatus8 = 0
   TD_KellyNewStatus8 = 0
   TD_KellyOldStatus18 = 0
   TD_KellyNewStatus18 = 0
   TD_KellyOldStatus19 = 0
   TD_KellyNewStatus19 = 0
   
   TD_KellyOldStatus9  = 0
   TD_KellyNewStatus9  = 0
   TD_KellyOldStatus10 = 0
   TD_KellyNewStatus10 = 0
   TD_KellyOldStatus11 = 0
   TD_KellyNewStatus11 = 0
   TD_KellyOldStatus12 = 0
   TD_KellyNewStatus12 = 0
   TD_KellyOldStatus13 = 1
   TD_KellyNewStatus13 = 1
   TD_KellyOldStatus14 = 0
   TD_KellyNewStatus14 = 0
   TD_KellyOldStatus15 = 0
   TD_KellyNewStatus15 = 0
   TD_KellyOldStatus16 = 0
   TD_KellyNewStatus16 = 0
   TD_KellyOldStatus17 = 0
   TD_KellyNewStatus17 = 0
   
  
   
   
   !=====> Problems
    TD_WeightIndicatorMalf = 0
   
   
end subroutine